<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

error_reporting(0);

ignore_user_abort(true);
set_magic_quotes_runtime(0);
ini_set('session.url_rewriter.tags', '');
ini_set('session.auto_start', 0);
ini_set('html_errors', 1);
ini_set('magic_quotes_runtime', false);
ini_set('track_errors', true);
ini_set('html_errors', false);
ini_set('allow_url_fopen', true);
if (!ini_get('safe_mode')) @set_time_limit(0);

define('PHP_SELF', (@$_SERVER['PHP_SELF']) ? $_SERVER['PHP_SELF'] : $_SERVER['DOCUMENT_URI']);
define('DIR_SELF', dirname(PHP_SELF) . ((substr(dirname(PHP_SELF),-1,1) != DIRECTORY_SEPARATOR) ? DIRECTORY_SEPARATOR : ''));

define('MYSELF', basename(PHP_SELF));
define('QUERY_STRING', '?' . $_SERVER['QUERY_STRING']);
define('REFERER', @$_SERVER['HTTP_REFERER']);
define('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
define('HOST', $_SERVER['HTTP_HOST']);
define('PORT', $_SERVER['SERVER_PORT']);
define('PROTOCOL', ((@$_SERVER["HTTPS"] == 'on') ? 'https' : 'http'));
define('SCRIPT_URI', $_SERVER['SCRIPT_URI']);

$admin_dir = (dirname(DIR_SELF) == DIRECTORY_SEPARATOR) ? '' : dirname(DIR_SELF);
define('DIR_WS_CATALOG', PROTOCOL . '://' . HOST . $admin_dir . DIRECTORY_SEPARATOR);
define('DIR_FS_CATALOG', realpath('../') . DIRECTORY_SEPARATOR);
define('DIR_WS_CATALOG_IMAGES', DIR_WS_CATALOG . 'images/');
define('DIR_FS_CATALOG_IMAGES', DIR_FS_CATALOG . 'images/');
define('DIR_FS_CATALOG_ELEMENTS', DIR_FS_CATALOG_IMAGES . 'interface_elements/');
define('DIR_FS_CATALOG_CONTENTS', DIR_FS_CATALOG . 'contents/');

define('DIR_WS_ADMIN', DIR_WS_CATALOG . 'admin/');
define('DIR_WS_IMAGES', 'images/');
define('DIR_WS_ICONS', DIR_WS_IMAGES . 'icons/');

define('UNIX_RETURN', "\n");
define('MAC_RETURN', "\r");
define('DOS_RETURN', "\r\n");
define('TAB', "\t");

return true;

// Internal Functions Start Here

function shop_redirect($url) {
	header('Location: ' . $url);
 	exit();
}

function shop_db_connect($server = DB_SERVER, $username = DB_SERVER_USERNAME, $password = DB_SERVER_PASSWORD, $database = DB_DATABASE) {
	$GLOBALS['db_link'] = @mysql_connect($server, $username, $password);
	return mysql_select_db($database, $GLOBALS['db_link']);
}

function shop_db_query($query) {
  return mysql_query($query, $GLOBALS['db_link']);
}

function shop_db_fetch_array($db_query) {
  return mysql_fetch_assoc($db_query);
}

function shop_db_num_rows($db_query) {
  return mysql_num_rows($db_query);
}

function shop_db_insert_id() {
  return mysql_insert_id($GLOBALS['db_link']);
}

function shop_db_data_seek($db_query, $row_number) {
	return mysql_data_seek($db_query, $row_number);
}

function shop_db_perform($table, $data, $action = 'insert', $parameters = '') {
	$table = DB_PREFIX . $table;
  if ($action == 'insert') {
		$query = 'replace into ' . $table . ' (';
		foreach ($data as $column => $value) $query .= $column . ',';
		$query = substr($query, 0, -1) . ') values (';
		foreach ($data as $column => $value) {
			switch ((string) $value) {
				case 'now()':
				case 'null':
					$query .= $value . ',';
					break;
				default:
					$query .= "'" . addslashes(stripslashes($value)) . "',";
					break;
			}
		}
		$query = substr($query, 0, -1) . ')';
  } elseif ($action == 'update') {
		$query = 'update ' . $table . ' set ';
		foreach ($data as $column => $value) {
			switch ((string) $value) {
				case 'now()':
				case 'null':
					$query .= $column . '=' . $value . ',';
					break;
				default:
					$query .= $column . "='" . addslashes(stripslashes($value)) . "',";
					break;
			}
		}
		$query = substr($query, 0, -1) . ' where ' . $parameters;
	}
  mysql_query($query, $GLOBALS['db_link']);
  
  if ($action == 'update') return mysql_affected_rows();
  else return mysql_insert_id();
}

function shop_load_configuration() {
  $configuration_query = mysql_query('select configuration_key as cfgKey, configuration_value as cfgValue from ' . DB_PREFIX . 'configuration', $GLOBALS['db_link']);
  while ($configuration = mysql_fetch_assoc($configuration_query)) @define($configuration['cfgKey'], $configuration['cfgValue']);
  return true;
}

function shop_get_languages_directory($code) {
  global $languages_id;

  $language_query = shop_db_query("select languages_id from " . DB_PREFIX . "languages where code = '$code'");
  if (shop_db_num_rows($language_query)) {
	$language = shop_db_fetch_array($language_query);
	$languages_id = $language['languages_id'];
	return $language['directory'];
  } else {
	return false;
  }
}

function shop_get_language($id) {
  $languages_query = shop_db_query("select languages_id as id, name, code, image from " . DB_PREFIX . "languages where languages_id = '$id' order by name");
  $languages_data = shop_db_fetch_array($languages_query);
  $languages_data['meta'] = 'utf-8';
  return $languages_data;
}

function shop_customers_name($customers_id) {
  $customers = shop_db_query("select customers_firstname, customers_lastname from " . DB_PREFIX . "customers where customers_id = '$customers_id'");
  $customers_values = shop_db_fetch_array($customers);

  return $customers_values['customers_firstname'] . ' ' . $customers_values['customers_lastname'];
}

function shop_get_path($current_category_id = '') {
  global $cPath_array;

  if ($current_category_id == '') {
	$cPath_new = implode('_', $cPath_array);
  } else {
	if (sizeof($cPath_array) == 0) {
	  $cPath_new = $current_category_id;
	} else {
	  $cPath_new = '';
	  $last_category_query = shop_db_query("select parent_id from " . DB_PREFIX . "categories where categories_id = '" . $cPath_array[(sizeof($cPath_array)-1)] . "'");
	  $last_category = shop_db_fetch_array($last_category_query);
	  $current_category_query = shop_db_query("select parent_id from " . DB_PREFIX . "categories where categories_id = '$current_category_id'");
	  $current_category = shop_db_fetch_array($current_category_query);
	  if ($last_category['parent_id'] == $current_category['parent_id']) {
	    for ($i=0; $i<(sizeof($cPath_array)-1); $i++) {
	      $cPath_new .= '_' . $cPath_array[$i];
	    }
	  } else {
	    for ($i=0; $i<sizeof($cPath_array); $i++) {
	      $cPath_new .= '_' . $cPath_array[$i];
	    }
	  }
	  $cPath_new .= '_' . $current_category_id;
	  if (substr($cPath_new, 0, 1) == '_') {
	    $cPath_new = substr($cPath_new, 1);
	  }
	}
  }

  return 'cPath=' . $cPath_new;
}

function shop_get_all_get_params($exclude_array = array()) {
	$get_url = '';
	if (is_array($_GET)) {
		foreach ($_GET as $key => $value) {
			if ($value && !in_array($key, $exclude_array)) {
				$get_url .= $key . '=' . rawurlencode(($value)) . '&';
			}
		}
	}
	return $get_url;
}

function shop_date_long($raw_date = false) {
  if (!$raw_date) return false;
  return strftime('%A, %B %e, %Y %r', (is_int($raw_date) ? $raw_date : strtotime($raw_date)));
}

function shop_date_short($raw_date = false) {
  if (!$raw_date) return false;
  return strftime('%x', (is_int($raw_date) ? $raw_date : strtotime($raw_date)));
}

function shop_datetime_short($raw_date = false) {
  if (!$raw_date) return false;
  return strftime('%x %r', (is_int($raw_date) ? $raw_date : strtotime($raw_date)));
}

function shop_draw_date_input($name, $value, $default = false) {
	if ($value == '') $value = 'now';
  $date = date("Ymd",strtotime($value));
  $day = shop_draw_input_field($name . '[day]', (($date || !$default) ? substr($date, 6, 2) : date('d')), 'style="font-size:10px;" size="2" maxlength="2"');
  $month = shop_draw_input_field($name . '[month]', (($date || !$default) ? substr($date, 4, 2) : date('m')), 'style="font-size:10px;" size="2" maxlength="2"');
  $year = shop_draw_input_field($name . '[year]', (($date || !$default) ? substr($date, 0, 4) : date('Y')), 'style="font-size:10px;" size="4" maxlength="4"');
  return str_replace(array('/','12','30','70','19'), array('',$month, $day, $year, ''), strftime('%x', '31392000'));
}

function shop_get_category_tree($parent_id = 0, $exclude = 'none', $spacing = '', $category_tree_array = '', $include_top = true) {
  if (!is_array($category_tree_array)) $category_tree_array = array();
  if ($include_top == true) $category_tree_array[] = array('id' => '0', 'text' => '--Top--');

  global $languages_id;

  $categories_query = shop_db_query("select count(*) as count, c.categories_id, cd.categories_name, c.parent_id 
  									 from " . DB_PREFIX . "categories c left join " . DB_PREFIX . "categories cc on cc.parent_id = c.categories_id, " . DB_PREFIX . "categories_description cd where 
  									 c.categories_id = cd.categories_id 
  									 and c.parent_id = '$parent_id' 
  									 and cd.language_id = '$languages_id' 
  									 group by cd.categories_id 
  									 order by c.sort_order");

  while ($categories = shop_db_fetch_array($categories_query)) {
	if ($categories['categories_id'] != $exclude) {
	  $category_tree_array[] = array('id' => $categories['categories_id'], 'text' => $spacing . $categories['categories_name']);
	  if ($categories['count'] > 1) {
	    $child = shop_get_category_tree($categories['categories_id'], $exclude, $spacing . '&nbsp;&nbsp;&nbsp;', array(), false);
	    $category_tree_array = array_merge($category_tree_array, $child);
	  }
	}
  }

  return $category_tree_array;
}

function shop_draw_products_pull_down($name, $parameters = '', $exclude = array()) {
  global $currencies, $languages_id;

  $select_string = '<select name="' . $name . '"';
  if ($parameters) $select_string .= ' ' . $parameters;
  $select_string .= '>';
  $products_query = shop_db_query("select p.products_id, pd.products_name, p.products_price from " . DB_PREFIX . "products p, " . DB_PREFIX . "products_description pd where p.products_id = pd.products_id and pd.language_id = '$languages_id' order by products_name");
  while ($products = shop_db_fetch_array($products_query)) {
	if (!in_array($products['products_id'], $exclude)) {
	  $select_string .= '<option value="' . $products['products_id'] . '">' . $products['products_name'] . ' (' . $currencies->format($products['products_price']) . ')</option>';
	}
  }
  $select_string .= '</select>';

  return $select_string;
}

function shop_options_name($options_id, $language_id = null) {
  if (!$language_id) {
	global $languages_id;
  } else {
	$languages_id = $language_id;
  }
  $options = shop_db_query("select products_options_name from " . DB_PREFIX . "products_options where products_options_id = '$options_id' and language_id = '$languages_id'");
  $options_values = shop_db_fetch_array($options);

  return $options_values['products_options_name'];
}

function shop_values_name($values_id, $language_id = null) {
  if (!$language_id) {
	global $languages_id;
  } else {
	$languages_id = $language_id;
  }
  $values = shop_db_query("select products_options_values_name from " . DB_PREFIX . "products_options_values where products_options_values_id = '$values_id' and language_id = '$languages_id'");
  $values_values = shop_db_fetch_array($values);

  return $values_values['products_options_values_name'];
}

function shop_coptions_name($options_id, $language_id = null) {
  if (!$language_id) {
	global $languages_id;
  } else {
	$languages_id = $language_id;
  }
  $options = shop_db_query("select customer_options_options_name from " . DB_PREFIX . "customer_options_options where customer_options_options_id = '$options_id' and language_id = '$languages_id'");
  $options_values = shop_db_fetch_array($options);

  return htmlentities($options_values['customer_options_options_name']);
}

function shop_info_image($image, $alt, $width = '', $height = '') {
  if ( ($image) && (file_exists(DIR_FS_CATALOG_IMAGES . $image)) ) {
	$image = shop_image(DIR_WS_CATALOG_IMAGES . $image, $alt, $width, $height);
  } else {
	$image = TEXT_IMAGE_NONEXISTENT;
  }

  return $image;
}

function shop_get_country_name($country_id) {
  $country_query = shop_db_query("select countries_name from " . DB_PREFIX . "countries where countries_id = '$country_id'");

  if (!shop_db_num_rows($country_query)) {
	return $country_id;
  } else {
	$country = shop_db_fetch_array($country_query);
	return $country['countries_name'];
  }
}

function shop_get_zone_name($zone_id) {
  $zone_query = shop_db_query("select zone_name from " . DB_PREFIX . "zones where zone_id = '$zone_id'");

  if (!shop_db_num_rows($zone_query)) {
	return $zone_id;
  } else {
	$zone = shop_db_fetch_array($zone_query);
	return $zone['zone_name'];
  }
}

function shop_browser_detect($component) {
  global $HTTP_USER_AGENT;

  return stristr($HTTP_USER_AGENT, $component);
}

function shop_tax_classes_pull_down($parameters, $selected = '') {
  $select_string = '<select ' . $parameters . '>';
  $classes_query = shop_db_query("select tax_class_id, tax_class_title from " . DB_PREFIX . "tax_class order by tax_class_title");
  while ($classes = shop_db_fetch_array($classes_query)) {
	$select_string .= '<option value="' . $classes['tax_class_id'] . '"';
	if ($selected == $classes['tax_class_id']) $select_string .= ' SELECTED';
	$select_string .= '>' . $classes['tax_class_title'] . '</option>';
  }
  $select_string .= '</select>';

  return $select_string;
}

function shop_geo_zones_pull_down($parameters, $selected = '') {
  $select_string = '<select ' . $parameters . '>';
  $zones_query = shop_db_query("select geo_zone_id, geo_zone_name from " . DB_PREFIX . "geo_zones order by geo_zone_name");
  while ($zones = shop_db_fetch_array($zones_query)) {
	$select_string .= '<option value="' . $zones['geo_zone_id'] . '"';
	if ($selected == $zones['geo_zone_id']) $select_string .= ' SELECTED';
	$select_string .= '>' . $zones['geo_zone_name'] . '</option>';
  }
  $select_string .= '</select>';

  return $select_string;
}

function shop_get_geo_zone_name($geo_zone_id) {
  $zones_query = shop_db_query("select geo_zone_name from " . DB_PREFIX . "geo_zones where geo_zone_id = '$geo_zone_id'");

  if (!shop_db_num_rows($zones_query)) {
	$geo_zone_name = $geo_zone_id;
  } else {
	$zones = shop_db_fetch_array($zones_query);
	$geo_zone_name = $zones['geo_zone_name'];
  }

  return $geo_zone_name;
}

function shop_address_format($address_format_id, $address, $html = true, $nbsp = '&nbsp;', $cr = '<br />') {
	$company = $address['company'];
	$name = (($address['firstname']) ? ($address['firstname'] . ' ' . $address['lastname']) : $address['name']);
	$street = $address['street_address'] . (($address['street_address_2']) ? $cr . $nbsp . $address['street_address_2'] : '');
	$city = $address['city'];
	$state = shop_get_zone_code($address['country'], $address['zone_id'], $address['state']);
	if (strlen($state)) {
		$statecomma = $address['state'] . ', ';
		$stcomma = $address['zone_id'] . ', ';
	}
	$postcode = $address['postcode'];
	$country = $address['country'];
	$address_formats = array(1 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city, $postcode$cr$nbsp$statecomma$country",
							 2 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city, $state $postcode$cr$nbsp$country",
							 3 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city$cr$nbsp$postcode - $statecomma$country",
							 4 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city ($postcode)$cr$nbsp$country",
							 5 => "$nbsp$name$cr$nbsp$street$cr$nbsp$postcode $city$cr$nbsp$country");	

	return ((($company) ? $nbsp . $company . $cr : '') . str_replace($cr . $cr, $cr, $address_formats[$address_format_id]));
}

function shop_payment_info($payment, $html = true, $nbsp = '&nbsp;', $cr = '<br />') {
	if ($payment['payment_method'] && strlen($payment['cc_type'])) {
		$payment_method = $payment['payment_method'];
		$cc_type = $payment['cc_type'];
		$cc_owner = '<b>Name on Card:</b> ' . $payment['cc_owner'];
		$cc_number = $payment['cc_number'];
		$cc_expires = substr($payment['cc_expires'],0,2) . '/' . substr($payment['cc_expires'],2);
		$cc_code = (($payment['cc_code']) ? "$cr$nbsp<b>CVV Code:</b> " . $payment['cc_code'] : '');
		$cc_approval = (($payment['cc_approval']) ? "$cr$nbsp<b>Approval Code:</b> " . $payment['cc_approval'] : '');
		
		return "$nbsp<b>$payment_method: $cc_type</b>$cr$nbsp$cc_owner$cr$nbsp$cc_number$nbsp<b>Exp:</b> $cc_expires$cc_code$cc_approval";
	} elseif ($payment['payment_method']) {
		return $nbsp . $payment['payment_method'] . (($payment['po_number']) ? ': ' . $payment['po_number'] : '');
	} else {
		return "$nbspNo payment selected";
	}
}
 
function shop_get_zone_code($country, $zone, $def_state) {

  $state_prov_query = shop_db_query("select zone_code from " . DB_PREFIX . "zones where zone_country_id = '$country' and zone_id = '$zone'");

  if (!shop_db_num_rows($state_prov_query)) {
	$state_prov_code = $def_state;
  }
  else {
	$state_prov_values = shop_db_fetch_array($state_prov_query);
	$state_prov_code = $state_prov_values['zone_code'];
  }
  
  return $state_prov_code;
}

function shop_get_languages() {
  $languages_array = array();
  $languages_query = shop_db_query("select languages_id as id, name, code, image from " . DB_PREFIX . "languages order by name");
  while ($languages = shop_db_fetch_array($languages_query)) $languages_array[] = $languages;

  return $languages_array;
}

function shop_get_category_name($category_id, $language_id) {
  $category_query = shop_db_query("select categories_name from " . DB_PREFIX . "categories_description where categories_id = '$category_id' and language_id = '$language_id'");
  $category = shop_db_fetch_array($category_query);

  return $category['categories_name'];
}

function shop_get_orders_status($orders_status_id, $language = '') {
  global $languages_id;
  if ($language == '') $language = $languages_id;
	$result = shop_db_query("select status_id as id, status_name as text from " . DB_PREFIX . "orders_status_values where language_id = '" . $language . "' order by sort_order asc");
	$orders_statuses = array();
	while ($row = shop_db_fetch_array($result)) {
		$orders_statuses[] = $row;
		$in_order[$row['id']] = $row;
	}
	
  if ($orders_status_id) {
  	return $in_order[$orders_status_id]['text'];
  } else {
  	return $orders_statuses;
  }
}

function shop_get_products_name($product_id, $language_id = 0) {
  global $languages_id;

  if ($language_id == 0) $language_id = $languages_id;
  $product_query = shop_db_query("select products_name from " . DB_PREFIX . "products_description where products_id = '$product_id' and language_id = '$language_id'");
  $product = shop_db_fetch_array($product_query);

  return $product['products_name'];
}

function shop_get_products_description($product_id, $language_id) {
  $product_query = shop_db_query("select products_description from " . DB_PREFIX . "products_description where products_id = '$product_id' and language_id = '$language_id'");
  $product = shop_db_fetch_array($product_query);

  return $product['products_description'];
}

function shop_get_meta_info($type, $product_id, $language_id) {
	if ($type == 'title' OR $type == 'keywords' OR $type == 'description') {
	  $product_query = shop_db_query("select meta_" . $type . " AS meta_info from " . DB_PREFIX . "products_description where products_id = '$product_id' and language_id = '$language_id'");
 		$product = shop_db_fetch_array($product_query);

  	return $product['meta_info'];
	}
}

function shop_get_artists_name($artist_id) {
  $artist_query = shop_db_query("select * from " . DB_PREFIX . "mshox_artists where artist_id = '$artist_id'");
  $artist = shop_db_fetch_array($artist_query);

  return $artist['artist'];
}

function shop_get_products_url($product_id, $language_id) {
  $product_query = shop_db_query("select products_url from " . DB_PREFIX . "products_description where products_id = '$product_id' and language_id = '$language_id'");
  $product = shop_db_fetch_array($product_query);

  return $product['products_url'];
}

function shop_get_manufacturer_url($manufacturer_id, $language_id) {
  $manufacturer_query = shop_db_query("select manufacturers_url from " . DB_PREFIX . "manufacturers where manufacturers_id = '$manufacturer_id'");
  $manufacturer = shop_db_fetch_array($manufacturer_query);

  return $manufacturer['manufacturers_url'];
}

function shop_get_manufacturer_name($manufacturer_id) {
  $manufacturer_query = shop_db_query("select manufacturers_name from " . DB_PREFIX . "manufacturers where manufacturers_id = '$manufacturer_id'");
  $manufacturer = shop_db_fetch_array($manufacturer_query);

  return $manufacturer['manufacturers_name'];
}

function shop_has_product_attributes($products_id) {
	$attributes_query = shop_db_query("select count(*) as count from " . DB_PREFIX . "products_attributes where products_id = '$products_id'");
	$attributes = shop_db_fetch_array($attributes_query);

	if ($attributes['count'] > 0) {
		return true;
	} else {
		return false;
	}
}

function shop_get_product_attribute_model($products_id,$products_attributes_id) {
	$attributes_query = shop_db_query("select options_model from " . DB_PREFIX . "products_attributes where products_id = '$products_id' and products_attributes_id = '$products_attributes_id'");
	$attributes = shop_db_fetch_array($attributes_query);
	return $attributes['options_model'];
}

function shop_has_customer_options($products_id) {
	$customer_options_query = shop_db_query("select count(*) as count from " . DB_PREFIX . "customer_options where products_id = '$products_id'");
	$customer_options = shop_db_fetch_array($customer_options_query);

	if ($customer_options['count'] > 0) {
		return true;
	} else {
		return false;
	}
}

function shop_get_artist_url($manufacturer_id) {
  $artist_query = shop_db_query("select artist_website from " . DB_PREFIX . "mshox_artists where artist_id = '$artist_id'");
  $artist = shop_db_fetch_array($artist_query);

  return $artist['artist_website'];
}

function shop_class_exists($class_name) {
  if (function_exists('class_exists')) {
	return class_exists($class_name);
  } else {
	return true;
  }
}

function shop_products_in_category_count($categories_id, $include_deactivated = false) {
  $products_count = 0;

  if ($include_deactivated) {
	$products_query = shop_db_query("select count(*) as total from " . DB_PREFIX . "products p, " . DB_PREFIX . "products_to_categories p2c where p.products_id = p2c.products_id and p2c.categories_id = '$categories_id'");
  } else {
	$products_query = shop_db_query("select count(*) as total from " . DB_PREFIX . "products p, " . DB_PREFIX . "products_to_categories p2c where p.products_id = p2c.products_id and p.products_status = 1 and p2c.categories_id = '$categories_id'");
  }

  $products = shop_db_fetch_array($products_query);

  $products_count += $products['total'];

  $childs_query = shop_db_query("select categories_id from " . DB_PREFIX . "categories where parent_id = '$categories_id'");
  if (shop_db_num_rows($childs_query)) {
	while ($childs = shop_db_fetch_array($childs_query)) {
	  $products_count += shop_products_in_category_count($childs['categories_id'], $include_deactivated);
	}
  }

  return $products_count;
}

function shop_childs_in_category_count($categories_id) {
  $categories_count = 0;

  $categories_query = shop_db_query("select categories_id from " . DB_PREFIX . "categories where parent_id = '$categories_id'");
  while ($categories = shop_db_fetch_array($categories_query)) {
	$categories_count++;
	$categories_count += shop_childs_in_category_count($categories['categories_id']);
  }

  return $categories_count;
}

function shop_get_countries($default = '') {
  $countries_array = array();
  if ($default) $countries_array[] = $default;
  $countries_query = shop_db_query("select countries_id as id, countries_name as text from " . DB_PREFIX . "countries order by countries_name");
  while ($countries = shop_db_fetch_array($countries_query)) $countries_array[] = $countries;

  return $countries_array;
}

function shop_get_country_zones($country_id) {
  $zones_array = array();
  $zones_query = shop_db_query("select zone_id as id, zone_name as text from " . DB_PREFIX . "zones where zone_country_id = '$country_id' order by zone_name");
  while ($zones = shop_db_fetch_array($zones_query)) $zones_array[] = $zones;

  return $zones_array;
}

function shop_prepare_country_zones_pull_down($country_id = '') {
  $pre = '';
  if ( (!shop_browser_detect('MSIE')) && (shop_browser_detect('Mozilla/4')) ) {
	for ($i=0; $i<45; $i++) $pre .= '&nbsp;';
  }

  $zones = shop_get_country_zones($country_id);

  if (sizeof($zones) > 0) {
	$zones_select = array(array('id' => '', 'text' => PLEASE_SELECT));
	$zones = array_merge($zones_select, $zones);
  } else {
	$zones = array(array('id' => '', 'text' => TYPE_BELOW));
	if ( (!shop_browser_detect('MSIE')) && (shop_browser_detect('Mozilla/4')) ) {
	  for ($i=0; $i<9; $i++) {
	    $zones[] = array('id' => '', 'text' => $pre);
	  }
	}
  }

  return $zones;
}

function shop_set_product_status($products_id, $status) {
  if ($status == '1') {
	return shop_db_query("update " . DB_PREFIX . "products set products_status = '1', products_last_modified = now() where products_id = '$products_id'");
  } elseif ($status == '0') {
	return shop_db_query("update " . DB_PREFIX . "products set products_status = '0', products_last_modified = now() where products_id = '$products_id'");
  } else {
	return -1;
  }
}

function shop_set_category_status($categories_id, $status) {
  if ($status == '1') {
	return shop_db_query("update " . DB_PREFIX . "categories set categories_status = '1', last_modified = now() where categories_id = '$categories_id'");
  } elseif ($status == '0') {
	return shop_db_query("update " . DB_PREFIX . "categories set categories_status = '0', last_modified = now() where categories_id = '$categories_id'");
  } else {
	return -1;
  }
}

function shop_set_specials_status($specials_id, $status) {
  if ($status == '1') {
	return shop_db_query("update " . DB_PREFIX . "specials set status = '1', expires_date = NULL, date_status_change = NULL where specials_id = '$specials_id'");
  } elseif ($status == '0') {
	return shop_db_query("update " . DB_PREFIX . "specials set status = '0', date_status_change = now() where specials_id = '$specials_id'");
  } else {
	return -1;
  }
}

function shop_cfg_select_option($select_array, $key_value, $key = '', $title, $description) {
  if ($title) $string .= '<b>' . $title . '</b><br />';
  if ($description) $string .= $description . '<br />';
  for ($i=0; $i<sizeof($select_array); $i++) {
	$name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
	$string .= '<br /> &nbsp;  &nbsp; <input type="radio" name="' . $name . '" value="' . $select_array[$i] . '"';
	if ($key_value == $select_array[$i]) $string .= ' CHECKED';
	$string .= '> ' . ucwords($select_array[$i]);
  }

  return $string;
}

function shop_cfg_price_display($value, $key, $title, $description) {
  $currencies = new currencies;
  if ($title) $string .= '<b>' . $title . '</b><br />';
  if ($description) $string .= $description . '<br />';
  return $string . '<p> &nbsp;  &nbsp; ' . ((substr($value,-1) == '%') ? $value : $currencies->format($value));
}

function shop_cfg_textarea($value, $key, $title, $description) {
  if ($title) $string .= '<b>' . $title . '</b><br />';
  if ($description) $string .= $description . '<br />';
  return $string . shop_draw_textarea_field('configuration[' . $key . ']', $value, 6);
}

function shop_cfg_checkbox($value, $key = '', $title, $description) {
  return '<input type="hidden" name="configuration[' . $key . ']" value="false">' .
	     ' &nbsp;  &nbsp; <input type="checkbox" name="configuration[' . $key . ']" value="true"' . 
	     (($value == 'true') ? ' CHECKED' : '') . '> ' . $title;
}

function shop_cfg_checkbox_display($value, $key = '', $title, $description) {
  return str_replace(array('true','false'), 
	                 array(' &nbsp;  &nbsp; <font color="44aa00"><B>&#10003;</B></font> ',
	                       ' &nbsp;  &nbsp; <font color="aa4400">&times;</font> '), strtolower($value)) . $title;

}

function shop_cfg_pull_down_tax_classes($tax_class_id, $key = '', $title, $description) {
  if ($title) $string .= '<b>' . $title . '</b><br />';
  if ($description) $string .= $description . '<br />';

  $tax_class_array = array(array('id' => '0', 'text' => TEXT_NONE));
  $tax_class_query = shop_db_query("select tax_class_id as id, tax_class_title as text from " . DB_PREFIX . "tax_class order by tax_class_title");
  while ($tax_class = shop_db_fetch_array($tax_class_query)) $tax_class_array[] = $tax_class;

  return $string . '<br /> &nbsp;  &nbsp; ' . shop_draw_pull_down_menu('configuration[' . $key . ']', $tax_class_array, $tax_class_id);
}

function shop_is_uploaded_file($filename) {
  if (function_exists('is_uploaded_file')) {
	return is_uploaded_file($filename);
  } else {
	if (!$tmp_file = get_cfg_var('upload_tmp_dir')) {
	  $tmp_file = dirname(tempnam('', ''));
	}
	$tmp_file .= '/' . basename($filename);
	return (ereg_replace('/+', '/', $tmp_file) == $filename);
  }
}

function shop_array_shift(&$array) {
  if (function_exists('array_shift')) {
	return array_shift($array);
  } else {
	$i = 0;
	$shifted_array = array();
	foreach ($array as $key => $value) {
	  if ($i > 0) {
	    $shifted_array[$key] = $value;
	  } else {
	    $return = $array[$key];
	  }
	  $i++;
	}
	$array = $shifted_array;

	return $return;
  }
}

function shop_array_reverse($array) {
  if (function_exists('array_reverse')) {
	return array_reverse($array);
  } else {
	$reversed_array = array();
	for ($i=sizeof($array)-1; $i>=0; $i--) {
	  $reversed_array[] = $array[$i];
	}
	return $reversed_array;
  }
}

function shop_generate_category_path($id, $from = 'category', $categories_array = '', $index = 0) {
  global $languages_id;

  if (!is_array($categories_array)) $categories_array = array();

  if ($from == 'product') {
	$categories_query = shop_db_query("select categories_id from " . DB_PREFIX . "products_to_categories where products_id = '$id'");
	while ($categories = shop_db_fetch_array($categories_query)) {
	  if ($categories['categories_id'] == '0') {
	    $categories_array[$index][] = array('id' => '0', 'text' => 'Top');
	  } else {
	    $category_query = shop_db_query("select cd.categories_name, c.parent_id from " . DB_PREFIX . "categories c, " . DB_PREFIX . "categories_description cd where c.categories_id = '" . $categories['categories_id'] . "' and c.categories_id = cd.categories_id and cd.language_id = '$languages_id'");
	    $category = shop_db_fetch_array($category_query);
	    $categories_array[$index][] = array('id' => $categories['categories_id'], 'text' => $category['categories_name']);
	    if ( ($category['parent_id']) && ($category['parent_id'] != '0') ) $categories_array = shop_generate_category_path($category['parent_id'], 'category', $categories_array, $index);
	    $categories_array[$index] = shop_array_reverse($categories_array[$index]);
	  }
	  $index++;
	}
  } elseif ($from == 'category') {
	$category_query = shop_db_query("select cd.categories_name, c.parent_id from " . DB_PREFIX . "categories c, " . DB_PREFIX . "categories_description cd where c.categories_id = '$id' and c.categories_id = cd.categories_id and cd.language_id = '$languages_id'");
	$category = shop_db_fetch_array($category_query);
	$categories_array[$index][] = array('id' => $id, 'text' => $category['categories_name']);
	if ( ($category['parent_id']) && ($category['parent_id'] != '0') ) $categories_array = shop_generate_category_path($category['parent_id'], 'category', $categories_array, $index);
  }

  return $categories_array;
}

function shop_output_generated_category_path($id, $from = 'category') {
  $calculated_category_path_string = '';
  $calculated_category_path = shop_generate_category_path($id, $from);
  for ($i=0; $i<sizeof($calculated_category_path); $i++) {
	for ($j=0; $j<sizeof($calculated_category_path[$i]); $j++) {
	  $calculated_category_path_string .= '/' . $calculated_category_path[$i][$j]['text'];
	}
	$calculated_category_path_string .= '<br />';
  }

  if (strlen($calculated_category_path_string) < 1) $calculated_category_path_string = 'Top';

  return $calculated_category_path_string;
}

function shop_remove_category($category_id) {
  shop_db_query("delete from " . DB_PREFIX . "categories where categories_id = '" . ($category_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "categories_description where categories_id = '" . ($category_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "products_to_categories where categories_id = '" . ($category_id) . "'");
}

function shop_remove_product($product_id) {
  shop_db_query("delete from " . DB_PREFIX . "specials where products_id = '" . ($product_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "products where products_id = '" . ($product_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "products_to_categories where products_id = '" . ($product_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "products_description where products_id = '" . ($product_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "products_attributes where products_id = '" . ($product_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "customer_options where products_id = '" . ($product_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "features where products_id = '" . ($product_id) . "'");
}

function shop_remove_order($order_id, $restock = false) {
  if ($restock == 'on') {
		$order_query = shop_db_query("select products_id, products_quantity from " . DB_PREFIX . "orders_products where orders_id = '" . ($order_id) . "'");
		while ($order = shop_db_fetch_array($order_query)) {
			// if this product is unique and turned off after sold, turn it back on		
			$product = shop_db_fetch_array(shop_db_query("select products_turnoff_sold as turn_off from " . DB_PREFIX . "products where products_id = '" . $order['products_id'] . "'"));
			if ($product['turn_off'] == '1') $prod_sql = ", products_status = '1'";
			shop_db_query("update " . DB_PREFIX . "products set products_quantity = products_quantity + " . $order['products_quantity'] . ", products_ordered = products_ordered - " . $order['products_quantity'] . $prod_sql . " where products_id = '" . $order['products_id'] . "'");
		}
  }

  shop_db_query("delete from " . DB_PREFIX . "orders where orders_id = '" . ($order_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "orders_products where orders_id = '" . ($order_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "orders_products_attributes where orders_id = '" . ($order_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "orders_status_history where orders_id = '" . ($order_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "orders_total where orders_id = '" . ($order_id) . "'");
  shop_db_query("delete from " . DB_PREFIX . "orders_coupons where orders_id = '" . ($order_id) . "'");
}

function shop_display_tax_value($value, $padding = TAX_DECIMAL_PLACES) {
  if (strpos($value, '.')) {
	$loop = true;
	while ($loop) {
	  if (substr($value, -1) == '0') {
	    $value = substr($value, 0, -1);
	  } else {
	    $loop = false;
	    if (substr($value, -1) == '.') {
	      $value = substr($value, 0, -1);
	    }
	  }
	}
  }

  if ($padding > 0) {
	if ($decimal_pos = strpos($value, '.')) {
	  $decimals = strlen(substr($value, ($decimal_pos+1)));
	  for ($i=$decimals; $i<$padding; $i++) {
	    $value .= '0';
	  }
	} else {
	  $value .= '.';
	  for ($i=0; $i<$padding; $i++) {
	    $value .= '0';
	  }
	}
  }

  return $value;
}

function shop_get_tax_class_title($tax_class_id) {
  if ($tax_class_id == '0') {
	return TEXT_NONE;
  } else {
	$classes_query = shop_db_query("select tax_class_title from " . DB_PREFIX . "tax_class where tax_class_id = '$tax_class_id'");
	$classes = shop_db_fetch_array($classes_query);

	return $classes['tax_class_title'];
  }
}

function shop_add_tax($price, $tax) {
  global $currencies;

  if (DISPLAY_PRICE_WITH_TAX == 'true') {
	return round($price, $currencies->currencies[DEFAULT_CURRENCY]['decimal_places']) + shop_calculate_tax($price, $tax);
  } else {
	return round($price, $currencies->currencies[DEFAULT_CURRENCY]['decimal_places']);
  }
}

function shop_calculate_tax($price, $tax) {
  global $currencies;

  return round($price * $tax / 100, $currencies->currencies[DEFAULT_CURRENCY]['decimal_places']);
}

function shop_href_link($page = '', $parameters = '') {
  $link = $page . ((!$parameters || substr($parameters,0,1) == '?') ? '' : '?') . $parameters;
  while ((substr($link, -1) == '&') || (substr($link, -1) == '?')) $link = substr($link, 0, -1);
  return $link;
}

function shop_image($src, $alt = '', $width = '', $height = '', $params = '') {
  $image = '<img src="' . $src . '" border="0" alt="' . $alt . '"';
  if ($alt) $image .= ' title=" ' . $alt . ' "';
  if ($width) $image .= ' width="' . $width . '"';
  if ($height) $image .= ' height="' . $height . '"';
  if ($params) $image .= ' ' . $params;
  $image .= '>';

  return $image;
}

function shop_image_transparent($src, $name) {
  if ($src) {
	return '<table background="images/transparent_bg.gif" border="0" cellpadding="0" cellspacing="0"><tr><td><a onclick="popupWindow(\'contents/popup_image.php?image=' . $src . '\');">' . shop_info_image($src, $name, 200) . '</a></td></tr></table>';
  } else {
	return '';
  }
}

function shop_image_submit($image, $alt, $params = '') {
  return '<input type="image" src="images/buttons/' . $image . '" border="0" alt="' . $alt . '"' . (($params) ? ' ' . $params : '') . '>';
}

function shop_draw_separator($image = 'pixel_black.gif', $width = '100%', $height = '1') {
  return shop_image(DIR_WS_IMAGES . $image, '', $width, $height);
}

function shop_image_button($image, $alt = '', $params = '') {
  return shop_image('images/buttons/' . $image, $alt, '', '', $params);
}

function shop_js_zone_list($country, $form, $field) {
  $countries_query = shop_db_query("select distinct zone_country_id from " . DB_PREFIX . "zones order by zone_country_id");
  $num_country = 1;
  $output_string = '';
  while ($countries = shop_db_fetch_array($countries_query)) {
	if ($num_country == 1) {
	  $output_string .= '  if (' . $country . ' == "' . $countries['zone_country_id'] . '") {' . UNIX_RETURN;
	} else {
	  $output_string .= '  } else if (' . $country . ' == "' . $countries['zone_country_id'] . '") {' . UNIX_RETURN;
	}

	$states_query = shop_db_query("select zone_name, zone_id from " . DB_PREFIX . "zones where zone_country_id = '" . $countries['zone_country_id'] . "' order by zone_name");

	$num_state = 1;
	while ($states = shop_db_fetch_array($states_query)) {
	  if ($num_state == '1') $output_string .= '    ' . $form . '.' . $field . '.options[0] = new Option("' . PLEASE_SELECT . '", "");' . UNIX_RETURN;
	  $output_string .= '    ' . $form . '.' . $field . '.options[' . $num_state . '] = new Option("' . $states['zone_name'] . '", "' . $states['zone_id'] . '");' . UNIX_RETURN;
	  if (MYSELF == 'customers.php') {
	    $output_string .= '    state_popup.style.visibility="hidden";' . UNIX_RETURN .
	                      '    zone_popup.style.visibility="visible";' . UNIX_RETURN;
	  }
	  $num_state++;
	}
	$num_country++;
  }  
  if (MYSELF == 'customers.php') {
	$output_string .= '  } else {' . UNIX_RETURN .
	                  '    state_popup.style.visibility="visible";' . UNIX_RETURN .
	                  '    zone_popup.style.visibility="hidden";' . UNIX_RETURN;
  }                
  $output_string .= '  }' . UNIX_RETURN;

  return $output_string;
}

function shop_js_values_list($option, $form, $field) {
  $options_query = shop_db_query("select distinct products_options_id from " . DB_PREFIX . "products_options order by products_options_id");
  $num_option = 1;
  $output_string = '';
  while ($options = shop_db_fetch_array($options_query)) {
	if ($num_option == 1) {
	  $output_string .= '  if (' . $option . ' == "' . $options['products_options_id'] . '") {' . UNIX_RETURN;
	} else {
	  $output_string .= '  } else if (' . $option . ' == "' . $options['products_options_id'] . '") {' . UNIX_RETURN;
	}
	
	$values_query = shop_db_query("select distinct products_options_values_name, products_options_values_id from " . DB_PREFIX . "products_options_values where products_options_id = '" . $options['products_options_id'] . "' order by products_options_values_name");

	$num_value = 1;
	while ($values = shop_db_fetch_array($values_query)) {
	  if ($num_value == '1') $output_string .= '    ' . $form . '.' . $field . '.options[0] = new Option("' . PLEASE_SELECT . '", "");' . UNIX_RETURN;
	  $output_string .= '    ' . $form . '.' . $field . '.options[' . $num_value . '] = new Option("' . ($values['products_options_values_name']) . '", "' . $values['products_options_values_id'] . '");' . UNIX_RETURN;
	  $num_value++;
	}
	$num_option++;
  }
  $output_string .= '  }' . UNIX_RETURN;

  return $output_string;
}

function shop_draw_form($name, $action, $parameters = '', $method = 'post', $params = '') {
  $form = '<form name="' . $name . '" id="' . $name . '" action="' . shop_href_link($action, $parameters) . '" method="' . $method . '" accept-charset="UTF-8"';
  if ($params) $form .= ' ' . $params;
  $form .= '>';
	
  return $form;
}

function shop_draw_input_field($name, $value = false, $parameters = false, $type = 'text') {
  $field = '<input type="' . $type . '" name="' . $name . '" value="' . utf_htmlentities(stripslashes($value)) . '"';
  if ($parameters) {
	$field .= ' ' . $parameters;
  } else {
  	$field .= ' style="font-size:10px;"';
  }
  $field .= '>';

  return $field;
}

function shop_draw_password_field($name, $value) {
  return shop_draw_input_field($name, $value, 'style="font-size:10px;" size="16"', 'password');
}

function shop_draw_file_field($name, $value = '', $parameters = '') {
  return shop_draw_input_field($name, $value, $parameters, 'file');
}

function shop_draw_hidden_field($name, $value) {
  return shop_draw_input_field($name, $value, '', 'hidden');
}

function shop_draw_selection_field($name, $type, $value = false, $checked = false) {
  $selection = '<input type="' . $type . '" name="' . $name . '"';
  if ($value) {
	$selection .= ' value="' . trim(utf_htmlentities($value)) . '"';
  }
  if ($checked == true || $GLOBALS[$name] == 'on' || $GLOBALS[$name] == 'true') {
	$selection .= ' CHECKED';
  }
  $selection .= '>';

  return $selection;
}

function shop_draw_checkbox_field($name, $value = false, $checked = false) {
  return shop_draw_selection_field($name, 'checkbox', $value, $checked);
}

function shop_draw_radio_field($name, $value = false, $checked = false, $compare = '') {
  return shop_draw_selection_field($name, 'radio', $value, $checked, $compare);
}

function shop_draw_textarea_field($name, $value = false, $rows = "4", $width = "98%", $params = '') {
  $field = '<textarea name="' . $name . '" wrap="soft" rows="' . $rows . '" style="font-size:10px; width:' . $width . ';"';
  if ($params) $field .= ' ' . $params;
  $field .= '>';
  if (!$value && ($_GET[$name] || $_POST[$name])) {
	$field .= utf_htmlentities(($_GET[$name]) ? $_GET[$name] : $_POST[$name]);
  } else {
	$field .= utf_htmlentities($value);
  }
  $field .= '</textarea>';

  return $field;
}

/* Create a FCKEditor textarea field
 * Created: Jul 22, 2005 Rick Baskett rick@baskettcase.com
 * Modified: Sep 21, 2006 Dynamic toolbars, height and width
 						 Apr 07, 2008 External Expand window link
 */
function shop_draw_texteditor_field ($name, $value = '', $tbwidth = '98%', $tbheight = '200') {
	if (TEXT_EDITOR != 'None') {
		require_once("fckeditor/fckeditor.php");
		$oFCKeditor = new FCKeditor($name);
		$oFCKeditor->BasePath = 'fckeditor/';
		$oFCKeditor->Value = $value;
		$oFCKeditor->ToolbarSet = TEXT_EDITOR;
		$oFCKeditor->Width = $tbwidth;
		$oFCKeditor->Height = $tbheight;
		return '
	<script type="text/javascript" language="javascript" charset="utf-8">
	<!--
	function FCKeditor_Expand (editorInstance) {
		var oEditor = FCKeditorAPI.GetInstance(editorInstance) ;
		oEditor.EditorWindow.parent.FCK.ToolbarSet._ChangeVisibility(false);
		oEditor.Commands.GetCommand(\'FitWindow\').Execute();
	}
	//-->
	</script>
	<a href="#" onclick="FCKeditor_Expand(\'' . $name . '\')"><img src="images/icon_full_window.gif" alt="Expand" border="0" /> Expand text editor to full window</a>' . $oFCKeditor->CreateHtml() ;
	}
	else return shop_draw_textarea_field($name, $value, "8", $tbwidth);
}

function shop_draw_pull_down_menu($name, $values, $default = '', $params = '') {
  $field = '<select name="' . $name . '"';
  if ($params) $field .= ' ' . $params;
  $field .= '>';
  for ($i=0; $i<sizeof($values); $i++) {
	$field .= '<option value="' . $values[$i]['id'] . '"';
	if ( ((strlen($values[$i]['id']) > 0) && ($GLOBALS[$name] == $values[$i]['id'])) || ($default == $values[$i]['id']) ) {
	  $field .= ' SELECTED';
	}
	$field .= '>' . $values[$i]['text'] . '</option>';
  }
  $field .= '</select>';
  return $field;
}

function shop_draw_language_menu($language_selected) {
  $languages_array = array();
  $languages_query = shop_db_query("select languages_id as id, name as text from " . DB_PREFIX . "languages order by name");
  while ($languages = shop_db_fetch_array($languages_query)) $languages_array[] = $languages;
  return shop_draw_pull_down_menu('choose_language', $languages_array, $language_selected, 'onChange="showLanguage(this.form.choose_language.selectedIndex, this.form);"');
}

class tableBlock {
  var $table_border = '0';
  var $table_width = '100%';
  var $table_cellspacing = '0';
  var $table_cellpadding = '0';
  var $table_parameters = '';
  var $table_row_parameters = '';
  var $table_data_parameters = '';

  function tableBlock($contents, $table_cellspacing = '') {
	$tableBox_string = '<table border="' . $this->table_border . '" width="' . $this->table_width . '" cellspacing="' . $this->table_cellspacing . '" cellpadding="' . $this->table_cellpadding . '"';
	if ($this->table_parameters != '') $tableBox_string .= ' ' . $this->table_parameters;
	$tableBox_string .= '>' . UNIX_RETURN;

	$form_set = false;
	if ($contents['form']) {
	  echo $contents['form'] . UNIX_RETURN;
	  $form_set = true;
	  shop_array_shift($contents);
	}

	for ($i=0; $i<sizeof($contents); $i++) {
	  $tableBox_string .= '  <tr';
	  if ($this->table_row_parameters != '') $tableBox_string .= ' ' . $this->table_row_parameters;
	  if ($contents[$i]['params']) $tableBox_string .= ' ' . $contents[$i]['params'];
	  $tableBox_string .= '>' . UNIX_RETURN;

	  if (is_array($contents[$i][0])) {
	    for ($x=0; $x<sizeof($contents[$i]); $x++) {
	      if ($contents[$i][$x]['text']) {
	        $tableBox_string .= '    <td';
	        if ($contents[$i][$x]['align'] != '') $tableBox_string .= ' align="' . $contents[$i][$x]['align'] . '"';
	        if ($contents[$i][$x]['params']) {
	          $tableBox_string .= ' ' . $contents[$i][$x]['params'];
	        } elseif ($this->table_data_parameters != '') {
	          $tableBox_string .= ' ' . $this->table_data_parameters;
	        }
	        $tableBox_string .= '>';
	        if ($contents[$i][$x]['form']) $tableBox_string .= $contents[$i][$x]['form'];
	        $tableBox_string .= $contents[$i][$x]['text'];
	        if ($contents[$i][$x]['form']) $tableBox_string .= '</form>';
	        $tableBox_string .= '</td>' . UNIX_RETURN;
	      }
	    }
	  } else {
	    $tableBox_string .= '    <td';
	    if ($contents[$i]['align'] != '') $tableBox_string .= ' align="' . $contents[$i]['align'] . '"';
	    if ($contents[$i]['params']) {
	      $tableBox_string .= ' ' . $contents[$i]['params'];
	    } elseif ($this->table_data_parameters != '') {
	      $tableBox_string .= ' ' . $this->table_data_parameters;
	    }
	    $tableBox_string .= '>' . $contents[$i]['text'] . '</td>' . UNIX_RETURN;
	  }

	  $tableBox_string .= '  </tr>' . UNIX_RETURN;
	  if ($contents[$i]['form']) $tableBox_string .= '</form>' . UNIX_RETURN;
	}

	$tableBox_string .= '</table>' . UNIX_RETURN;

	return $tableBox_string;
  }
}

class box extends tableBlock {
  function box() {
	$this->heading = array();
	$this->contents = array();
  }

  function infoBox($heading, $contents) {
	$this->table_row_parameters = '';
	$this->table_cellspacing = "0";
	$this->table_data_parameters = 'class="dataTableContent" height="17" BACKGROUND="images/win_header_column.gif"';
	$this->heading = $this->tableBlock($heading);

	$this->table_row_parameters = '';
	$this->table_cellspacing = "5";
	$this->table_data_parameters = 'class="infoBoxContent"';
	$this->contents = $this->tableBlock($contents, $table_cellspacing);

	return $this->heading . $this->contents;
  }

  function menuBox($heading, $contents) {
	$this->table_data_parameters = 'class="menuBoxContent"';
	if ($heading[0]['link']) {
	  $this->table_data_parameters .= ' onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . $heading[0]['link'] . '\'"';
	  $heading[0]['text'] = '<a href="' . $heading[0]['link'] . '" class="dataTableContentLink">' . $heading[0]['text'] . '</a>&nbsp;';
	} else {
	  $heading[0]['text'] = $heading[0]['text'] . '&nbsp;';
	}
	$this->heading = $this->tableBlock($heading);

	$this->table_data_parameters = 'class="menuBoxContent"';
	$this->contents = $this->tableBlock($contents);

	return $this->heading . $this->contents;
  }
}

class splitPageResults {

  function splitPageResults(&$current_page_number, $max_rows_per_page, &$sql_query, &$query_num_rows) {
	if (empty($current_page_number)) $current_page_number = 1;
	$query_num_rows = shop_db_num_rows(shop_db_query($sql_query));
	$sql_query .= " limit " . ($max_rows_per_page * ($current_page_number - 1)) . ", " . $max_rows_per_page;
  }

  function display_links($query_numrows, $max_rows_per_page, $max_page_links, $current_page_number, $parameters = '', $page_name = 'page') {
	
	if ($parameters != '') $parameters .= '&';

	$num_pages = intval($query_numrows / $max_rows_per_page);

	if ($query_numrows % $max_rows_per_page) $num_pages++;

	$pages_array = array();
	for ($i=1; $i<=$num_pages; $i++) {
	  $pages_array[] = array('id' => $i, 'text' => $i);
	}

	if ($num_pages > 1) {
	  $display_links = shop_draw_form('pages', MYSELF, '', 'get');

	  $display_links .= sprintf(TEXT_RESULT_PAGE, shop_draw_pull_down_menu($page_name, $pages_array, $current_page_number, 'onChange="this.form.submit();"'), $num_pages);

	  if ($parameters != '') {
	    if (substr($parameters, -1) == '&') $parameters = substr($parameters, 0, -1);
	    $pairs = explode('&', $parameters);
	    foreach ($pairs as  $pair) {
	      list($key,$value) = explode('=', $pair);
	      $display_links .= shop_draw_hidden_field(rawurldecode($key), rawurldecode($value));
	    }
	  }
	  $display_links .= '</form>';
	} else {
	  $display_links = '';
	}

	return $display_links;
  }

  function display_count($query_numrows, $max_rows_per_page, $current_page_number, $text_output) {
	$to_num = ($max_rows_per_page * $current_page_number);
	if ($to_num > $query_numrows) $to_num = $query_numrows;
	$from_num = ($max_rows_per_page * ($current_page_number - 1));
	if ($to_num == 0) {
	  $from_num = 0;
	} else {
	  $from_num++;
	}

	return sprintf($text_output, $from_num, $to_num, $query_numrows);
  }
}

class objectInfo {
  function objectInfo($object_array) {
	foreach ($object_array as $key => $value) {
	  $this->$key = ($value);
	}
  }
}

function crypt_password($plain_pass){
  mt_srand ((double) microtime() * 1000000);
  for($i=0;$i<10;$i++){
   $tstring	.= mt_rand();
  }
  
  $salt = substr(md5($tstring),0, 2);
  
  $passtring = $salt . $plain_pass;
  
  $encrypted = md5($passtring);
  
  return($encrypted . ":" . $salt);
}

class currencies {
  var $currencies;

  function currencies() {
	$this->currencies = array();
	$currencies_query = shop_db_query("select code, title, symbol_left, symbol_right, decimal_point, thousands_point, decimal_places, value from " . DB_PREFIX . "currencies");
	while ($currencies = shop_db_fetch_array($currencies_query)) {
		$this->currencies[$currencies['code']] = array('title' => $currencies['title'],
	                                                 'symbol_left' => $currencies['symbol_left'],
	                                                 'symbol_right' => $currencies['symbol_right'],
	                                                 'decimal_point' => $currencies['decimal_point'],
	                                                 'thousands_point' => $currencies['thousands_point'],
	                                                 'decimal_places' => $currencies['decimal_places'],
	                                                 'value' => $currencies['value']);
	}
  }

  function format($number, $calculate_currency_value = true, $currency_type = DEFAULT_CURRENCY, $currency_value = '') {
	$number = shop_get_price($number,1);
	if ($calculate_currency_value) {
	  $rate = ($currency_value) ? $currency_value : $this->currencies[$currency_type]['value'];
	  $format_string = $this->currencies[$currency_type]['symbol_left'] . number_format($number * $rate, $this->currencies[$currency_type]['decimal_places'], $this->currencies[$currency_type]['decimal_point'], $this->currencies[$currency_type]['thousands_point']) . $this->currencies[$currency_type]['symbol_right'];
	  if ( (DEFAULT_CURRENCY == 'EUR') && ($currency_type == 'DEM' || $currency_type == 'BEF' || $currency_type == 'LUF' || $currency_type == 'ESP' || $currency_type == 'FRF' || $currency_type == 'IEP' || $currency_type == 'ITL' || $currency_type == 'NLG' || $currency_type == 'ATS' || $currency_type == 'PTE' || $currency_type == 'FIM' || $currency_type == 'GRD') ) {
	    $format_string .= ' <small>[' . $this->format($number, true, 'EUR') . ']</small>';
	  }
	} else {
	  $format_string = $this->currencies[$currency_type]['symbol_left'] . number_format($number, $this->currencies[$currency_type]['decimal_places'], $this->currencies[$currency_type]['decimal_point'], $this->currencies[$currency_type]['thousands_point']) . $this->currencies[$currency_type]['symbol_right'];
	}

	return $format_string;
  }
}

function shop_get_price($number, $quantity = 1) {
	$numbers = split("[:;]" , $number);
	if (count($numbers) >= 2) {
		$number = $numbers[1];
		for ($i = 0; $i < count($numbers); $i++) {
			$j=$i*2;
			if (!$numbers[$j] || $quantity < $numbers[$j]) break;
			$number = $numbers[$j+1];
		}
	}
	return $number;
}

function shop_update_currency_rates($currency, $default = DEFAULT_CURRENCY) {
  if ($default != $currency || $force) {
	$currency_query = shop_db_query("select * from " . DB_PREFIX . "currencies where code='$currency'");
	$currency = shop_db_fetch_array($currency_query);
	$rate = file('http://tools.secure.cc/currency/currency.php?from=' . $default . '&to=' . $currency['code'] . '&serial=' . A_SERIAL);
	if ($rate) shop_db_query("update " . DB_PREFIX . "currencies set value = '" . $rate[0] . "', last_updated = now() where currencies_id = '" . $currency['currencies_id'] . "'");
  }
  return true;
}

function & http_request($address, $data_array = array()) {
	$data = '';
	foreach ($data_array as $key => $value) $data .= $key . '=' . urlencode($value) . '&';
	$data = substr($data, 0, -1);
	if (function_exists('curl_init')) {
	    $ch = @curl_init($address);
		if ($data_array) {
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, "$data");
		}
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_COOKIE, 0);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_VERBOSE, 0);
		$response = curl_exec($ch);
		curl_close($ch);
	} else {
		$response = `/usr/bin/curl -d "$data" $address`;
	}
	return $response;
}

class sparx {
	var $files, $sparx_classes;

	function shop_load_sparx() {
		$module_directory = 'contents/sparx/';
		$file_extension = substr(PHP_SELF, strrpos(PHP_SELF, '.'));
		$directory_array = array();
		$exists = false;
		if ($dir = @dir($module_directory)) {
			while ($file = $dir->read()) {
				if (!is_dir($module_directory . $file)) {
					if (substr($file, strrpos($file, '.')) == $file_extension) {
						$directory_array[] = $file;
						$exists = true;
					}
				}
			}
			sort($directory_array);
			$dir->close();
		}
		
		if ($exists) {
			$this->files = $directory_array;
			foreach ($this->files as  $value) {
				include('contents/sparx/' . $value);
				$class = substr($value, 0, strrpos($value, '.'));
				$this->sparx_classes[] = substr($value, 0, strrpos($value, '.'));
				$GLOBALS[$class] = new $class;
				$GLOBALS[$class]->load();
			}
		}
		return true;
	}
}
