<?php
/*

  eShox 4 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003-04, Secure.cc, Inc. All rights reserved.

  SOFTWARE LICENSE INFORMATION

  http://www.eshox.com/license.html

  PLEASE READ THE SECURE.CC, INC SINGLE USE SOFTWARE LICENSE AGREEMENT ("LICENSE") 
  CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY INSTALLING OR USING THE 
  SOFTWARE, YOU ARE AGREEING TO BE BOUND BY THE TERMS OF THE LICENSE.

*/

error_reporting(0);

if (file_exists('../../config.php')) include('../../config.php');

if (ENABLE_GD != true) {
  header('Location: http://graphs.secure.cc/linegraph.php?' . $_SERVER['QUERY_STRING']);
  die;
}

function format_label($number) { 
  return number_format($number);
}

include ("jpgraph/jpgraph.php");
include ("jpgraph/jpgraph_line.php");
include ("jpgraph/jpgraph_regstat.php");

$data1 = array();
$data3 = array();
$average = 0;
while(list($key,$value) = each($_GET['data'])) {
  $data1[$key] = $value;
  $average = ($average + $value) / 2;
  $data3[$key] = $average;
}
$data2 = array();
while(list($key,$value) = each($_GET['dates'])) {
  $data2[$key] = $value;
}
$graph = new Graph(720,440);
$graph->SetMarginColor('white');
$graph->SetScale("textlin");
$graph->SetFrame(false);
$graph->SetMargin(50,10,15,45);

$graph->yaxis->HideZeroLabel();
$graph->yaxis->SetLabelFormatCallback('format_label'); 

$graph->ygrid->SetFill(true,'#F0F0F0@0.25','#E0E0E0@0.15');
$graph->xgrid->Show();

if (strlen($data2[0]) > 2) $graph->xaxis->SetLabelAngle(90);
$graph->xaxis->SetTickLabels($data2);

$p2 = new LinePlot($data3);
$p2->SetColor("lightslategray");
$p2->SetFillColor("lightslategray");
$graph->Add($p2);

$p1 = new LinePlot($data1);
$p1->SetColor("black");
$graph->Add($p1);
$handle=$graph->Stroke(_IMG_HANDLER);

$small = imagecreatetruecolor(360, 220);
imagecopyresampled($small, $handle, 0, 0, 0, 0, 360, 220, 720, 440);
imagetruecolortopalette($small);

header("Last-Modified: Mon, 26 Nov 1962 00:00:00 GMT");
header("Expires: " . gmdate("D,d M Y H:i:s") . " GMT");
header("Cache-Control: cache");
header("Pragma: cache");

header("Content-Type: image/jpeg");
imagejpeg($small, '', 94);
ImageDestroy($small);
ImageDestroy($image);