ALTER TABLE admin_users CHANGE access_level permissions smallint unsigned NOT NULL default 0;
ALTER TABLE admin_users DROP KEY shop_access_level;
ALTER TABLE admin_users ADD KEY shop_permissions (admin_user_id, permissions);

ALTER TABLE customers ADD COLUMN customers_default_coupon varchar(32) NOT NULL default 0;

update admin_users set permissions = 1023 where permissions = 10;
update admin_users set permissions = 1 where permissions = 5;
update admin_users set permissions = 16 where permissions = 4;

update configuration set configuration_title = 'Rendezvous / LPR Printing', configuration_description = 'The printer to which orders should be printed', configuration_group_id = 1, sort_order = 9 where configuration_key = 'DEFAULT_PRINTER';

delete from configuration where configuration_key like 'MODULE_ORDER_TOTAL_COUPON_%';
