<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  require('contents/resources.php');

define('HEADING_TITLE', 'Coupons');

define('TABLE_HEADING_COUPONS', 'Coupons');
define('TABLE_HEADING_DESCRIPTION', 'Description');
define('TABLE_HEADING_EXPIRES', 'Expires');

define('TEXT_COUPONS_PRODUCT', 'Product:');
define('TEXT_COUPONS_EXPIRES_DATE', 'Expiry Date:');
define('TEXT_COUPONS_MAXUSAGE', 'Maximum Usage:<br /><small>(per customer)</small>');

define('TEXT_EDIT_INTRO', 'Please make any necessary changes');
define('TEXT_NEW_INTRO', 'Please fill out the following information for the coupon');
define('TEXT_INFO_DATE_ADDED', 'Date Added');
define('TEXT_INFO_LAST_MODIFIED', 'Last Modified');
define('TEXT_INFO_EXPIRES_DATE', 'Expires At');

define('TEXT_INFO_AMOUNT', 'Discount Amount');
define('TEXT_INFO_OVERAMOUNT', 'Minimum Order Total');
define('TEXT_INFO_MAXUSAGE', 'Maximum Usage');

define('TEXT_INFO_CODE', 'Coupon Code');
define('TEXT_INFO_TYPE', 'Coupon Type');
define('TEXT_INFO_PRODUCT', 'Discount Product');
define('TEXT_INFO_CATEGORY', 'Discount Category');
define('TEXT_INFO_MANUFACTURER', 'Discount Manufacturer');
define('TEXT_INFO_ORDERTOTAL', 'Discount Order Total');
define('TEXT_INFO_FREE_SHIPPING', 'Free Shipping (no discount)');

define('TEXT_COUPONS_PRICE_TIP', '<b>Coupon Notes:</b> You can enter a percentage to deduct in the Discount Amount field, for example: 20%. Leave the expiry date empty for no expiration.');

define('TEXT_INFO_DELETE_INTRO', 'Are you sure you want to delete this coupon? &nbsp;');

define('TEXT_INFO_HEADING_DELETE_COUPONS', 'Delete Coupon');

$currencies = new currencies();

if ($_GET['action']) {
  $coupons_id = $_POST['coupons_id'];
  $coupons_code = $_POST['coupons_code'];
  $coupon_type = $_POST['coupon_type'];
  $amount = $_POST['amount'];
  $over_amount = $_POST['over_amount'];
  $max_usage = $_POST['max_usage'];
  $products_id = 0;
  $manufacturers_id = 0;
  $categories_id = 0;
  switch ($_POST['coupon_type']) {
	case '1':
	  $products_id = $_POST['products_id'];
	  break;
	case '2':
	  $categories_id = $_POST['categories_id'];
	  break;
	case '3':
	  $manufacturers_id = $_POST['manufacturers_id'];
	  break;
  }
  
  $expires_date = ($_POST['expires_date']['year'] . '-' . $_POST['expires_date']['month'] . '-' . $_POST['expires_date']['day']);

  $sql_data_array = array('coupons_code' => $coupons_code,
	                      'coupon_type' => $coupon_type,
	                      'amount' => $amount,
	                      'over_amount' => $over_amount,
	                      'max_usage' => $max_usage,
	                      'products_id' => $products_id,
	                      'manufacturers_id' => $manufacturers_id,
	                      'categories_id' => $categories_id,
	                      'expires_date' => $expires_date);

  switch ($_GET['action']) {
	case 'insert':
	  $sql_data_array['coupons_date_added'] = 'now()';
	  $coupons_id = shop_db_perform('coupons', $sql_data_array, 'insert');

	  shop_redirect(shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $coupons_id));
	  break;
	case 'update':
	  $sql_data_array['coupons_last_modified'] = 'now()';
	  shop_db_perform('coupons', $sql_data_array, 'update', "coupons_id = '$coupons_id'");

	  shop_redirect(shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $coupons_id));
	  break;
	case 'deleteconfirm':
	  shop_db_query("delete from " . DB_PREFIX . "coupons where coupons_id = '" . $_GET['cID'] . "'");

	  shop_redirect(shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page']));
	  break;
  }
}

?><html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>eShox: <?php echo HEADING_TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="contents/stylesheet.css">
<script language="JavaScript" src="contents/eshox_os/scripts.js" type="text/javascript"></script>
<?php
  if ( ($_GET['action'] == 'new') || ($_GET['action'] == 'edit') ) {

  }
?>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="333333">
<!-- header //-->
<!-- header_eof //-->

<!-- body //-->
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<?php
$help_page = 'product_specials.php';
include('contents/header.php');
?>
</table><table border="0" width="100%" cellspacing="8" cellpadding="1" bgcolor="333333">
  <tr>
	<td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="160" cellspacing="0" cellpadding="0">
<!-- left_navigation //-->
<?php require('contents/navbar.php'); ?>
<!-- left_navigation_eof //-->
	</table></td>
<!-- body_text //-->
	<td width="100%" valign="top">
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	        <td><img src="images/win_header_left.gif" width="8" height="22"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="index.php"><img src="images/close.gif" width="13" height="14" border="0"></a></td>
	        <td width="6" align="left" valign="center" background="images/win_header_bg.gif"><img src="images/pixel_trans.gif" border="0" width="6" height="14"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="<?php echo MYSELF . '?page_toggle=true'; ?>"><img src="images/max.gif" width="13" height="14" border="0"></a></td>
	        <td class="windowHeading" align="CENTER" valign="CENTER" height="22" width="100%" background="images/win_header_bg.gif"><?php echo HEADING_TITLE; ?></td>
	        <td width="34" background="images/win_header_bg.gif"></td>
	        <td><img src="images/win_header_right.gif" width="8" height="22"></td>
	    </tr>
	</table>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td width="100%" background="images/win_header_column.gif">
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
	      <tr>
	        <td valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td height="17" valign="center" class="dataTableContent"> &nbsp; <?php echo TABLE_HEADING_COUPONS; ?></td>
	            <td height="17" valign="center" class="dataTableContent"> &nbsp; <?php echo TABLE_HEADING_DESCRIPTION; ?></td>
	            <td height="17" valign="center" class="dataTableContent" align="right">&nbsp;</td>
	          </tr>
<?php
	$coupons_query_raw = "select * from " . DB_PREFIX . "coupons";
	$coupons_split = new splitPageResults($_GET['page'], CFG_ADMIN_ITEMS_PAGE, $coupons_query_raw, $coupons_query_numrows);
	$coupons_query = shop_db_query($coupons_query_raw);
	while ($coupons = shop_db_fetch_array($coupons_query)) {
	  if (!is_object($cInfo) && (!($_GET['cID'] || $_GET['action'] == 'new') || $_GET['cID'] == $coupons['coupons_id'])) {
	    $cInfo = new objectInfo($coupons);
	  }
	  
	  if (is_object($cInfo) && $coupons['coupons_id'] == $cInfo->coupons_id) {
	    echo '                  <tr class="dataTableRowSelected">' . UNIX_RETURN;
	  } else {
	    echo '                  <tr class="dataTableRow" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $coupons['coupons_id']) . '\'">' . UNIX_RETURN;
	  }
?>
	            <td  class="dataTableContent" height="20"> &nbsp; <?php echo $coupons['coupons_code']; ?></td>
	            <td  class="dataTableContent" height="20"> &nbsp; <?php 
	  switch ($coupons['coupon_type']) {
	    case '1':
	      echo ((strstr($coupons['amount'], '%')) ? $coupons['amount'] : $currencies->format($coupons['amount'])) . ' off "' . shop_get_products_name($coupons['products_id'], $languages_id) . '"';
	      break;
	    case '2':
	      echo ((strstr($coupons['amount'], '%')) ? $coupons['amount'] : $currencies->format($coupons['amount'])) . ' off products in "' . shop_get_category_name($coupons['categories_id'], $languages_id) . '"';
	      break;
	    case '3':
	      echo ((strstr($coupons['amount'], '%')) ? $coupons['amount'] : $currencies->format($coupons['amount'])) . ' off "' . shop_get_manufacturer_name($coupons['manufacturers_id']) . '" products';
	      break;
	    case '4':
	      echo ((strstr($coupons['amount'], '%')) ? $coupons['amount'] : $currencies->format($coupons['amount'])) . ' off order';
	      break;
	    case '5':
	      echo 'Free shipping';
	      break;
	  }
	  if ($coupons['over_amount'] > 0) echo ' on order' . (($coupons['max_usage'] < 1) ? '(s)' : '') .  ' over ' . $currencies->format($coupons['over_amount']);
	  if ($coupons['expires_date'] > 0) echo ' until ' . shop_date_short($coupons['expires_date']);
	  ?></td>
	            <td class="dataTableContent" align="right"><?php 
if ( (is_object($cInfo)) && ($coupons['coupons_id'] == $cInfo->coupons_id) ) {
  echo shop_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', '');
} else {
  echo shop_image(DIR_WS_IMAGES . 'pixel_trans.gif', '', 16, 16); } ?></td>
	  </tr>
<?php

}
?>
	          <tr>
	            <td colspan="4">
	              <table border="0" width="100%" cellpadding="0"cellspacing="4">
	                <tr>
	                  <td class="smallText" valign="top"><?php echo $coupons_split->display_count($coupons_query_numrows, CFG_ADMIN_ITEMS_PAGE, $_GET['page'], TEXT_DISPLAY_NUMBER_OF_COUPONS); ?></td>
	                  <td class="smallText" align="right"><?php echo $coupons_split->display_links($coupons_query_numrows, CFG_ADMIN_ITEMS_PAGE, MAX_DISPLAY_PAGE_LINKS, $_GET['page']); ?></td>
	                </tr>
	              </table>
	            </td>
	          </tr>
<?php
  if (!$_GET['action']) {
?>
	              <tr> 
	                <td colspan="4" align="right"><?php echo '<a href="' . shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&action=new') . '">' . shop_image_button('button_insert.gif', IMAGE_INSERT) . '</a>&nbsp;'; ?></td>
	              </tr>
<?php
  }
?>
	        </table></td>
<?php
  $products_array = array(array('id' => '0', 'text' => 'Select Product'));
  $products_query = shop_db_query("select * from " . DB_PREFIX . "products_description where language_id = '$languages_id'");
  while ($products = shop_db_fetch_array($products_query)) {
	$products_array[] = array('id' => $products['products_id'], 'text' => $products['products_name']);
  }
  $categories_array = array(array('id' => '0', 'text' => 'Select Category'));
  $categories_query = shop_db_query("select * from " . DB_PREFIX . "categories_description where language_id = '$languages_id'");
  while ($categories = shop_db_fetch_array($categories_query)) {
	$categories_array[] = array('id' => $categories['categories_id'], 'text' => $categories['categories_name']);
  }
  $manufacturers_array = array(array('id' => '0', 'text' => 'Select Manufacturer'));
  $manufacturers_query = shop_db_query("select * from " . DB_PREFIX . "manufacturers");
  while ($manufacturers = shop_db_fetch_array($manufacturers_query)) {
	$manufacturers_array[] = array('id' => $manufacturers['manufacturers_id'], 'text' => $manufacturers['manufacturers_name']);
  }
  
  $heading = array();
  $contents = array();
  switch ($_GET['action']) {
	case 'delete':
	  $heading[] = array('text' => TEXT_INFO_HEADING_DELETE_COUPONS);

	  $contents = array('form' => shop_draw_form('coupons', FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $cInfo->coupons_id . '&action=deleteconfirm'));
	  $contents[] = array('text' => TEXT_INFO_DELETE_INTRO);
	  $contents[] = array('text' => '<br /><b>' . $cInfo->coupons_code . '</b>');
	  $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_delete.gif', IMAGE_DELETE) . '&nbsp;<a href="' . shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $cInfo->coupons_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  break;
	case 'new':
	  $cInfo = array();
	case 'edit':
	  
	  if ($_GET['action'] == 'new') {
	    $heading[] = array('text' => 'New Coupon');
	    $contents[] = array('text' => TEXT_NEW_INTRO);
	    $contents[] = array('text' => shop_draw_form('coupon', FILENAME_COUPONS, 'page=' . $_GET['page'] . '&action=insert'));
	  } else {
	    $heading[] = array('text' => $cInfo->coupons_code);
	    $contents[] = array('text' => TEXT_EDIT_INTRO);
	    $contents[] = array('text' => shop_draw_form('coupon', FILENAME_COUPONS, 'page=&action=update'));
	    $contents[] = array('text' => shop_draw_hidden_field('coupons_id', $_GET['cID']));
	  }
	  $contents[] = array('text' => TEXT_INFO_CODE . ':<br />' . shop_draw_input_field('coupons_code', (($cInfo->coupons_code) ? $cInfo->coupons_code : 'CP' . rand(10000,99999)), 'style="font-size:10px;" maxlength="32"'));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_AMOUNT . ':<br />' . shop_draw_input_field('amount', $cInfo->amount, 'style="font-size:10px;" size="8" maxlength="8"'));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_OVERAMOUNT . ':<br />' . shop_draw_input_field('over_amount', $cInfo->over_amount, 'style="font-size:10px;" size="8" maxlength="8"'));

	  $contents[] = array('text' => '<br />' . TEXT_INFO_TYPE . ':<p>' . shop_draw_radio_field('coupon_type', 1, (($cInfo->coupon_type == 1) ? true : false)) . TEXT_INFO_PRODUCT . ': <br /> &nbsp; &nbsp; &nbsp; &nbsp;' . shop_draw_pull_down_menu('products_id', $products_array, $cInfo->products_id) . 
	                                '<p>' . shop_draw_radio_field('coupon_type', 2, (($cInfo->coupon_type == 2) ? true : false)) . TEXT_INFO_CATEGORY . ': <br /> &nbsp; &nbsp; &nbsp; &nbsp;' . shop_draw_pull_down_menu('categories_id', $categories_array, $cInfo->categories_id) . 
	                                '<p>' . shop_draw_radio_field('coupon_type', 3, (($cInfo->coupon_type == 3) ? true : false)) . TEXT_INFO_MANUFACTURER . ': <br /> &nbsp; &nbsp; &nbsp; &nbsp;' . shop_draw_pull_down_menu('manufacturers_id', $manufacturers_array, $cInfo->manufacturers_id) . 
	                                '<p>' . shop_draw_radio_field('coupon_type', 4, (($cInfo->coupon_type == 4) ? true : false)) . TEXT_INFO_ORDERTOTAL . 
	                                '<br />' . shop_draw_radio_field('coupon_type', 5, (($cInfo->coupon_type == 5) ? true : false)) . TEXT_INFO_FREE_SHIPPING);
	  
	  $contents[] = array('text' => '<br />' . TEXT_COUPONS_MAXUSAGE . '<br />' . shop_draw_input_field('max_usage', (($cInfo->max_usage) ? $cInfo->max_usage : '1'), 'style="font-size:10px;" size="3" maxlength="3"'));
	  $contents[] = array('text' => '<br />' . TEXT_COUPONS_EXPIRES_DATE . '<br />' . shop_draw_date_input('expires_date', $cInfo->expires_date, false));

	  if ($_GET['action'] == 'new') {
	    $button_insert = shop_image_submit('button_insert.gif', IMAGE_INSERT);
	  } else {
	    $button_insert = shop_image_submit('button_update.gif', IMAGE_UPDATE);
	  }
	  $contents[] = array('align' => 'center', 'text' => '<br />' . $button_insert . ' &nbsp;<a href="' . shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $_GET['cID']) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  $contents[] = array('text' => '<p><br />' . TEXT_COUPONS_PRICE_TIP);
	  break;
	default:
	  if (is_object($cInfo)) {
	    $heading[] = array('text' => $cInfo->coupons_code);
	    $contents[] = array('text' => TEXT_INFO_DATE_ADDED . ': ' . shop_date_short($cInfo->coupons_date_added));
	    if ($cInfo->coupons_last_modified) {
	      $contents[] = array('text' => TEXT_INFO_LAST_MODIFIED . ': ' . shop_date_short($cInfo->coupons_last_modified));
	    }
	    if ($cInfo->expires_date >= 1) {
	      $contents[] = array('text' => TEXT_INFO_EXPIRES_DATE . ': <b>' . shop_date_short($cInfo->expires_date) . '</b>');
	    }
	    if ($cInfo->max_usage) $contents[] = array('text' => '<br />' . TEXT_INFO_MAXUSAGE . ': ' . number_format($cInfo->max_usage));
	    switch($cInfo->coupon_type) {
	      case '1':
	        $contents[] = array('text' => '<br />' . TEXT_INFO_TYPE . ': ' . TEXT_INFO_PRODUCT . ' (' . shop_get_products_name($cInfo->products_id, $languages_id) . ')');
	        break;
	      case '2':
	        $contents[] = array('text' => '<br />' . TEXT_INFO_TYPE . ': ' . TEXT_INFO_CATEGORY . ' (' . shop_get_category_name($cInfo->categories_id, $languages_id) . ')');
	        break;
	      case '3':
	        $contents[] = array('text' => '<br />' . TEXT_INFO_TYPE . ': ' . TEXT_INFO_MANUFACTURER . ' (' . shop_get_manufacturer_name($cInfo->manufacturers_id) . ')');
	        break;
	      case '4':
	        $contents[] = array('text' => '<br />' . TEXT_INFO_TYPE . ': ' . TEXT_INFO_ORDERTOTAL);
	        break;
	      case '5':
	        $contents[] = array('text' => '<br />' . TEXT_INFO_TYPE . ': ' . TEXT_INFO_FREE_SHIPPING);
	        break;
	    }
	    $contents[] = array('text' => TEXT_INFO_AMOUNT . ': ' . ((strstr($cInfo->amount, '%')) ? $cInfo->amount : $currencies->format($cInfo->amount)));
	    $contents[] = array('text' => TEXT_INFO_OVERAMOUNT . ': ' . ((strstr($cInfo->over_amount, '%')) ? $cInfo->over_amount : $currencies->format($cInfo->over_amount)));
	    $contents[] = array('align' => 'center', 'text' => '<br /><a href="javascript:popupWindow(\'' . shop_href_link(FILENAME_COUPONS_MAIL, '&cID=' . $cInfo->coupons_id) . '\',\'product_options\');">' . shop_image_button('button_email.gif', IMAGE_EMAIL) . '</a> ' . '<a href="' . shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $cInfo->coupons_id . '&action=edit') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a> ' . '<a href="' . shop_href_link(FILENAME_COUPONS, 'page=' . $_GET['page'] . '&cID=' . $cInfo->coupons_id . '&action=delete') . '">' . shop_image_button('button_delete.gif', IMAGE_DELETE) . '</a> ');
	  }
	  break;
  }
  if ( ($heading) && ($contents) ) {
	echo '            <td width="250" valign="top" class="infoBoxContent">' . UNIX_RETURN;

	$box = new box;
	echo $box->infoBox($heading, $contents);

	echo '            </td>' . UNIX_RETURN;
  }
?>
	      </tr>
	</table></td>
	</tr>
	<tr>
		<td background="images/win_div.gif" width="8" height="1"></td>
	</tr>
	<tr>
		<td align="left" valign="center" width="100%" height=17 background="images/base_bg.gif">
<?php
include('contents/footer.php');
?>
		</td>
	</tr>
</table>
  </tr>
</table>
<!-- body_eof //-->

</body>
</html>
