<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/
$see_also = 'See also: <a href="help.php?page=configuration.php&gID=9">Setting stock and packaging options</a>';
?>
<table width="100%" border="0" cellpadding="4" cellspacing="0">
<tr><td class="large">Selecting checkout options</td></tr>
<tr><td valign="top">
<blockquote><p align="justify">The "Checkout Options" section of eShox can be accessed via eShox Admin. Open a Web browser and enter the following URL: http://your-domain-or-ip/shop/admin/. Click on "Checkout Options" under "Checkout Setup" on the left "Administration" window. To enable a checkout option, select the checkout option and click the "green" button.

<p align="justify">Checkout options are displayed at checkout, on invoices and packing slips. Fields such as "Sub-total" and "Tax" are displayed on orders based on the settings defined in the "Checkout Options" admin page. Checkout options include:

<blockquote>

<p><u>Low Order Fee</u>
<p align="justify">The "Low Order Fee" option allows the store owner to charge a fee for orders under a defined amount. Once enabled, additional options include: "Order Fee For Orders Under", which should be set to the amount at which orders under will be charged a fee; "Low order fee", which should be set to the amount customers will be charged if their order is under the amount defined in the "Order Fee For Orders Under"; "Attach Order Fee On Orders Made", which can be set to "National" to only charge the fee for orders placed in the same country as the store owner, "International" to only charge the fee for international orders or "Both" to charge the fee for all orders; and "Tax Class", which can be set to charge the fee for orders matching a currently defined tax class or "None" to charge the fee to all orders.

<p><u>Shipping</u>
<p align="justify">The "Shipping" option allows the store owner to display shipping fees on orders. It is suggested that this module be enabled to allow shipping charges be paid by the customer. Once enabled, additional options include: "Allow Free Shipping" and "Free Shipping For Orders Over", which allow the store owner to offer free shipping for orders over a defined amount; "Free Shipping For Orders Made", which allows the store owner to only provide free shipping within the country, internationally or both; "Tax Class", which can be set to allow free shipping for orders matching a currently defined tax class or "None" to provide free shipping to all orders.

<p><u>Sub-Total</u>
<p align="justify">The "Sub-Total" option allows the store owner to display the sub-total of orders, which is the total amount of ordered products (not including tax or shipping).

<p><u>Tax</u>
<p align="justify">The "Tax" option allows the store owner to display the tax charge for orders matching currently defined tax classes and rates. Once enabled, additional options include: "Display Tax Groups", which allows the customer to view what the tax charges are for each tax rate currently defined. For example, if the customer orders two products, each of which having different tax rates, the customer can see what the tax charges are at each rate.

<p><u>Total</u>
<p align="justify">The "Total" option allows the store owner to display the total amount of their order. It is suggested that this module be enabled.

</blockquote>

</blockquote>

</tr>
</table>