<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  require('contents/resources.php');

define('HEADING_TITLE', 'Featured Products');

define('TABLE_HEADING_PRODUCTS', 'Products');

define('TEXT_FEATURES_PRODUCT', 'Product:');
define('TEXT_FEATURES_EXPIRES_DATE', 'Expiry Date:');

define('TEXT_EDIT_INTRO', 'Please make any necessary changes');
define('TEXT_NEW_INTRO', 'Please fill out the following information for the featured product');
define('TEXT_INFO_DATE_ADDED', 'Date Added:');
define('TEXT_INFO_LAST_MODIFIED', 'Last Modified:');
define('TEXT_INFO_PERCENTAGE', 'Percentage:');
define('TEXT_INFO_EXPIRES_DATE', 'Expires At:');
define('TEXT_INFO_DELETE_INTRO', 'Are you sure you want to delete this feature? &nbsp;');

define('TEXT_INFO_HEADING_DELETE_FEATURES', 'Delete Feature');

  $currencies = new currencies();

  switch ($_GET['action']) {
	case 'insert':
	  $expires_date = ($_POST['expires_date']['year'] . '-' . $_POST['expires_date']['month'] . '-' . $_POST['expires_date']['day']);

	  shop_db_query("insert into " . DB_PREFIX . "features (products_id, features_date_added, expires_date) values ('" . $_POST['products_id'] . "', now(), '$expires_date')");
	  shop_redirect(shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page']));
	  break;
	case 'update':
	  $expires_date = ($_POST['expires_date']['year'] . '-' . $_POST['expires_date']['month'] . '-' . $_POST['expires_date']['day']);

	  shop_db_query("update " . DB_PREFIX . "features set features_last_modified = now(), expires_date = '$expires_date' where features_id = '" . $_POST['features_id'] . "'");
	  shop_redirect(shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page'] . '&fID=' . $_POST['features_id']));
	  break;
	case 'deleteconfirm':
	  $features_id = ($_GET['fID']);

	  shop_db_query("delete from " . DB_PREFIX . "features where features_id = '" . ($features_id) . "'");

	  shop_redirect(shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page']));
	  break;
  }

?><html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>eShox: <?php echo HEADING_TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="contents/stylesheet.css">
<script language="JavaScript" src="contents/eshox_os/scripts.js" type="text/javascript"></script>
<?php
  if ( ($_GET['action'] == 'new') || ($_GET['action'] == 'edit') ) {

  }
?>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="333333">
<!-- header //-->
<!-- header_eof //-->

<!-- body //-->
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<?php
$help_page = 'product_specials.php';
include('contents/header.php');
?>
</table><table border="0" width="100%" cellspacing="8" cellpadding="1" bgcolor="333333">
  <tr>
	<td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="160" cellspacing="0" cellpadding="0">
<!-- left_navigation //-->
<?php require('contents/navbar.php'); ?>
<!-- left_navigation_eof //-->
	</table></td>
<!-- body_text //-->
	<td width="100%" valign="top">
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	        <td><img src="images/win_header_left.gif" width="8" height="22"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="index.php"><img src="images/close.gif" width="13" height="14" border="0"></a></td>
	        <td width="6" align="left" valign="center" background="images/win_header_bg.gif"><img src="images/pixel_trans.gif" border="0" width="6" height="14"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="<?php echo MYSELF . '?page_toggle=true'; ?>"><img src="images/max.gif" width="13" height="14" border="0"></a></td>
	        <td class="windowHeading" align="center" valign="center" height="22" width="100%" background="images/win_header_bg.gif"><?php echo HEADING_TITLE; ?></td>
	        <td width="34" background="images/win_header_bg.gif"></td>
	        <td><img src="images/win_header_right.gif" width="8" height="22"></td>
	    </tr>
	</table>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td width="100%" background="images/win_header_column.gif">
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
	      <tr>
	        <td valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td height="17" valign="center" class="dataTableContent"> &nbsp; <?php echo TABLE_HEADING_PRODUCTS; ?></td>
	            <td height="17" valign="center" class="dataTableContent" align="right">&nbsp;</td>
	          </tr>
<?php
	$features_query_raw = "select p.products_id, pd.products_name, f.features_id, f.features_date_added, f.features_last_modified, f.expires_date from " . DB_PREFIX . "products p, " . DB_PREFIX . "features f, " . DB_PREFIX . "products_description pd where p.products_id = pd.products_id and pd.language_id = '$languages_id' and p.products_id = f.products_id order by pd.products_name";
	$features_split = new splitPageResults($_GET['page'], CFG_ADMIN_ITEMS_PAGE, $features_query_raw, $features_query_numrows);
	$features_query = shop_db_query($features_query_raw);
	while ($features = shop_db_fetch_array($features_query)) {
	  if (!is_object($fInfo) && (!($_GET['fID'] || $_GET['action'] == 'new') || $_GET['fID'] == $features['features_id'])) {
	    $fInfo = new objectInfo($features);
	  }
	  if (is_object($fInfo) && $features['features_id'] == $fInfo->features_id) {
	    echo '                  <tr class="dataTableRowSelected">' . UNIX_RETURN;
	  } else {
	    echo '                  <tr class="dataTableRow" onmouseover="thif.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page'] . '&fID=' . $features['features_id']) . '\'">' . UNIX_RETURN;
	  }
?>
	            <td  class="dataTableContent" height="20"> &nbsp; <?php echo $features['products_name']; ?></td>
	            <td class="dataTableContent" align="right"><?php 
if (is_object($fInfo) && $features['features_id'] == $fInfo->features_id) echo shop_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', ''); ?></td>
	  </tr>
<?php

}
?>
	          <tr>
	            <td colspan="4">
	              <table border="0" width="100%" cellpadding="0"cellspacing="4">
	                <tr>
	                  <td class="smallText" valign="top"><?php echo $features_split->display_count($features_query_numrows, CFG_ADMIN_ITEMS_PAGE, $_GET['page'], TEXT_DISPLAY_NUMBER_OF_FEATURES); ?></td>
	                  <td class="smallText" align="right"><?php echo $features_split->display_links($features_query_numrows, CFG_ADMIN_ITEMS_PAGE, MAX_DISPLAY_PAGE_LINKS, $_GET['page']); ?></td>
	                </tr>
	              </table>
	            </td>
	          </tr>
<?php
  if (!$_GET['action']) {
?>
	              <tr> 
	                <td colspan="4" align="right"><?php echo '<a href="' . shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page'] . '&action=new') . '">' . shop_image_button('button_insert.gif', IMAGE_INSERT) . '</a>&nbsp;'; ?></td>
	              </tr>
<?php
  }
?>
	        </table></td>
<?php
  $heading = array();
  $contents = array();
  switch ($_GET['action']) {
	case 'delete':
	  $heading[] = array('text' => TEXT_INFO_HEADING_DELETE_FEATURES);

	  $contents = array('form' => shop_draw_form('features', FILENAME_FEATURES, 'page=' . $_GET['page'] . '&fID=' . $fInfo->features_id . '&action=deleteconfirm'));
	  $contents[] = array('text' => TEXT_INFO_DELETE_INTRO);
	  $contents[] = array('text' => '<br /><b>' . $fInfo->products_name . '</b>');
	  $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_delete.gif', IMAGE_DELETE) . '&nbsp;<a href="' . shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page'] . '&fID=' . $fInfo->features_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  break;
	case 'new':
	case 'edit':

	  if ($_GET['action'] == 'new') {
	    $features_array = array();
	    $features_query = shop_db_query("select p.products_id from " . DB_PREFIX . "products p left join " . DB_PREFIX . "features f on f.products_id = p.products_id where f.products_id = p.products_id or f.products_id = NULL");
	    while ($features = shop_db_fetch_array($features_query)) $features_array[] = $features['products_id'];
		unset($fInfo);
	    $heading[] = array('text' => 'New Featured Product');
	    $contents[] = array('text' => TEXT_NEW_INTRO . shop_draw_form('new_feature', FILENAME_FEATURES, shop_get_all_get_params(array('fID', 'action', 'info')) . '&action=insert'));
	    $contents[] = array('text' => 'Product: ' . shop_draw_products_pull_down('products_id', 'style="font-size:10px"', $features_array));
	  } else {
	    $heading[] = array('text' => $fInfo->products_name);
	    $contents[] = array('text' => TEXT_EDIT_INTRO . shop_draw_form('edit_feature', FILENAME_FEATURES, shop_get_all_get_params(array('fID', 'action', 'info')) . 'fID=' . $fInfo->features_id . '&action=update'));
	  }
	  $contents[] = array('text' => TEXT_FEATURES_EXPIRES_DATE . '<br />' . shop_draw_date_input('expires_date', $fInfo->expires_date, false));
	  if ($_GET['action'] == 'new') {
	    $button_insert = shop_image_submit('button_insert.gif', IMAGE_INSERT);
	  } else {
	    $button_insert = shop_draw_hidden_field('features_id', $_GET['fID']) . shop_image_submit('button_update.gif', IMAGE_UPDATE);
	  }
	  $contents[] = array('align' => 'center', 'text' => '<br />' . $button_insert . ' &nbsp;<a href="' . shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page'] . '&fID=' . $_GET['fID']) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  break;
	default:
	  if (is_object($fInfo)) {
	    $heading[] = array('text' => $fInfo->products_name);
	    $contents[] = array('text' => TEXT_INFO_DATE_ADDED . ' ' . shop_date_short($fInfo->features_date_added));
	    if ($fInfo->features_last_modified) {
	      $contents[] = array('text' => TEXT_INFO_LAST_MODIFIED . ' ' . shop_date_short($fInfo->features_last_modified));
	    }
	    if ($fInfo->expires_date >= 1) {
	      $contents[] = array('text' => TEXT_INFO_EXPIRES_DATE . ' <b>' . shop_date_short($fInfo->expires_date));
	    }
	    $contents[] = array('align' => 'center', 'text' => '<br /><a href="' . shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page'] . '&fID=' . $fInfo->features_id . '&action=edit') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a> <a href="' . shop_href_link(FILENAME_FEATURES, 'page=' . $_GET['page'] . '&fID=' . $fInfo->features_id . '&action=delete') . '">' . shop_image_button('button_delete.gif', IMAGE_DELETE) . '</a>');
	  }
	  break;
  }
  if ( ($heading) && ($contents) ) {
	echo '            <td width="250" valign="top" class="infoBoxContent">' . UNIX_RETURN;

	$box = new box;
	echo $box->infoBox($heading, $contents);

	echo '            </td>' . UNIX_RETURN;
  }
?>
	      </tr>
	</table></td>
	</tr>
	<tr>
		<td background="images/win_div.gif" width="8" height="1"></td>
	</tr>
	<tr>
		<td align="left" valign="center" width="100%" height="17" background="images/base_bg.gif">
<?php
include('contents/footer.php');
?>
		</td>
	</tr>
</table>
  </tr>
</table>
<!-- body_eof //-->

</body>
</html>
