<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  require('contents/resources.php');

define('HEADING_TITLE', 'Tax Rates');

define('TABLE_HEADING_TAX_RATE_PRIORITY', 'Priority');
define('TABLE_HEADING_TAX_CLASS_TITLE', 'Tax Class');
define('TABLE_HEADING_COUNTRIES_NAME', 'Country');
define('TABLE_HEADING_ZONE', 'Zone');
define('TABLE_HEADING_TAX_RATE', 'Tax Rate');

define('TEXT_INFO_EDIT_INTRO', 'Please make any necessary changes');
define('TEXT_INFO_DATE_ADDED', 'Date Added:');
define('TEXT_INFO_LAST_MODIFIED', 'Last Modified:');
define('TEXT_INFO_CLASS_TITLE', 'Tax Class Title:');
define('TEXT_INFO_COUNTRY_NAME', 'Country:');
define('TEXT_INFO_ZONE_NAME', 'Zone:');
define('TEXT_INFO_TAX_RATE', 'Tax Rate (%):');
define('TEXT_INFO_RATE_DESCRIPTION', 'Description:');
define('TEXT_INFO_INSERT_INTRO', 'Please enter the new tax class with its related data');
define('TEXT_INFO_DELETE_INTRO', 'Are you sure you want to delete this tax rate?');
define('TEXT_INFO_HEADING_NEW_TAX_RATE', 'New Tax Rate');
define('TEXT_INFO_HEADING_EDIT_TAX_RATE', 'Edit Tax Rate');
define('TEXT_INFO_HEADING_DELETE_TAX_RATE', 'Delete Tax Rate');

if ($_GET['action']) {
	switch ($_GET['action']) {
	  case 'insert':
	    $tax_zone_id = ($_POST['tax_zone_id']);
	    $tax_class_id = ($_POST['tax_class_id']);
	    $tax_rate = ($_POST['tax_rate']);
	    $tax_description = ($_POST['tax_description']);
	    $date_added = ($_POST['date_added']);

	    shop_db_query("insert into " . DB_PREFIX . "tax_rates (tax_zone_id, tax_class_id, tax_rate, tax_description, date_added) values ('" . ($tax_zone_id) . "', '" . ($tax_class_id) . "', '" . ($tax_rate) . "', '" . ($tax_description) . "', now())");
	    shop_redirect(shop_href_link(FILENAME_TAX_RATES));
	    break;
	  case 'save':
	    $tax_rates_id = ($_GET['tID']);
	    $tax_zone_id = ($_POST['tax_zone_id']);
	    $tax_class_id = ($_POST['tax_class_id']);
	    $tax_rate = ($_POST['tax_rate']);
	    $tax_description = ($_POST['tax_description']);
	    $last_modified = ($_POST['last_modified']);

	    shop_db_query("update " . DB_PREFIX . "tax_rates set tax_zone_id = '" . ($tax_zone_id) . "', tax_class_id = '" . ($tax_class_id) . "', tax_rate = '" . ($tax_rate) . "', tax_description = '" . ($tax_description) . "', last_modified = now() where tax_rates_id = '" . ($tax_rates_id) . "'");
	    shop_redirect(shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $tax_rates_id));
	    break;
	  case 'deleteconfirm':
	    $tax_rates_id = ($_GET['tID']);

	    shop_db_query("delete from " . DB_PREFIX . "tax_rates where tax_rates_id = '" . ($tax_rates_id) . "'");
	    shop_redirect(shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page']));
	    break;
	}
}

?><html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>eShox: <?php echo HEADING_TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="contents/stylesheet.css">
<script language="JavaScript" src="contents/eshox_os/scripts.js" type="text/javascript"></script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="333333">
<!-- header //-->
<!-- header_eof //-->

<!-- body //-->
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<?php
$help_page = 'tax.php';
include('contents/header.php');
?>
</table><table border="0" width="100%" cellspacing="8" cellpadding="1" bgcolor="333333">
  <tr>
	<td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="160" cellspacing="0" cellpadding="0">
<!-- left_navigation //-->
<?php require('contents/navbar.php'); ?>
<!-- left_navigation_eof //-->
	</table></td>
<!-- body_text //-->
	<td width="100%" valign="top">
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	        <td><img src="images/win_header_left.gif" width="8" height="22"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="index.php"><img src="images/close.gif" width="13" height="14" border="0"></a></td>
	        <td width="6" align="left" valign="center" background="images/win_header_bg.gif"><img src="images/pixel_trans.gif" border="0" width="6" height="14"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="<?php echo MYSELF . '?page_toggle=true'; ?>"><img src="images/max.gif" width="13" height="14" border="0"></a></td>
	        <td class="windowHeading" align="center" valign="center" height="22" width="100%" background="images/win_header_bg.gif"><?php echo HEADING_TITLE; ?></td>
	        <td width="34" background="images/win_header_bg.gif"></td>
	        <td><img src="images/win_header_right.gif" width="8" height="22"></td>
	    </tr>
	</table>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td width="100%" background="images/win_header_column.gif"><table border="0" width="100%" cellspacing="0" cellpadding="0">
	  <tr>
	    <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
	      <tr>
	        <td valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td height="17" valign="center" class="dataTableContent"> &nbsp; <?php echo TABLE_HEADING_TAX_RATE; ?></td>
	            <td height="17" valign="center" class="dataTableContent"><?php echo TABLE_HEADING_TAX_CLASS_TITLE; ?></td>
	            <td height="17" valign="center" class="dataTableContent"><?php echo TABLE_HEADING_ZONE; ?></td>
	            <td height="17" valign="center" class="dataTableContent" align="right">&nbsp;</td>
	          </tr>
<?php
  $rates_query_raw = "select r.tax_rates_id, z.geo_zone_id, z.geo_zone_name, tc.tax_class_title, tc.tax_class_id, r.tax_rate, r.tax_description, r.date_added, r.last_modified from " . DB_PREFIX . "tax_class tc, " . DB_PREFIX . "tax_rates r left join " . DB_PREFIX . "geo_zones z on r.tax_zone_id = z.geo_zone_id where r.tax_class_id = tc.tax_class_id";
  $rates_split = new splitPageResults($_GET['page'], CFG_ADMIN_ITEMS_PAGE, $rates_query_raw, $rates_query_numrows);
  $rates_query = shop_db_query($rates_query_raw);
  while ($rates = shop_db_fetch_array($rates_query)) {
	if (((!$_GET['tID']) || (@$_GET['tID'] == $rates['tax_rates_id'])) && (!$trInfo) && (substr($_GET['action'], 0, 3) != 'new')) {
	  $trInfo = new objectInfo($rates);
	}

	if ( (is_object($trInfo)) && ($rates['tax_rates_id'] == $trInfo->tax_rates_id) ) {
	  echo '              <tr class="dataTableRowSelected" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $trInfo->tax_rates_id . '&action=edit') . '\'">' . UNIX_RETURN;
	} else {
	  echo '              <tr class="dataTableRow" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $rates['tax_rates_id']) . '\'">' . UNIX_RETURN;
	}
?>
	            <td class="dataTableContent" height="20"> &nbsp; <?php echo shop_display_tax_value($rates['tax_rate']); ?>%</td>
	            <td class="dataTableContent"><?php echo $rates['tax_class_title']; ?></td>
	            <td class="dataTableContent"><?php echo $rates['geo_zone_name']; ?></td>
	            <td class="dataTableContent" align="right"><?php if ( (is_object($trInfo)) && ($rates['tax_rates_id'] == $trInfo->tax_rates_id) ) { echo shop_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', ''); } else { echo '<a href="' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $rates['tax_rates_id']) . '"></a>'; } ?></td>
	          </tr>
<?php
  }
?>
	          <tr>
	            <td colspan="5">
	              <table border="0" width="100%" cellspacing="0" cellpadding="4">
	                <tr>
	                  <td class="smallText" valign="top"><?php echo $rates_split->display_count($rates_query_numrows, CFG_ADMIN_ITEMS_PAGE, $_GET['page'], TEXT_DISPLAY_NUMBER_OF_TAX_RATES); ?></td>
	                  <td class="smallText" align="right"><?php echo $rates_split->display_links($rates_query_numrows, CFG_ADMIN_ITEMS_PAGE, MAX_DISPLAY_PAGE_LINKS, $_GET['page']); ?></td>
	                </tr>
	              </table>
	            </td>
	          </tr>
<?php
  if (!$_GET['action']) {
?>
	              <tr>
	                <td colspan="5" align="right"><?php echo '<a href="' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&action=new') . '">' . shop_image_button('button_insert.gif', IMAGE_NEW_TAX_RATE) . '</a>&nbsp;'; ?></td>
	              </tr>
<?php
  }
?>
	        </table></td>
<?php
  $heading = array();
  $contents = array();
  switch ($_GET['action']) {
	case 'new':
	  $heading[] = array('text' => TEXT_INFO_HEADING_NEW_TAX_RATE);

	  $contents = array('form' => shop_draw_form('rates', FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&action=insert'));
	  $contents[] = array('text' => TEXT_INFO_INSERT_INTRO);
	  $contents[] = array('text' => '<br />' . TEXT_INFO_CLASS_TITLE . '<br />' . shop_tax_classes_pull_down('name="tax_class_id" style="font-size:10px"'));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_ZONE_NAME . '<br />' . shop_geo_zones_pull_down('name="tax_zone_id" style="font-size:10px"'));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_TAX_RATE . '<br />' . shop_draw_input_field('tax_rate'));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_RATE_DESCRIPTION . '<br />' . shop_draw_input_field('tax_description','','maxlength="64"'));
	  $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_insert.gif', IMAGE_INSERT) . '&nbsp;<a href="' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page']) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  break;
	case 'edit':
	  $heading[] = array('text' => TEXT_INFO_HEADING_EDIT_TAX_RATE);

	  $contents = array('form' => shop_draw_form('rates', FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $trInfo->tax_rates_id  . '&action=save'));
	  $contents[] = array('text' => TEXT_INFO_EDIT_INTRO);
	  $contents[] = array('text' => '<br />' . TEXT_INFO_CLASS_TITLE . '<br />' . shop_tax_classes_pull_down('name="tax_class_id" style="font-size:10px"', $trInfo->tax_class_id));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_ZONE_NAME . '<br />' . shop_geo_zones_pull_down('name="tax_zone_id" style="font-size:10px"', $trInfo->geo_zone_id));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_TAX_RATE . '<br />' . shop_draw_input_field('tax_rate', $trInfo->tax_rate));
	  $contents[] = array('text' => '<br />' . TEXT_INFO_RATE_DESCRIPTION . '<br />' . shop_draw_input_field('tax_description', $trInfo->tax_description,'maxlength="64"'));
	  $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_update.gif', IMAGE_UPDATE) . '&nbsp;<a href="' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $trInfo->tax_rates_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  break;
	case 'delete':
	  $heading[] = array('text' => TEXT_INFO_HEADING_DELETE_TAX_RATE);

	  $contents = array('form' => shop_draw_form('rates', FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $trInfo->tax_rates_id  . '&action=deleteconfirm'));
	  $contents[] = array('text' => TEXT_INFO_DELETE_INTRO);
	  $contents[] = array('text' => '<br /><b>' . $trInfo->tax_class_title . ' ' . number_format($trInfo->tax_rate, TAX_DECIMAL_PLACES) . '%</b>');
	  $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_delete.gif', IMAGE_DELETE) . '&nbsp;<a href="' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $trInfo->tax_rates_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  break;
	default:
	  if (is_object($trInfo)) {
	    $heading[] = array('text' => $trInfo->tax_class_title);
	    $contents[] = array('text' => TEXT_INFO_RATE_DESCRIPTION . ' ' . $trInfo->tax_description);
	    $contents[] = array('align' => 'center', 'text' => '<br /><a href="' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $trInfo->tax_rates_id . '&action=edit') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a> <a href="' . shop_href_link(FILENAME_TAX_RATES, 'page=' . $_GET['page'] . '&tID=' . $trInfo->tax_rates_id . '&action=delete') . '">' . shop_image_button('button_delete.gif', IMAGE_DELETE) . '</a>');
	  }
	  break;
  }

  if ( ($heading) && ($contents) ) {
	echo '            <td class="infoBoxContent" width="25%" valign="top">' . UNIX_RETURN;

	$box = new box;
	echo $box->infoBox($heading, $contents);

	echo '            </td>' . UNIX_RETURN;
  }
?>
	      </tr>
	    </table></td>
	  </tr>
	</table></td>
	</tr>
	<tr>
		<td background="images/win_div.gif" width="8" height="1"></td>
	</tr>
	<tr>
		<td align="left" valign="center" width="100%" height="14" background="images/base_bg.gif">
<?php
include('contents/footer.php');
?>
		</td>
	</tr>
</table>
<!-- body_eof //-->
</body>
</html>
