<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

require('contents/resources.php');

define('HEADING_TITLE', 'Tax Zones');

define('TABLE_HEADING_COUNTRY', 'Country');
define('TABLE_HEADING_COUNTRY_ZONE', 'Zone');
define('TABLE_HEADING_TAX_ZONES', 'Tax Zones');

define('TEXT_INFO_HEADING_NEW_ZONE', 'New Zone');
define('TEXT_INFO_NEW_ZONE_INTRO', 'Please enter the new zone information');

define('TEXT_INFO_HEADING_EDIT_ZONE', 'Edit Zone');
define('TEXT_INFO_EDIT_ZONE_INTRO', 'Please make any necessary changes');

define('TEXT_INFO_HEADING_DELETE_ZONE', 'Delete Zone');
define('TEXT_INFO_DELETE_ZONE_INTRO', 'Are you sure you want to delete this zone?');

define('TEXT_INFO_HEADING_NEW_SUB_ZONE', 'New Sub Zone');
define('TEXT_INFO_NEW_SUB_ZONE_INTRO', 'Please enter the new sub zone information');

define('TEXT_INFO_HEADING_EDIT_SUB_ZONE', 'Edit Sub Zone');
define('TEXT_INFO_EDIT_SUB_ZONE_INTRO', 'Please make any necessary changes');

define('TEXT_INFO_HEADING_DELETE_SUB_ZONE', 'Delete Sub Zone');
define('TEXT_INFO_DELETE_SUB_ZONE_INTRO', 'Are you sure you want to delete this sub zone?');

define('TEXT_INFO_SUBZONE_SUGGESTION', '<font color="aa4400">It is suggested that you now add a sub-zone (country/state) to this zone</a>');

define('TEXT_INFO_DATE_ADDED', 'Date Added:');
define('TEXT_INFO_LAST_MODIFIED', 'Last Modified:');
define('TEXT_INFO_ZONE_NAME', 'Zone Name:');
define('TEXT_INFO_ZONE_DESCRIPTION', 'Description:');
define('TEXT_INFO_COUNTRY', 'Country:');
define('TEXT_INFO_COUNTRY_ZONE', 'Zone:');
define('TYPE_BELOW', 'All Zones');
define('PLEASE_SELECT', 'All Zones');
define('TEXT_ALL_COUNTRIES', 'All Countries');

  switch ($_GET['saction']) {
	case 'insert_sub':
	  $zID = ($_GET['zID']);
	  $zone_country_id = ($_POST['zone_country_id']);
	  $zone_id = ($_POST['zone_id']);

	  $new_subzone_id = shop_db_query("insert into " . DB_PREFIX . "zones_to_geo_zones (zone_country_id, zone_id, geo_zone_id, date_added) values ('" . ($zone_country_id) . "', '" . ($zone_id) . "', '" . ($zID) . "', now())");

	  shop_redirect(shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $new_subzone_id));
	  break;
	case 'save_sub':
	  $sID = ($_GET['sID']);
	  $zID = ($_GET['zID']);
	  $zone_country_id = ($_POST['zone_country_id']);
	  $zone_id = ($_POST['zone_id']);

	  shop_db_query("update " . DB_PREFIX . "zones_to_geo_zones set geo_zone_id = '" . ($zID) . "', zone_country_id = '" . ($zone_country_id) . "', zone_id = " . ((($zone_id)) ? "'" . ($zone_id) . "'" : 'null') . ", last_modified = now() where association_id = '" . ($sID) . "'");

	  shop_redirect(shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $_GET['sID']));
	  break;
	case 'deleteconfirm_sub':
	  $sID = ($_GET['sID']);

	  shop_db_query("delete from " . DB_PREFIX . "zones_to_geo_zones where association_id = '" . ($sID) . "'");

	  shop_redirect(shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage']));
	  break;
  }

  switch ($_GET['action']) {
	case 'insert_zone':
	  $geo_zone_name = ($_POST['geo_zone_name']);
	  $geo_zone_description = ($_POST['geo_zone_description']);

	  $new_zone_id = shop_db_query("insert into " . DB_PREFIX . "geo_zones (geo_zone_name, geo_zone_description, date_added) values ('" . ($geo_zone_name) . "', '" . ($geo_zone_description) . "', now())");

	  shop_redirect(shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $new_zone_id . '&action=list&saction=new&new_zone_message=true'));
	  break;
	case 'save_zone':
	  $zID = ($_GET['zID']);
	  $geo_zone_name = ($_POST['geo_zone_name']);
	  $geo_zone_description = ($_POST['geo_zone_description']);

	  shop_db_query("update " . DB_PREFIX . "geo_zones set geo_zone_name = '" . ($geo_zone_name) . "', geo_zone_description = '" . ($geo_zone_description) . "', last_modified = now() where geo_zone_id = '" . ($zID) . "'");

	  shop_redirect(shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID']));
	  break;
	case 'deleteconfirm_zone':
	  $zID = ($_GET['zID']);

	  shop_db_query("delete from " . DB_PREFIX . "geo_zones where geo_zone_id = '" . ($zID) . "'");
	  shop_db_query("delete from " . DB_PREFIX . "zones_to_geo_zones where geo_zone_id = '" . ($zID) . "'");

	  shop_redirect(shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage']));
	  break;
  }

?><html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>eShox: <?php echo HEADING_TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="contents/stylesheet.css">
<script language="JavaScript" src="contents/eshox_os/scripts.js" type="text/javascript"></script>
<?php
  if ($_GET['zID']  && (($_GET['saction'] == 'edit') || ($_GET['saction'] == 'new'))) {
?>
<script language="javascript"><!--
function resetZoneSelected(theForm) {
  if (theForm.state.value != '') {
	theForm.zone_id.selectedIndex = '0';
	if (theForm.zone_id.options.length > 0) {
	  theForm.state.value = '-- Select Above --';
	}
  }
}

function update_zone(theForm) {
  var NumState = theForm.zone_id.options.length;
  var SelectedCountry = "";

  while(NumState > 0) {
	NumState--;
	theForm.zone_id.options[NumState] = null;
  }         

  SelectedCountry = theForm.zone_country_id.options[theForm.zone_country_id.selectedIndex].value;

<?php echo shop_js_zone_list('SelectedCountry', 'theForm', 'zone_id'); ?>

}
//--></script>
<?php
  }
?>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="333333">
<!-- header //-->
<!-- header_eof //-->

<!-- body //-->
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<?php
$help_page = 'tax.php';
include('contents/header.php');
?>
</table><table border="0" width="100%" cellspacing="8" cellpadding="1" bgcolor="333333">
  <tr>
	<td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="160" cellspacing="0" cellpadding="0">
<!-- left_navigation //-->
<?php require('contents/navbar.php'); ?>
<!-- left_navigation_eof //-->
	</table></td>
<!-- body_text //-->
	<td width="100%" valign="top">
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	        <td><img src="images/win_header_left.gif" width="8" height="22"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="index.php"><img src="images/close.gif" width="13" height="14" border="0"></a></td>
	        <td width="6" align="left" valign="center" background="images/win_header_bg.gif"><img src="images/pixel_trans.gif" border="0" width="6" height="14"></td>
	        <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="<?php echo MYSELF . '?page_toggle=true'; ?>"><img src="images/max.gif" width="13" height="14" border="0"></a></td>
	        <td class="windowHeading" align="center" valign="center" height="22" width="100%" background="images/win_header_bg.gif"><?php echo HEADING_TITLE; ?></td>
	        <td width="34" background="images/win_header_bg.gif"></td>
	        <td><img src="images/win_header_right.gif" width="8" height="22"></td>
	    </tr>
	</table>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td width="100%" background="images/win_header_column.gif"><table border="0" width="100%" cellspacing="0" cellpadding="0">
	  <tr>
	        <td valign="top">
<?php
  if ($_GET['action'] == 'list') {
?>
	        <table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td height="17" valign="center" class="dataTableContent"> &nbsp; <?php echo TABLE_HEADING_COUNTRY_ZONE; ?></td>
	            <td height="17" valign="center" class="dataTableContent"><?php echo TABLE_HEADING_COUNTRY; ?></td>
	            <td height="17" valign="center" class="dataTableContent">&nbsp;</td>
	          </tr>
<?php
	$rows = 0;
	$zones_query_raw = "select a.association_id, a.zone_country_id, c.countries_name, a.zone_id, a.geo_zone_id, a.last_modified, a.date_added, z.zone_name from " . DB_PREFIX . "zones_to_geo_zones a left join " . DB_PREFIX . "countries c on a.zone_country_id = c.countries_id left join " . DB_PREFIX . "zones z on a.zone_id = z.zone_id where a.geo_zone_id = " . $_GET['zID'] . " order by association_id";
	$zones_split = new splitPageResults($_GET['spage'], CFG_ADMIN_ITEMS_PAGE, $zones_query_raw, $zones_query_numrows);
	$zones_query = shop_db_query($zones_query_raw);
	while ($zones = shop_db_fetch_array($zones_query)) {
	  $rows++;
	  if (((!$_GET['sID']) || (@$_GET['sID'] == $zones['association_id'])) && (!$sInfo) && (substr($_GET['saction'], 0, 3) != 'new')) {
	    $sInfo = new objectInfo($zones);
	  }
	  if ( (is_object($sInfo)) && ($zones['association_id'] == $sInfo->association_id) ) {
	    echo '                  <tr class="dataTableRowSelected">' . UNIX_RETURN;
	  } else {
	    echo '                  <tr class="dataTableRow" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $zones['association_id']) . '\'">' . UNIX_RETURN;
	  }
?>
	            <td class="dataTableContent" height="20"> &nbsp; <?php echo (($zones['zone_id']) ? $zones['zone_name'] : PLEASE_SELECT); ?></td>
	            <td class="dataTableContent"><?php echo (($zones['countries_name']) ? $zones['countries_name'] : TEXT_ALL_COUNTRIES); ?></td>
	            <td class="dataTableContent" align="right"><?php if ( (is_object($sInfo)) && ($zones['association_id'] == $sInfo->association_id) ) { echo shop_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', ''); } else { echo '<a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $zones['association_id']) . '"></a>'; } ?></td>
	          </tr>
<?php
	}
?>
	          <tr>
	            <td colspan="3">
	              <table border="0" width="100%" cellspacing="0" cellpadding="4">
	                <tr>
	                  <td class="smallText" valign="top"><?php echo $zones_split->display_count($zones_query_numrows, CFG_ADMIN_ITEMS_PAGE, $_GET['spage'], TEXT_DISPLAY_NUMBER_OF_ZONES); ?></td>
	                  <td class="smallText" align="right"><?php echo $zones_split->display_links($zones_query_numrows, CFG_ADMIN_ITEMS_PAGE, MAX_DISPLAY_PAGE_LINKS, $_GET['spage'], 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list', 'spage'); ?></td>
	                </tr>
	              </table>
	            </td>
	          </tr>
	          <tr>
	            <td align="right" colspan="3"><?php if (!$_GET['saction']) echo '<a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID']) . '">' . shop_image_button('button_back.gif', IMAGE_BACK) . '</a>&nbsp;<a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $sInfo->association_id . '&saction=new') . '">' . shop_image_button('button_insert.gif', IMAGE_INSERT) . '</a>&nbsp;'; ?></td>
	          </tr>
<?php
  } else {
?>
	        <table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td height="17" colspan="2" valign="center" class="dataTableContent"> &nbsp; <?php echo TABLE_HEADING_TAX_ZONES; ?></td>
	            <td height="17" valign="center" class="dataTableContent" align="right">&nbsp;</td>
	          </tr>
<?php
	$zones_query_raw = "select geo_zone_id, geo_zone_name, geo_zone_description, last_modified, date_added from " . DB_PREFIX . "geo_zones order by geo_zone_name";
	$zones_split = new splitPageResults($_GET['zpage'], CFG_ADMIN_ITEMS_PAGE, $zones_query_raw, $zones_query_numrows);
	$zones_query = shop_db_query($zones_query_raw);
	while ($zones = shop_db_fetch_array($zones_query)) {
	  if (((!$_GET['zID']) || (@$_GET['zID'] == $zones['geo_zone_id'])) && (!$zInfo) && (substr($_GET['action'], 0, 3) != 'new')) {
	    $zInfo = new objectInfo($zones);
	  }
	  if ( (is_object($zInfo)) && ($zones['geo_zone_id'] == $zInfo->geo_zone_id) ) {
	    echo '                  <tr class="dataTableRowSelected" valign="center" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id . '&action=list') . '\'">' . UNIX_RETURN;
	  } else {
	    echo '                  <tr class="dataTableRow" valign="center" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zones['geo_zone_id']) . '\'">' . UNIX_RETURN;
	  }
?>
	            <td class="dataTableContent" height="20" width="18" align="right"><img src="images/icons/folder.gif" width=16 height=16 hspace="4"></td>
	            <td class="dataTableContent" align="left"><?php echo $zones['geo_zone_name']; ?></td>
	            <td class="dataTableContent" align="right"><?php if ( (is_object($zInfo)) && ($zones['geo_zone_id'] == $zInfo->geo_zone_id) ) { echo shop_image(DIR_WS_IMAGES . 'icon_arrow_right.gif'); } else { echo '<a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zones['geo_zone_id']) . '"></a>'; } ?></td>
	          </tr>
<?php
	}
?>
	          <tr>
	            <td colspan="3">
	              <table border="0" width="100%" cellspacing="0" cellpadding="4">
	                <tr>
	                  <td class="smallText" valign="center"><?php echo $zones_split->display_count($zones_query_numrows, CFG_ADMIN_ITEMS_PAGE, $_GET['zpage'], TEXT_DISPLAY_NUMBER_OF_TAX_ZONES); ?></td>
	                  <td class="smallText" valign="center" align="right"><?php echo $zones_split->display_links($zones_query_numrows, CFG_ADMIN_ITEMS_PAGE, MAX_DISPLAY_PAGE_LINKS, $_GET['zpage'], '', 'zpage'); ?></td>
	                </tr>
	              </table>
	            </td>
	          </tr>
	          <tr>
	            <td align="right" colspan="3"><?php if (!$_GET['action']) echo '<a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id . '&action=new_zone') . '">' . shop_image_button('button_insert.gif', IMAGE_INSERT) . '</a>&nbsp;'; ?></td>
	          </tr>
<?php
  }
?>
	        </table>
	        </td>
<?php
  $heading = array();
  $contents = array();

  if ($_GET['action'] == 'list') {
	switch ($_GET['saction']) {
	  case 'new':
	    $heading[] = array('text' => TEXT_INFO_HEADING_NEW_SUB_ZONE);

	    $contents = array('form' => shop_draw_form('zones', FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $_GET['sID'] . '&saction=insert_sub'));
	    if ($_GET['new_zone_message'] == 'true') $contents[] = array('text' => TEXT_INFO_SUBZONE_SUGGESTION);
	    $contents[] = array('text' => TEXT_INFO_NEW_SUB_ZONE_INTRO);
	    $contents[] = array('text' => '<br />' . TEXT_INFO_COUNTRY . '<br />' . shop_draw_pull_down_menu('zone_country_id', shop_get_countries(TEXT_ALL_COUNTRIES), '', 'onChange="update_zone(this.form);"'));
	    $contents[] = array('text' => '<br />' . TEXT_INFO_COUNTRY_ZONE . '<br />' . shop_draw_pull_down_menu('zone_id', shop_prepare_country_zones_pull_down()));
	    $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_insert.gif', IMAGE_INSERT) . ' <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $_GET['sID']) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	    break;
	  case 'edit':
	    $heading[] = array('text' => TEXT_INFO_HEADING_EDIT_SUB_ZONE);

	    $contents = array('form' => shop_draw_form('zones', FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $sInfo->association_id . '&saction=save_sub'));
	    $contents[] = array('text' => TEXT_INFO_EDIT_SUB_ZONE_INTRO);
	    $contents[] = array('text' => '<br />' . TEXT_INFO_COUNTRY . '<br />' . shop_draw_pull_down_menu('zone_country_id', shop_get_countries(TEXT_ALL_COUNTRIES), $sInfo->zone_country_id, 'onChange="update_zone(this.form);"'));
	    $contents[] = array('text' => '<br />' . TEXT_INFO_COUNTRY_ZONE . '<br />' . shop_draw_pull_down_menu('zone_id', shop_prepare_country_zones_pull_down($sInfo->zone_country_id), $sInfo->zone_id));
	    $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_update.gif', IMAGE_UPDATE) . ' <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $sInfo->association_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	    break;
	  case 'delete':
	    $heading[] = array('text' => TEXT_INFO_HEADING_DELETE_SUB_ZONE);

	    $contents = array('form' => shop_draw_form('zones', FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $sInfo->association_id . '&saction=deleteconfirm_sub'));
	    $contents[] = array('text' => TEXT_INFO_DELETE_SUB_ZONE_INTRO);
	    $contents[] = array('text' => '<br /><b>' . $sInfo->countries_name);
	    $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_delete.gif', IMAGE_DELETE) . ' <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $sInfo->association_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	    break;
	  default:
	    if (is_object($sInfo)) {
	      $heading[] = array('text' => $sInfo->countries_name);

	      $contents[] = array('align' => 'center', 'text' => '<a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $sInfo->association_id . '&saction=edit') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a> <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=list&spage=' . $_GET['spage'] . '&sID=' . $sInfo->association_id . '&saction=delete') . '">' . shop_image_button('button_delete.gif', IMAGE_DELETE) . '</a>');
	    }
	    break;
	}
  } else {
	switch ($_GET['action']) {
	  case 'new_zone':
	    $heading[] = array('text' => TEXT_INFO_HEADING_NEW_ZONE);

	    $contents = array('form' => shop_draw_form('zones', FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID'] . '&action=insert_zone'));
	    $contents[] = array('text' => TEXT_INFO_NEW_ZONE_INTRO);
	    $contents[] = array('text' => '<br />' . TEXT_INFO_ZONE_NAME . '<br />' . shop_draw_input_field('geo_zone_name'));
	    $contents[] = array('text' => '<br />' . TEXT_INFO_ZONE_DESCRIPTION . '<br />' . shop_draw_input_field('geo_zone_description','','maxlength="64"'));
	    $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_insert.gif', IMAGE_INSERT) . ' <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $_GET['zID']) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	    break;
	  case 'edit_zone':
	    $heading[] = array('text' => TEXT_INFO_HEADING_EDIT_ZONE);

	    $contents = array('form' => shop_draw_form('zones', FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id . '&action=save_zone'));
	    $contents[] = array('text' => TEXT_INFO_EDIT_ZONE_INTRO);
	    $contents[] = array('text' => '<br />' . TEXT_INFO_ZONE_NAME . '<br />' . shop_draw_input_field('geo_zone_name', $zInfo->geo_zone_name));
	    $contents[] = array('text' => '<br />' . TEXT_INFO_ZONE_DESCRIPTION . '<br />' . shop_draw_input_field('geo_zone_description', $zInfo->geo_zone_description,'maxlength="64"'));
	    $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_update.gif', IMAGE_UPDATE) . ' <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	    break;
	  case 'delete_zone':
	    $heading[] = array('text' => TEXT_INFO_HEADING_DELETE_ZONE);

	    $contents = array('form' => shop_draw_form('zones', FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id . '&action=deleteconfirm_zone'));
	    $contents[] = array('text' => TEXT_INFO_DELETE_ZONE_INTRO);
	    $contents[] = array('text' => '<br /><b>' . $zInfo->geo_zone_name);
	    $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_delete.gif', IMAGE_DELETE) . ' <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	    break;
	  default:
	    if (is_object($zInfo)) {
	      $heading[] = array('text' => $zInfo->geo_zone_name);

	      $contents[] = array('text' => TEXT_INFO_ZONE_DESCRIPTION . ' ' . $zInfo->geo_zone_description);
	      $contents[] = array('align' => 'center', 'text' => '<br /><a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id . '&action=edit_zone') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a> <a href="' . shop_href_link(FILENAME_GEO_ZONES, 'zpage=' . $_GET['zpage'] . '&zID=' . $zInfo->geo_zone_id . '&action=delete_zone') . '">' . shop_image_button('button_delete.gif', IMAGE_DELETE) . '</a>');
	    }
	    break;
	}
  }

  if ( ($heading) && ($contents) ) {
	echo '            <td class="infoBoxContent" width="25%" valign="top">' . UNIX_RETURN;

	$box = new box;
	echo $box->infoBox($heading, $contents);

	echo '            </td>' . UNIX_RETURN;
  }
?>
	      </tr>
	</table></td>
	</tr>
	<tr>
		<td background="images/win_div.gif" width="8" height="1"></td>
	</tr>
	<tr>
		<td align="left" valign="center" width="100%" height="14" background="images/base_bg.gif">
<?php
include('contents/footer.php');
?>
		</td>
	</tr>
</table>
<!-- body_eof //-->
</body>
</html>
