<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

require('contents/resources.php');

header('Pragma: no-cache');
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);

define('HEADING_TITLE', 'Software Update');
define('ERROR_NO_FILES', 'No updates are available.');
define('FILES_NO_UPDATE', 'Files could not be updated:');
define('FILES_UPDATE', 'Files to be updated:');
define('UPDATE_COMPLETE', 'Update Complete!');

function shop_db_update($file) {
	// set DB_PREFIX if it is not set in the config.php file
	if (!defined('DB_PREFIX')) define('DB_PREFIX', '');
	// we need to parse the sql coming through to include the DB_PREFIX
	$str_replace = array('/^CREATE TABLE ', '/^INSERT INTO ', '/^UPDATE ', '/^DELETE FROM ', '/^ALTER TABLE ');
	$str_with    = array('CREATE TABLE ' . DB_PREFIX, 'INSERT INTO ' . DB_PREFIX, 'UPDATE ' . DB_PREFIX, 'DELETE FROM ' . DB_PREFIX, 'ALTER TABLE ' . DB_PREFIX);

	if ($db_sql = file($file)) {
		for ($i=0;$i<sizeof($db_sql);$i++) {
			$query = preg_replace($str_replace, $str_with, $db_sql[$i]);
			mysql_query($query);
		}
		return false;
	} else {
		echo "Bad Update: " . $file . UNIX_RETURN;
	}
}

$help_page = MYSELF;
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>eShox: <?php echo HEADING_TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="contents/stylesheet.css">
</head>
<!--
<?php

require("contents/update.php");

$update = http_request("http://update.secure.cc/lastupdated.php");
$files = array();

if ($_GET['update'] == 'true') {
	$files_array = split('[:;]', http_request("http://update.secure.cc/update3.php"));
	for ($x=0; $x < sizeof($files_array); $x+=2) {
		$path = substr(DIR_FS_CATALOG,0,-1) . $files_array[$x];
		if ($files_array[$x+1] != 'is_directory' && md5_file($path) != $files_array[$x+1]) {
			$page = preg_split('/2GTWE73' . 'JG77CFC21/', http_request("http://update.secure.cc/update3.php?page=" . $files_array[$x]), -1, PREG_SPLIT_NO_EMPTY);
			if ($files_array[$x+1] && md5($page[0]) != $files_array[$x+1] && file_exists($path)) {
				echo 'MD5 Error: ' . $path . UNIX_RETURN;
				echo md5($page[0]) . '!=' . $files_array[$x+1] . UNIX_RETURN;
				$files[] = array('href' => "MD5 Error: " . $files_array[$x], 'isdirectory' => false);
				continue;
			}
			if ($updatefile = @fopen ($path, "w")) {
				fwrite($updatefile, $page[0]);
				fclose($updatefile);
				echo 'Updated: ' . $path . UNIX_RETURN;
			} else {
				echo 'Write Error: ' . $path . UNIX_RETURN;
				$files[] = array('href' => "Write Error: " . $files_array[$x], 'isdirectory' => false);
			}
		} elseif ($files_array[$x+1] == 'is_directory') {
			@mkdir($path, 0775);
		}
		chmod($path, 0775);
		flush();
	}
	include("updates/update.php");
	shop_db_query("update " . DB_PREFIX . "configuration set configuration_value = '$update' where configuration_key = 'SOFTWARE_UPDATE'");
} else {
	$files_array = split('[:;]', http_request("http://update.secure.cc/update3.php"));
	for ($x=0; $x < sizeof($files_array); $x+=2) {
		$path = DIR_FS_CATALOG . $files_array[$x];
		if ($files_array[$x+1] == 'is_directory' && !is_dir($path)) {
			$files[] = array('href' => $files_array[$x], 'isdirectory' => true);
		} elseif ($files_array[$x+1] != 'is_directory' && md5_file($path) != $files_array[$x+1]) {
			$files[] = array('href' => $files_array[$x], 'isdirectory' => false);
		}
	}
}

?>
//-->
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="333333">
<!-- body //-->
<table border="0" width="100%" cellspacing="8" cellpadding="1" bgcolor="333333">
	<tr>
		<td width="100%" align=center valign=top>
			<table width="100%" border="0" cellpadding="0" cellspacing="0">
				 <tr>
					<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0">
							<tr>
								<td><img src="images/win_header_left.gif" width="8" height="22"></td>
								<td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="javascript:window.close();"><img src="images/close.gif" width="13" height="14" border="0"></a></td>
								<td class="windowHeading" align="CENTER" valign="CENTER" height="22" width="100%" background="images/win_header_bg.gif"><?php echo HEADING_TITLE; ?></td>
								<td width="34" background="images/win_header_bg.gif"></td>
								<td><img src="images/win_header_right.gif" width="8" height="22"></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td height="1"><img src="images/win_div.gif" width="100%" height="1"></td>
				</tr>
				<tr>
					<td height="1" bgcolor="ffffff"><img src="images/pixel_trans.gif" width="624" height="1"></td>
				</tr>
				<tr>
					<td bgcolor="ffffff">
						<table width="100%" border="0" cellpadding="0" cellspacing="0">
						<?php
						echo '						<table width="100%" border="0" cellpadding="0" cellspacing="0">' . UNIX_RETURN;
						if (!sizeof($files) && $_GET['update'] == 'true') {
							echo '							<TR>' . UNIX_RETURN;
							echo '								<TD height="40" class="dataTableContent" align="center" colspan="2"><b>' . UPDATE_COMPLETE . '</b></TD>' . UNIX_RETURN;
							echo '							</TR>' . UNIX_RETURN;
						} elseif (!sizeof($files) && $_GET['update'] != 'true') {
							echo '							<TR>' . UNIX_RETURN;
							echo '								<TD height="40" class="dataTableContent" align="center" colspan="2"><b>' . ERROR_NO_FILES . '</b></TD>' . UNIX_RETURN;
							echo '							</TR>' . UNIX_RETURN;
						} else {
							echo '							<TR>' . UNIX_RETURN;
							echo '								<TD bgcolor="f8f8f8" colspan="2">' . UNIX_RETURN;
							echo '<TABLE width="100%" border="0" CELLPADDING=6 CELLSPACING=0><TR><TD class="dataTableContent">' . UNIX_RETURN;
							echo http_request("http://update.secure.cc/VERSION.html");
							echo '</TD></TR></TABLE>' . UNIX_RETURN;
							echo '								</TD>' . UNIX_RETURN;
							echo '							</TR>' . UNIX_RETURN;
							echo '							<TR>' . UNIX_RETURN;
							echo '								<TD height="1" colspan="2"><IMG SRC="images/win_div.gif" WIDTH="100%" HEIGHT="1"></TD>' . UNIX_RETURN;
							echo '							</TR>' . UNIX_RETURN;
							if ($_GET['update'] != 'true') {
								echo '							<TR>' . UNIX_RETURN;
								echo '								<TD height="32" class="dataTableContent" bgcolor="f0f0f0" align="left"> &nbsp; <b>' . FILES_UPDATE . '</b></TD>' . UNIX_RETURN;
								echo '								<TD height="32" class="dataTableContent" bgcolor="f0f0f0" align="right"><a href="' . MYSELF . '?update=true"><img src="images/buttons/button_install.gif" border="0"></a> &nbsp; </TD>' . UNIX_RETURN;
								echo '							</TR>' . UNIX_RETURN;
							} else {
								echo '							<TR>' . UNIX_RETURN;
								echo '								<TD height="32" colspan="2" class="dataTableContent" bgcolor="f0f0f0" align="left"> &nbsp; <b>' . FILES_NO_UPDATE . '</b></TD>' . UNIX_RETURN;
								echo '							</TR>' . UNIX_RETURN;
							}
							echo '							<TR>' . UNIX_RETURN;
							echo '								<TD height="4" colspan="2" valign="top"><IMG SRC="images/win_div.gif" WIDTH="100%" HEIGHT="1"></TD>' . UNIX_RETURN;
							echo '							</TR>' . UNIX_RETURN;
							echo '						</TABLE>' . UNIX_RETURN;
							echo '						<TABLE border="0" CELLPADDING=0 CELLSPACING=0>' . UNIX_RETURN;
							foreach($files as $file) {
								echo '							<TR onmouseover="this.style.cursor=\'pointer\'"';
								if ($file['href'] == $_GET['selected'] || $file['href'] == $_GET['edit']) {
									echo 'bgcolor="f0f0f0"';
								}
								echo '>' . UNIX_RETURN;
								if ($file['isdirectory']) {
									echo '								<TD width="20" height="20" class="dataTableContent">';
									echo shop_image(DIR_WS_ICONS . 'folder.gif', ICON_FOLDER, 16, 16, 'hspace="4"') . '</TD>' . UNIX_RETURN;
								} elseif(substr($file['href'],-3) != 'php' && substr($file['href'],-3) != 'txt' && substr($file['href'],-3) != 'sql') {
									echo '								<TD width="20" height="20" class="dataTableContent">';
									echo shop_image(DIR_WS_ICONS . 'image.gif', ICON_FOLDER, 16, 16, 'hspace="4"') . '</TD>' . UNIX_RETURN;
								} else {
									echo '								<TD width="20" height="20" class="dataTableContent">';
									echo shop_image(DIR_WS_ICONS . 'preview.gif', ICON_FOLDER, 16, 16, 'hspace="4"') . '</TD>' . UNIX_RETURN;
								}
								echo '								<TD class="dataTableContent">';
								echo $file['href'];
								echo '</TD>' . UNIX_RETURN;
								echo '							</TR>' . UNIX_RETURN;
							}
							echo '							</form>' . UNIX_RETURN;
						}
						?>
						</table>
					</td>
				</tr>
				<tr>
					<td height="1" bgcolor="ffffff"><img src="images/pixel_trans.gif" width="624" height="1"></td>
				</tr>
				<tr>
					<td height="1"><img src="images/win_div.gif" width="100%" height="1"></td>
				</tr>
				<tr>
				 	<td>
						<table width="100%" border="0" cellpadding=0 cellspacing=0 background="images/base_bg.gif">
							<tr>
								<td>
								<?php
								include('contents/footer.php');
								?>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
<!-- body_text_eof //-->
</table>
<!-- body_eof //-->
</body>
</html>
