<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

$db_sessions = & new db_sessions('sessID');

class db_sessions {

	function db_sessions($db_session_name = 'sessID') {
		
		ini_set('session.gc_probability', 1);
		ini_set('session.gc_divisor', 250);
		ini_set('session.save_handler', 'user');
		ini_set('session.use_cookies', 0);
		ini_set('session.use_only_cookies', 0);
		
		if (@$_COOKIE[$db_session_name]) $id = $_COOKIE[$db_session_name];
		if (@$_POST[$db_session_name]) $id = $_POST[$db_session_name];
		if (@$_GET[$db_session_name]) $id = $_GET[$db_session_name]; 
		if (strlen($id) > 32) $id = substr($id, 0, 32);
		if (strlen($id) < 32) $id = strtoupper(md5(time()));

		unset($_COOKIE[$db_session_name], $_POST[$db_session_name], $_GET[$db_session_name]);
		
		shop_session_name($db_session_name);
		shop_session_id($id, $db_session_name);

		session_set_save_handler(array(& $this, 'db_sessions_open'), array(& $this, 'db_sessions_close'), 
								 array(& $this, 'db_sessions_read'), array(& $this, 'db_sessions_write'), 
								 array(& $this, 'db_sessions_destroy'), array(& $this, 'db_sessions_gc')); 

		session_start();
	}
	
	function db_sessions_open($path, $name) {
		return true;
	}
	
	function db_sessions_close() {
		return true;
	}

	function db_sessions_read($db_session_id = DB_SESSION_ID) {
		$db_session_query_raw = @mysql_query("SELECT session_id, session_data FROM " . DB_PREFIX . "sessions WHERE session_id = \"$db_session_id\"", $GLOBALS['db_link']);
		if (@mysql_num_rows($db_session_query_raw) >= 1) {
			$db_session_query = @mysql_fetch_assoc($db_session_query_raw);
			return $db_session_query["session_data"];
		}
		mysql_query("INSERT INTO " . DB_PREFIX . "sessions (session_id, session_active, session_created) VALUES ('$db_session_id', UNIX_TIMESTAMP(NOW()), UNIX_TIMESTAMP(NOW()))", $GLOBALS['db_link']);
		return '';
	} 

	function db_sessions_write($db_session_id = DB_SESSION_ID, $data) { 
		if (DEBUGGING == 'true') echo '<pre><h2>Session Data</h2>' . $data . '</pre>';
		return mysql_query("UPDATE " . DB_PREFIX . "sessions SET session_counter=session_counter+1, session_active=UNIX_TIMESTAMP(NOW()), session_data=\"" . addslashes($data) . "\" WHERE session_id=\"$db_session_id\"", $GLOBALS['db_link']); 
	} 

	function db_sessions_destroy($db_session_id = DB_SESSION_ID) { 
		$_SESSION = array();
		return mysql_query("DELETE FROM " . DB_PREFIX . "sessions WHERE session_id=\"$db_session_id\"", $GLOBALS['db_link']);
	} 

	function db_sessions_gc($maxlifetime = 2592000) { 
		mysql_query("DELETE FROM " . DB_PREFIX . "sessions WHERE session_data =\"\" or session_active < (UNIX_TIMESTAMP(now())-$maxlifetime)", $GLOBALS['db_link']);
		return mysql_query("OPTIMIZE TABLE sessions", $GLOBALS['db_link']); 
	}
} 

	
function shop_session_id($id = false, $shop_session_name = DB_SESSION_NAME) {
	if ($id || !defined('DB_SESSION_ID')) {
		session_id($id);
		define('DB_SESSION_ID', $id);
		define('SESSION_SID', $shop_session_name . '=' . $id);
		if (!@$_COOKIE[$shop_session_name]) define('SID', $shop_session_name . '=' . $id);
		header("Set-Cookie: $shop_session_name=$id; expires=" . date("D, d-M-Y H:i:s", strtotime("+3 months")) . " GMT;");
		@$_COOKIE[$shop_session_name] = $id;
	}
	return DB_SESSION_ID;
}
	
function shop_session_name($name = false) {
	if ($name || !defined('DB_SESSION_NAME')) {
		session_name($name);
		define('DB_SESSION_NAME', $name);
	}
	return DB_SESSION_NAME;
}

function session_restore_cart($customers_id) {
	$db_session_query = shop_db_query("SELECT session_id, session_data FROM " . DB_PREFIX . "sessions WHERE customers_id = '$customers_id'");
	if (shop_db_num_rows($db_session_query)) {
		$db_session = shop_db_fetch_array($db_session_query);
		$current_session = $_SESSION['cart']->contents;
		$_SESSION = array();
		session_decode($db_session["session_data"]);
		foreach ($current_session as $key=>$value) $_SESSION['cart']->contents[$key] = $value;
		shop_db_query("delete from " . DB_PREFIX . "sessions where session_id = '" . DB_SESSION_ID . "'");
		shop_db_query("update " . DB_PREFIX . "sessions set session_id = '" . DB_SESSION_ID . "' where customers_id='$customers_id'");
	}
	else {
		shop_db_query("update " . DB_PREFIX . "sessions set customers_id = '$customers_id' where session_id='" . DB_SESSION_ID . "'");
	}
}

function session_save_cart($customers_id) {
	shop_db_query("update " . DB_PREFIX . "sessions set session_id = '', customers_id = '$customers_id' where session_id='" . DB_SESSION_ID . "'");
}
