<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

function shop_prepare_country_zones_pull_down($country_id = '') {
  $zones = shop_get_country_zones($country_id, array('id' => '-1', 'text' => PULL_DOWN_DEFAULT));
  
  if (sizeof($zones) < 2) {
	$zones = array(array('id' => '-1', 'text' => TYPE_BELOW));
  }
  return $zones;
}

function shop_get_country_zones($country_id, $default = false) {
  $zones_array = array();
  if ($default) $zones_array[] = $default;
  $zones_query = shop_db_query("select zone_id as id, zone_name as text from " . DB_PREFIX . "zones where zone_country_id = '$country_id' order by zone_name");
  while ($zones = shop_db_fetch_array($zones_query)) $zones_array[] = $zones;
  return $zones_array;
}

function shop_get_countries_list() {
  $countries_array = array();
  $countries_query = shop_db_query("select countries_id as id, countries_name as text from " . DB_PREFIX . "countries order by countries_name");
  while ($countries = shop_db_fetch_array($countries_query)) $countries_array[] = $countries;
  return $countries_array;
}

function shop_js_zone_list() {
  $countries_query = shop_db_query("select distinct zone_country_id from " . DB_PREFIX . "zones order by zone_country_id");
  $num_country = 1;
  $output_string .=      "			theState.options[0] = new Option('" . PULL_DOWN_DEFAULT . "', -1);\n";
  $output_string =         "		if (SelectedCountry == -1) {\n			return false;\n";
  while ($countries = shop_db_fetch_array($countries_query)) {
	$output_string .=      "		} else if (SelectedCountry == " . $countries['zone_country_id'] . ") {\n";

	$states_query = shop_db_query("select zone_name, zone_id from " . DB_PREFIX . "zones where zone_country_id = '" . $countries['zone_country_id'] . "' order by zone_name");

	$num_state = 1;
	while ($states = shop_db_fetch_array($states_query)) {
	  $output_string .=    "			theState.options[$num_state] = new Option('" . $states['zone_name'] . "', " . $states['zone_id'] . ");\n";
	  $num_state++;
	}
	$num_country++;
  }
  $output_string .=        "		} else {\n			theState.options[0] = new Option('" . TYPE_BELOW . "', -1);\n		}\n";

  return $output_string;
}

if (MYSELF != 'account.php') {
  echo '<SCRIPT LANGUAGE="JavaScript"><!--' . UNIX_RETURN;
  include('contents/eshox_os/scripts.php');
  echo '//--></SCRIPT>' . UNIX_RETURN;
}
?>

<table border="0" width="100%" cellspacing="0" cellpadding="0">
  <tr>
	<td height="17" colspan="3" valign="center" background="templates/<?php echo MODULE_SKIN_SELECTED; ?>/images/column_bg.gif" class="column"> &nbsp; <?php echo CATEGORY_PERSONAL; ?></td>
  </tr>
  <tr>
	<td class="body" width="50%" valign="top">
	  <table border="0" width="100%" cellspacing="8" cellpadding="0">
	    <tr>
	      <td class="body"><?php echo ENTRY_EMAIL_ADDRESS; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['customers_email_address'] : shop_draw_input_field('email_address', $account['customers_email_address'])); if (@$entry_email_address_error) echo '&nbsp;' . ENTRY_EMAIL_ADDRESS_ERROR; if (@$entry_email_address_exists) echo '<br />&nbsp;' . ENTRY_EMAIL_ADDRESS_ERROR_EXISTS; ?></td>
	    </tr>
	    <tr>
	      <td class="body"><?php echo ENTRY_PASSWORD; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? '&bull;&bull;&bull;&bull;&bull;' : shop_draw_password_field('password')); if (@$entry_password_error) echo '&nbsp;' . ENTRY_PASSWORD_ERROR; ?></td>
	    </tr>
	    <?php if (!$is_read_only) { ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_PASSWORD_CONFIRMATION; ?></td>
	      <td class="body"><?php echo shop_draw_password_field('confirmation'); ?></td>
	    </tr>
	    <?php } ?>
	  </table>
	</td>
	<td width="1" valign="top" background="images/pixel_black.gif"><img src="images/pixel_trans.gif" width="1" height="100%"></td>
	<td class="body" width="50%" valign="top">
	  <table border="0" width="100%" cellspacing="8" cellpadding="0"><?php
	      if (!$is_read_only) {
	    ?>
	    <tr>
	      <td class="body" colspan="2"><?php
	      echo shop_draw_checkbox_field('email_address_flag', 1, ((@$_POST['email_address_flag']) ? $_POST['email_address_flag'] : $account['customers_email_address_flag'])) . ENTRY_ADDRESS_FLAG;
	      ?></td>
	    </tr><?php
	      }
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_TELEPHONE_NUMBER; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['customers_telephone'] : shop_draw_input_field('phone', ((@$_POST['phone']) ? $_POST['phone'] : $account['customers_telephone']))); if (@$entry_telephone_error) echo '&nbsp;' . ENTRY_TELEPHONE_NUMBER_ERROR; ?></td>
	    </tr>
	    <?php
	    if (!$is_read_only || $account['customers_fax']) {
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_FAX_NUMBER; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['customers_fax'] : shop_draw_input_field('fax', ((@$_POST['fax']) ? $_POST['fax'] : $account['customers_fax']))); ?></td>
	    </tr>
	    <?php
	    }
	    
	    if (DISPLAY_EU_VAT == 'true' && (!$is_read_only || $account['customers_resale_number'])) {
	    ?>
	    <tr>
	      <td class="body">EU VAT Number:</td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['customers_resale_number'] : shop_draw_input_field('resale_number', ((@$_POST['resale_number']) ? $_POST['resale_number'] : $account['customers_resale_number']))); if (@$entry_vat_error) echo '&nbsp;Invalid VAT Number'; ?></td>
	    </tr>
	    <?php
	    }
	    ?>
	  </table>
	</td>
  </tr>
</table>
<img src="images/pixel_trans.gif" width="1" height="4">
<table border="0" width="100%" cellspacing="0" cellpadding="0">
  <tr>
	<td height="17" valign="center" background="templates/<?php echo MODULE_SKIN_SELECTED; ?>/images/column_bg.gif" width="50%" class="column"> &nbsp; <?php echo CATEGORY_BILL_ADDRESS; ?></td>
	<td height="17" valign="center" width="1"><img src="images/pixel_trans.gif" width="1" height="17"></td>
	<td height="17" valign="center" background="templates/<?php echo MODULE_SKIN_SELECTED; ?>/images/column_bg.gif" width="50%" class="column"> &nbsp; <?php echo CATEGORY_SHIP_ADDRESS; ?></td>
  </tr>
  <tr>
	<td class="body" width="50%">
	  <table border="0" width="100%" cellspacing="8" cellpadding="0">
	    <tr>
	      <td class="body"><?php echo ENTRY_FIRST_NAME; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['entry_firstname'] : shop_draw_input_field('firstname[0]', ((@$_POST['firstname'][0]) ? $_POST['firstname'][0] : $account['entry_firstname']), 'maxlength="64" id="firstname0"')); if (@$entry_firstname_error) echo '&nbsp;' . ENTRY_FIRST_NAME_ERROR; ?></td>
	    </tr>
	    <tr>
	      <td class="body"><?php echo ENTRY_LAST_NAME; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['entry_lastname'] : shop_draw_input_field('lastname[0]', ((@$_POST['lastname'][0]) ? $_POST['lastname'][0] : $account['entry_lastname']), 'maxlength="64" id="lastname0"')); if (@$entry_lastname_error) echo '&nbsp;' . ENTRY_LAST_NAME_ERROR; ?></td>
	    </tr>
	    <?php
	    if (!$is_read_only || $account['entry_company']) {
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_COMPANY; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['entry_company'] : shop_draw_input_field('company[0]', ((@$_POST['company'][0]) ? $_POST['company'][0] : $account['entry_company']), 'maxlength="32" id="company0"')); if (@$entry_company_error) echo '&nbsp;' . ENTRY_COMPANY_ERROR; ?></td>
	    </tr>
	    <?php
	    }
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_STREET_ADDRESS; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['entry_street_address'] : shop_draw_input_field('street_address[0]', ((@$_POST['street_address'][0]) ? $_POST['street_address'][0] : $account['entry_street_address']), 'maxlength="64" id="street_address0"')); if (@$entry_street_address_error) echo '&nbsp;' . ENTRY_STREET_ADDRESS_ERROR; ?>
	    </tr>
	    <tr>
	      <td class="body"></td>
	      <td class="body"><?php
	      if (!$is_read_only || $account['entry_street_address_2']) echo (($is_read_only) ? $account['entry_street_address_2'] : shop_draw_input_field('street_address_2[0]', ((@$_POST['street_address_2'][0]) ? $_POST['street_address_2'][0] : $account['entry_street_address_2']), 'maxlength="64" id="street_address_20"')); ?></td>
	    </tr>
	    <tr>
	      <td class="body"><?php echo ENTRY_CITY; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['entry_city'] : shop_draw_input_field('city[0]', ((@$_POST['city'][0]) ? $_POST['city'][0] : $account['entry_city']), 'maxlength="32" id="city0"')); if (@$entry_city_error) echo '&nbsp;' . ENTRY_CITY_ERROR; ?></td>
	    </tr>
	    <?php
	    if (!$is_read_only || $account['entry_postcode']) {
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_POST_CODE; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account['entry_postcode'] : shop_draw_input_field('zip[0]', ((@$_POST['zip'][0]) ? $_POST['zip'][0] : $account['entry_postcode']), 'onchange="postcode_change(this.value, 0);" maxlength="10" id="postcode0"')); if (@$entry_post_code_error) echo '&nbsp;' . ENTRY_POST_CODE_ERROR; ?></td>
	    </tr>
	    <?php
	    }
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_STATE; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? (($account['entry_state']) ? $account['entry_state'] : shop_get_zone_name($account['entry_country_id'], $account['entry_zone_id'])) : shop_draw_pull_down_menu('zone_id[0]', shop_prepare_country_zones_pull_down(((@$_POST['country'][0]) ? $_POST['country'][0] : $account['entry_country_id'])), ((@$_POST['zone_id'][0]) ? $_POST['zone_id'][0] : $account['entry_zone_id']), 'onChange="setStateText(0);" id="state0"' . (($account['entry_zone_id']) ? '' : ' disabled="disabled"')));
	      if (!$is_read_only) echo '<br />' . shop_draw_input_field('state[0]', (($account['entry_zone_id']) ? JS_STATE_SELECT : $account['entry_state']), 'maxlength="32" id="statename0"' . (($account['entry_zone_id']) ? ' disabled="disabled"' : ''));
	      ?></td>
	    </tr>
	    <tr>
	      <td class="body"><?php echo ENTRY_COUNTRY; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? shop_get_country_name($account['entry_country_id']) : shop_draw_pull_down_menu('country[0]', shop_get_countries_list(), ((@$_POST['country'][0]) ? $_POST['country'][0] : $account['entry_country_id']), 'onChange="update_zone(0);" id="country0"')); ?></td>
	    </tr>
	  </table>
	</td>
	<td width="1" valign="top" background="images/pixel_black.gif"><img src="images/pixel_trans.gif" width="1" height="100%"></td>
	<td class="body" width="50%">
	  <table border="0" width="100%" cellspacing="8" cellpadding="0">
	    <?php
	    if (!$is_read_only) {
	    ?>
	    <tr>
	      <td class="body" colspan="2"><input onclick="javascript:copyAddress();" type="checkbox" name="copy" value="1"> <?php echo ENTRY_SAME_BILLING; ?></td>
	    </tr>
	    <?php
	    }
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_FIRST_NAME; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account2['entry_firstname'] : shop_draw_input_field('firstname[1]', ((@$_POST['firstname'][1]) ? $_POST['firstname'][1] : $account2['entry_firstname']), 'maxlength="64" id="firstname1"')); if (@$entry_firstname_error) echo '&nbsp;' . ENTRY_FIRST_NAME_ERROR; ?></td>
	    </tr>
	    <tr>
	      <td class="body"><?php echo ENTRY_LAST_NAME; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account2['entry_lastname'] : shop_draw_input_field('lastname[1]', ((@$_POST['lastname'][1]) ? $_POST['lastname'][1] : $account2['entry_lastname']), 'maxlength="64" id="lastname1"')); if (@$entry_lastname_error) echo '&nbsp;' . ENTRY_LAST_NAME_ERROR; ?></td>
	    </tr>
	    <?php
	    if (!$is_read_only || $account2['entry_company']) {
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_COMPANY; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account2['entry_company'] : shop_draw_input_field('company[1]', ((@$_POST['company'][1]) ? $_POST['company'][1] : $account2['entry_company']), 'maxlength="32" id="company1"')); if (@$entry_company_error) echo '&nbsp;' . ENTRY_COMPANY_ERROR; ?></td>
	    </tr>
	    <?php
	    }
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_STREET_ADDRESS; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account2['entry_street_address'] : shop_draw_input_field('street_address[1]', ((@$_POST['street_address'][1]) ? $_POST['street_address'][1] : $account2['entry_street_address']), 'maxlength="64" id="street_address1"')); if (@$entry_street_address_error) echo '&nbsp;' . ENTRY_STREET_ADDRESS_ERROR; ?></td>
	    </tr>
	    <tr>
	      <td class="body"></td>
	      <td class="body"><?php
	      if (!$is_read_only || $account2['entry_street_address_2']) echo (($is_read_only) ? $account2['entry_street_address_2'] : shop_draw_input_field('street_address_2[1]', ((@$_POST['street_address_2'][1]) ? $_POST['street_address_2'][1] : $account2['entry_street_address_2']), 'maxlength="64" id="street_address_21"')); ?></td>
	    </tr>
	    <tr>
	      <td class="body"><?php echo ENTRY_CITY; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account2['entry_city'] : shop_draw_input_field('city[1]', ((@$_POST['city'][1]) ? $_POST['city'][1] : $account2['entry_city']), 'maxlength="32" id="city1"')); if (@$entry_city_error) echo '&nbsp;' . ENTRY_CITY_ERROR; ?></td>
	    </tr>
	    <?php
	    if (!$is_read_only || $account2['entry_postcode']) {
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_POST_CODE; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? $account2['entry_postcode'] : shop_draw_input_field('zip[1]', ((@$_POST['zip'][1]) ? $_POST['zip'][1] : $account2['entry_postcode']), 'onchange="postcode_change(this.value, 1);" maxlength="10" id="postcode1"')); if (@$entry_post_code_error) echo '&nbsp;' . ENTRY_POST_CODE_ERROR; ?></td>
	    </tr>
	    <?php
	    }
	    ?>
	    <tr>
	      <td class="body"><?php echo ENTRY_STATE; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? (($account2['entry_state']) ? $account2['entry_state'] : shop_get_zone_name($account2['entry_country_id'], $account2['entry_zone_id'])) : shop_draw_pull_down_menu('zone_id[1]', shop_prepare_country_zones_pull_down(((@$_POST['country'][1]) ? $_POST['country'][1] : $account2['entry_country_id'])), ((@$_POST['zone_id'][1]) ? $_POST['zone_id'][1] : $account2['entry_zone_id']), 'onChange="setStateText(1);" id="state1"' . (($account2['entry_zone_id']) ? '' : ' disabled="disabled"')));
	      if (!$is_read_only) echo '<br />' . shop_draw_input_field('state[1]', (($account2['entry_zone_id']) ? JS_STATE_SELECT : $account2['entry_state']), 'maxlength="32" id="statename1"' . (($account2['entry_zone_id']) ? ' disabled="disabled"' : ''));
	      ?></td>
	    </tr>
	    <tr>
	      <td class="body"><?php echo ENTRY_COUNTRY; ?></td>
	      <td class="body"><?php
	      echo (($is_read_only) ? shop_get_country_name($account2['entry_country_id']) : shop_draw_pull_down_menu('country[1]', shop_get_countries_list(), ((@$_POST['country'][1]) ? $_POST['country'][1] : $account2['entry_country_id']), 'onChange="update_zone(1);" id="country1"')); ?></td>
	    </tr>
	  </table>
	</td>
  </tr>
<?php
  if ($is_read_only) {
?>
  <tr>
	<td colspan="3">
	  <table border="0" width="100%" cellspacing="0" cellpadding="2">
	    <tr>
	      <td align="center"><?php echo '<a href="' . shop_href_link('account_history.php', '', 'SSL') . '">' . shop_image_button('button_history.gif', IMAGE_BUTTON_HISTORY) . '</a>'; ?></td>
	      <td align="center"><?php echo '<a href="' . shop_href_link('account_edit.php', '', 'SSL') . '">' . shop_image_button('button_edit_account.gif', IMAGE_BUTTON_EDIT_ACCOUNT) . '</a>'; ?></td>
	    </tr>
	  </table>
	</td>
  </tr>
  <?php
  } else {
  ?>
  <tr>
	<td colspan="3">
	  <table border="0" width="100%" cellspacing="0" cellpadding="2">
	    <tr>
	      <td> &nbsp; <?php if ($_SESSION['customer_id']) echo '<a href="' . shop_href_link('account.php', '', 'SSL') . '">' . shop_image_button('button_back.gif', IMAGE_BUTTON_BACK) . '</a>'; ?></td>
	      <td align="right"><?php echo shop_image_submit('button_continue.gif', IMAGE_BUTTON_CONTINUE); ?> &nbsp; </td>
	    </tr>
	  </table>
	</td>
  </tr>
  </form>
  <?php
  }
  ?>
</table>
