<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

define('HEADING_TITLE', 'Compare Months');
define('TABLE_HEADING_DATE', 'Days');
define('GRAPHTYPE', 'linegraph');

$headers = array(0 => array('align' => 'left', 'text' => TABLE_HEADING_DATE, 'bg' => 'column'),
				 1 => array('align' => 'center', 'text' => date('F', UBEFORE1_LAST_MONTH), 'bg' => 'col_selected'),
				 2 => array('align' => 'center', 'text' => date('F', ULAST_MONTH), 'bg' => 'column'),
				 3 => array('align' => 'center', 'text' => date('F', UNOW_MONTH), 'bg' => 'col_selected'));
				
$columns = array(0 => array('align' => 'left', 'text' => 'name'),
				 1 => array('align' => 'right', 'text' => 'total1', 'function' => '$currencies->format('),
				 2 => array('align' => 'right', 'text' => 'total2', 'function' => '$currencies->format('),
				 3 => array('align' => 'right', 'text' => 'total3', 'function' => '$currencies->format('));
				
$footers = array(0 => array('align' => 'left', 'text' => 'Total'),
				 1 => array('align' => 'right', 'text' => '0', 'function' => '$currencies->format('),
				 2 => array('align' => 'right', 'text' => '0', 'function' => '$currencies->format('),
				 3 => array('align' => 'right', 'text' => '0', 'function' => '$currencies->format('));

$from = " from " . DB_PREFIX . "orders o, " . DB_PREFIX . "orders_products op, " . DB_PREFIX . "orders_total total";
$where = " where total.class = 'ot_total' and total.orders_id = o.orders_id and op.orders_id = o.orders_id and o.orders_status != 5" . 
		 " and o.date_purchased >= '" . date(DATE_FORMAT_START, UBEFORE1_LAST_MONTH) . "'";

$total = shop_db_fetch_array(shop_db_query("select sum(total.value) as total" . $from . $where));

$select = "select round(sum(total.value / " . $total['total'] . ") * 100) as percentage," .
		  "sum(IF(o.date_purchased >= '" . date(DATE_FORMAT_START, UBEFORE1_LAST_MONTH) . "' and o.date_purchased <= '" . date(DATE_FORMAT_END, ULAST_DAY_BEFORE1_LAST_MONTH) . "',  total.value, 0)) as total1, " .
		  "sum(IF(o.date_purchased >= '" . date(DATE_FORMAT_START, ULAST_MONTH) . "' and o.date_purchased <= '" . date(DATE_FORMAT_END, ULAST_DAY_LAST_MONTH) . "',  total.value, 0)) as total2, " .
		  "sum(IF(o.date_purchased >= '" . date(DATE_FORMAT_START, UNOW_MONTH) . "', total.value, 0)) as total3," .
		  "date_format(o.date_purchased, '%D') as name, DAYOFMONTH(o.date_purchased) as short_name";

$group = " group by name";

$query = $select . $from . $where . $group;

list($stats, $nodata, $data_array) = shop_simple_date_graph($headers, $columns, $footers, $query);

$label1 = date('F Y', UBEFORE1_LAST_MONTH);
$label2 = date('F Y', ULAST_MONTH);
$label3 = date('F Y', UNOW_MONTH);

$data = $data_array[1];
$data3 = $data_array[2];
$data4 = $data_array[3];