<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/

  Copyright (c) 2004, Secure.cc, Inc.

*/
$current = SHOX_VERSION + SHOX_RELEASE;
$updates_array = array();
if ($dir = dir("contents/updates/")) {
	while ($file = $dir->read()) {
		$file_array = explode('.', $file);
		if ($file_array[0] == 'update') {
			$updates_array[$file_array[1]+$file_array[2]] = array('type' => $file_array[3], 
																  'file' => $file, 
																  'version' => $file_array[1], 
																  'revision' => $file_array[2]);
		}
	}
	$dir->close();

	foreach ($updates_array as $version => $update) {
		if ($version <= $current) continue;
		switch ($update['type']) {
			case 'sql':
				shop_db_update('contents/updates/' . $update['file']);
				$latest_version = $update['version'];
				$latest_revision = $update['revision'];
				$latest = $version;
				echo 'installed: contents/updates/' . $update['file'] . UNIX_RETURN;
				break;
			case 'php':
				include('contents/updates/' . $update['file']);
				break;
		}
		rename('contents/updates/' . $update['file'], 'contents/updates/installed.' . $update['version'] . '.' . $update['revision'] . '.' . $update['type']);
	}

	if ($latest > $current) {
		shop_db_query("update " . DB_PREFIX . "configuration set configuration_value = '$latest_version' where configuration_key = 'SHOX_VERSION'");
		shop_db_query("update " . DB_PREFIX . "configuration set configuration_value = '$latest_revision' where configuration_key = 'SHOX_RELEASE'");
	}
}
