ALTER TABLE products ADD products_free_shipping ENUM('0','1') NOT NULL AFTER products_sku;
ALTER TABLE orders_products ADD coupon_amount DECIMAL(12,3) NULL DEFAULT '0.00';
ALTER TABLE configuration CHANGE configuration_description configuration_description VARCHAR( 255 ) NULL DEFAULT NULL;
ALTER TABLE orders CHANGE shipping_method shipping_method VARCHAR(64) NULL DEFAULT NULL;
ALTER TABLE products ADD products_turnoff_sold ENUM('0','1') NOT NULL AFTER products_call_for_price;
CREATE TABLE orders_coupons (orders_coupons_id int(11) unsigned NOT NULL auto_increment, coupons_id mediumint(9) NOT NULL, orders_id mediumint(8) unsigned NOT NULL, coupons_code varchar(32) default '0', coupon_type smallint(6) default '1', amount varchar(11) default NULL, over_amount varchar(11) default NULL, categories_id mediumint(9) default '0', manufacturers_id mediumint(9) default '0', products_id mediumint(9) default '0', max_usage smallint(6) default NULL, coupons_date_added datetime default '0000-00-00 00:00:00', coupons_last_modified datetime default '0000-00-00 00:00:00', expires_date datetime default '0000-00-00 00:00:00', PRIMARY KEY  (orders_coupons_id), KEY orders_id (orders_id)) TYPE=MyISAM;
CREATE TABLE ups_worldship (id int(10) unsigned NOT NULL auto_increment, orders_id bigint(20) unsigned NOT NULL default '0', date_added timestamp NOT NULL default CURRENT_TIMESTAMP, tracking_number varchar(255) NOT NULL default '', status_id tinyint(3) NOT NULL default '0', void enum('0','1') NOT NULL default '0', processed enum('0','1') NOT NULL default '0', PRIMARY KEY  (id), KEY orders_id (orders_id));
INSERT INTO configuration VALUES (NULL , 'Google Base', 'GOOGLE_BASE', 'false', 'Enable Google Base RSS2.0 Data Feed. Point Google to the google_base.xml file in your shop directory. You will need to manually run the google_base.php file to populate the xml file with your product information.', '2', '10', NOW(), NOW(), NULL, 'shop_cfg_select_option(array(''true'', ''false''),');
UPDATE configuration SET sort_order = '1' WHERE configuration_key = 'DOWNLOAD_ENABLED';
UPDATE configuration SET sort_order = '2' WHERE configuration_key = 'MSHOX_STATUS';
UPDATE configuration SET sort_order = '3' WHERE configuration_key = 'SN_STATUS';
UPDATE configuration SET sort_order = '4' WHERE configuration_key = 'CONFIG_RESELLER_ACCESS';
UPDATE configuration SET sort_order = '5' WHERE configuration_key = 'COUPONS_ALLOW_ONE';
UPDATE configuration SET sort_order = '6' WHERE configuration_key = 'REALTIME_CURRENCY';
UPDATE configuration SET sort_order = '7' WHERE configuration_key = 'TEXT_EDITOR';
UPDATE configuration SET sort_order = '8' WHERE configuration_key = 'GOOGLE_ANALYTICS';
UPDATE configuration SET sort_order = '9' WHERE configuration_key = 'GOOGLE_ANALYTICS_CONVERSION';
UPDATE configuration SET sort_order = '11' WHERE configuration_key = 'YAHOO_ANALYTICS_CONVERSION';
INSERT INTO configuration VALUES(NULL, 'Search Engine Friendly URLs', 'MOD_REWRITE', 'false', 'Create search engine friendly URLs, see help on how to implement this feature', 7, 5, NOW(), NOW(), NULL, 'shop_cfg_select_option(array(''true'', ''false''),');
UPDATE configuration SET configuration_value = '11' WHERE configuration_key = 'SHOX_RELEASE';
