<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/
?>
<table width="100%" border="0" cellpadding="4" cellspacing="0">
<tr><td class="large">Search Engine Setup</td></tr>
<tr><td valign="top">
<blockquote><p align="justify">The "Listings" section of eShox can be accessed via eShox Admin. Open a Web browser and enter the following URL: http://your-domain-or-ip/shop/admin/. Click on "Search Engine Setup" under "Store Setup" on the left "Administration" window. To make changes to an option: select the option, make any necessary changes, then click "Update". </p>
<blockquote>

<p><u>Search Engine Keywords</u></p>
<p align="justify">List keywords that describe your site in order of importance. You do not need to create sentences, just keywords. We recommend limiting this tag to 20 unique keywords.</p>

<p><u>Search Engine Abstract</u></p>
<p align="justify">This tag is not very important, most major search engines ignore this tag, unless you have highly specialized content, ie. academic papers. The use of this tag will allow search engines in your field of expertise to index your site properly. We recommend limiting this tag to 10 words or less.</p>

<p><u>Search Engine Description</u></p>
<p align="justify">Describe the purpose of this website, and what items that are sold. We recommend limiting this tag to one or two sentences.</p>

<p><u>Search Engine Robot Mode</u></p>
<p align="justify">This tag is often ignored by search engines. If you need to control the search engine robots, use a robots.txt file or modify your .htaccess file instead.</p>

<p><u>Search Engine Friendly URLs</u></p>
<p align="justify">
	This creates search engine friendly URL's so that most all search engines can better spider your site.  To use this feature of eShox, and if you are using an Apache webserver with .htaccess support, you will need to copy the below code into your .htaccess file.<br /><br />
	<code>
&lt;IfModule mod_rewrite.c&gt;<br />
RewriteEngine on<br />
RewriteRule ^cat-(.*)/(.*)/(.*) index.php?cPath=$2&$3<br />
RewriteRule ^prod-(.*)/(.*)/(.*) product_info.php?products_id=$2&$3<br />
RewriteRule ^info-(.*)/(.*)/(.*) information.php?id=$2&$3<br />
&lt;/IfModule&gt;
	</code>
</p>

</tr>
</table>