<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

require('contents/resources.php');

define('HEADING_TITLE_MODULES_PAYMENT', 'Payment Options');
define('HEADING_TITLE_MODULES_SHIPPING', 'Shipping Options');
define('HEADING_TITLE_MODULES_ORDER_TOTAL', 'Checkout Options');
define('HEADING_TITLE_MODULES_THEME', 'Button Themes');
define('HEADING_TITLE_MODULES_SKIN', 'Interface Skins');

define('TABLE_HEADING_MODULES', 'Title');
define('TABLE_HEADING_SORT_ORDER', 'Sort Order');
define('TABLE_HEADING_STATUS', 'Setting');

define('TEXT_MODULE_DIRECTORY', 'Module Directory:');
  $action = $_GET['action'];
  switch ($_GET['set']) {
	case 'shipping':
	  $module_type = 'shipping';
	  $module_directory = DIR_FS_CATALOG_CONTENTS . 'shipping/';
	  $module_key = 'MODULE_SHIPPING_INSTALLED';
	  define('HEADING_TITLE', HEADING_TITLE_MODULES_SHIPPING);
	  break;
	case 'ordertotal':
	  $module_type = 'order_total';
	  $module_directory = DIR_FS_CATALOG_CONTENTS . 'order_total/';
	  define('HEADING_TITLE', HEADING_TITLE_MODULES_ORDER_TOTAL);
	  break;
	default:
	case 'payment':
	  $module_type = 'payment';
	  $module_directory = DIR_FS_CATALOG_CONTENTS . 'payment/';
	  $module_key = 'MODULE_PAYMENT_INSTALLED';
	  define('HEADING_TITLE', HEADING_TITLE_MODULES_PAYMENT);
	  break;
	case 'theme':
	  $module_type = 'theme';
	  $module_directory = DIR_FS_CATALOG_CONTENTS . 'theme/';
	  define('HEADING_TITLE', HEADING_TITLE_MODULES_THEME);
	  break;
	case 'skin':
	  $module_type = 'skin';
	  $module_directory = DIR_FS_CATALOG_CONTENTS . 'skin/';
	  define('HEADING_TITLE', HEADING_TITLE_MODULES_SKIN);
	  break;
  }

  switch ($_GET['action']) {
	case 'save':
	  while (list($key, $value) = each($_POST['configuration'])) {
	    shop_db_query("update " . DB_PREFIX . "configuration set configuration_value = '$value' where configuration_key = '$key'");
	  }
	  shop_redirect(shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $_GET['module']));
	  break;
	case 'install':
	case 'remove':
	  $file_extension = substr(PHP_SELF, strrpos(PHP_SELF, '.'));
	  $class = basename($_GET['module']);
	  if (file_exists($module_directory . $class . $file_extension)) {
	    include($module_directory . $class . $file_extension);
	    $module = new $class;
	    if ($_GET['action'] == 'install') {
	      $module->remove();
	      $module->install();
	    } elseif ($_GET['action'] == 'remove') {
	      $module->remove();
	    }
	  }
	  shop_redirect(shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $class));
	  break;
  }

?><html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>eShox: <?php echo HEADING_TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="contents/stylesheet.css">
<script language="JavaScript" src="contents/eshox_os/scripts.js" type="text/javascript"></script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="333333">
<!-- body //-->
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<?php
$help_page = MYSELF . '&set=' . $_GET['set'];
include('contents/header.php');
?>
</table>
<table border="0" width="100%" cellspacing="8" cellpadding="1" bgcolor="333333">
  <tr>
	<td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="160" cellspacing="0" cellpadding="0">
<!-- left_navigation //-->
<?php require('contents/navbar.php'); ?>
<!-- left_navigation_eof //-->
	</table></td>
<!-- body_text //-->
	<td width="100%" valign="top">
	  <table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	      <td>
	        <table width="100%" border="0" cellpadding="0" cellspacing="0">
	          <tr>
	            <td width="8"><IMG SRC="images/win_header_left.gif" width="8" height="22"></td>
	            <td width="60" align="left" valign="center" background="images/win_header_bg.gif"><a href="index.php"><IMG SRC="images/close.gif" width="13" height="14" border="0"></a></td>
	            <td class="windowHeading" background="images/win_header_bg.gif" height="22" align=center valign="center"><?php echo HEADING_TITLE; ?></td>
	            <td width="34" background="images/win_header_bg.gif"></td>
	            <td width="8"><IMG SRC="images/win_header_right.gif" width="8" height="22"></td>
	          </tr>
	        </table>
	      </td>
	    </tr>
	    <tr>
	      <td width="100%" background="images/win_header_column.gif">
	        <table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td>
	              <table border="0" width="100%" cellspacing="0" cellpadding="0">
	                <tr>
	                  <td valign="top">
	                    <table border="0" width="100%" cellspacing="0" cellpadding="0">
	                      <tr>
	                        <td height="17" width="50%" valign="center" class="dataTableContent"> &nbsp; <?php echo TABLE_HEADING_MODULES; ?></td>
	                        <td height="17" width="90" valign="center" class="dataTableContent"><?php if ($_GET['set'] == 'payment' || $_GET['set'] == 'shipping') echo "Rating"; ?></td>
	                        <td height="17" width="40"></td>
	                        <td height="17" valign="center"></td>
	                      </tr>
	                      <?php
	                      $file_extension = substr(PHP_SELF, strrpos(PHP_SELF, '.'));
	                      $directory_array = array();
	                      if ($dir = @dir($module_directory)) {
	                        while ($file = $dir->read()) {
	                          if (!is_dir($module_directory . $file)) {
	                            if (substr($file, strrpos($file, '.')) == $file_extension) {
	                              $directory_array[] = $file;
	                            }
	                          }
	                        }
	                        sort($directory_array);
	                        $dir->close();
	                      }

	                      $installed_modules = array();
	                      for ($i=0; $i<sizeof($directory_array); $i++) {
	                      $file = $directory_array[$i];

	                      include($module_directory . $file);

	                      $class = substr($file, 0, strrpos($file, '.'));
	                      if (shop_class_exists($class)) {
	                        $module = new $class;
	                        if ($module->check() > 0) {
	                          if ($module->sort_order > 0) {
	                            $installed_modules[$module->sort_order] = $file;
	                          } else {
	                            $installed_modules[] = $file;
	                          }
	                        }
	                        if ($module_key) shop_db_perform('configuration', array('configuration_value' => implode(';', $installed_modules)), 'update', "configuration_key = '$module_key'");

	                        if (((!$_GET['module']) || ($_GET['module'] == $class)) && (!$mInfo)) {
	                          $module_info = array('code' => $module->code,
	                                     'title' => $module->title,
	                                     'description' => $module->description,
	                                     'signup' => $module->signup,
	                                     'status' => $module->check(),
	                                     'version' => $module->version);
	                          
	                          if ($module_info['status']) {
	                            $configuration_query = shop_db_query("select configuration_title as title, configuration_key, configuration_value as value, use_function, set_function, configuration_description as description from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("', '", $module->keys()) . "') order by sort_order");
	                          
	                            while ($configuration = shop_db_fetch_array($configuration_query)) {
	                              if (substr($configuration['configuration_key'], -6) != 'STATUS') $module_info['keys'][$configuration['configuration_key']] = $configuration;
	                            }
	                          }

	                          $mInfo = new objectInfo($module_info);
	                        }
	                        if ( (is_object($mInfo)) && ($class == $mInfo->code) ) {
	                          echo '                          <tr class="dataTableRowSelected">' . UNIX_RETURN;
	                          $link = '';
	                        } else {
	                          echo '                          <tr class="dataTableRow" onmouseover="this.style.cursor=\'pointer\'">' . UNIX_RETURN;
	                          $link = ' onclick="document.location.href=\'' . shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $class) . '\'"';
	                        }
	                        ?>
	                        <td class="dataTableContent" height="20" <?php echo $link; ?> width="50%"> &nbsp; <?php echo $module->title; ?></td>
	                        <td class="dataTableContent" width="90"><nobr><?php if ($module->recommend_level) echo str_repeat('<img src="images/recommend.gif" width="12" height="12" border="0">',$module->recommend_level); ?></nobr></td>
	                        <td class="dataTableContent" align="right"  width="40"><?php
	                        if ($module->check() > 0) {
	                          echo shop_image(DIR_WS_IMAGES . 'icon_status_green.gif', IMAGE_ICON_STATUS_GREEN, 12, 12) . '&nbsp;&nbsp;<a href="' . shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $class . '&action=remove') . '">' . shop_image(DIR_WS_IMAGES . 'icon_status_red_light.gif', IMAGE_ICON_STATUS_RED_LIGHT, 12, 12) . '</a>';
	                        } else {
	                          echo '<a href="' . shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $class . '&action=install') . '">' . shop_image(DIR_WS_IMAGES . 'icon_status_green_light.gif', IMAGE_ICON_STATUS_GREEN_LIGHT, 12, 12) . '</a>&nbsp;&nbsp;' . shop_image(DIR_WS_IMAGES . 'icon_status_red.gif', IMAGE_ICON_STATUS_RED, 12, 12);
	                        }
	                        ?>
	                        </td>
	                        <?php
	                        echo '<td class="dataTableContent" align="right">';
	                          if ( (is_object($mInfo)) && ($class == $mInfo->code) ) {
	                            echo shop_image(DIR_WS_IMAGES . 'icon_arrow_right.gif');
	                          } else {
	                            echo '<a href="' . shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $class) . '"></a>'; }
	                          }
	                          echo '</td>';
	                          ?>
	                      </tr>
	                      <?php
	                      }
	                      
	                      ?>
	                    </table>
	                  </td>
	                  <?php
	                  $heading = array(array('text' => $mInfo->title . (($mInfo->version) ? ' v' . $mInfo->version : '')));
	                  $contents = array();
	                  switch ($action) {
	                    case 'edit':
	                      $keys = '';
	                      foreach ($mInfo->keys as $key => $value) {
	                        if (!(substr($key,-6,6) == 'STATUS')) {
	                          if ($value['set_function']) {
	                            eval('$keys .= ' . $value['set_function'] . "'" . $value['value'] . "', '$key', '" . $value['title'] . "', '" . $value['description'] . "');");
	                          } else {
	                            if ($value['title']) $keys .= '<b>' . $value['title'] . '</b><br />';
	                            if ($value['description']) $keys .= $value['description'] . '<br />';
	                            $keys .= '<p> &nbsp;  &nbsp; ' . shop_draw_input_field('configuration[' . $key . ']', $value['value']);
	                          }
	                          $numkeys++;
	                          
	                          $keys .= '<p>';
	                        }
	                      }
	                      if ($mInfo->description) $contents[] = array(array('text' => '<b>' . $mInfo->description . '</b>'));
	                      $contents[] = array('text' => shop_draw_form('modules', FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $_GET['module'] . '&action=save') . $keys);
	                      $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_update.gif', IMAGE_UPDATE) . ' <a href="' . shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $_GET['module']) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	                      break;
	                    default:
	                      if ($mInfo->status) {
	                        $keys = '';
	                        $numkeys = 0;
	                        foreach ($mInfo->keys as $keyname => $value) {
	                        if (!(substr($keyname,-6,6) == 'STATUS')) {
	                          if ($value['use_function']) {
	                            eval('$keys .= ' . $value['use_function'] . "'" . $value['value'] . "','','" . $value['title'] . "','') . '<p>';");
	                          } else {
	                            $keys .= '<B>' . $value['title'] . '</B><p> &nbsp;  &nbsp; <B>&bull;</B> ' . ucwords($value['value']) . '<p>';
	                          }
	                          $numkeys++;
	                        }
	                      }
	                      if ($numkeys > 0) {
	                        if ($mInfo->description) $contents[] = array(array('text' => '<b>' . $mInfo->description . '</b>'));
	                        $contents[] = array('text' => $keys);
	                        if ($mInfo->signup) {
	                          $contents[] = array('align' => 'center', 'text' => '<br /><a href="' . shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $_GET['module'] . '&action=edit') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a> &nbsp;<a href="' . $mInfo->signup . '" target="_new">' . shop_image_button('button_signup.gif', IMAGE_SIGNUP) . '</a>');
	                        } else {
	                          $contents[] = array('align' => 'center', 'text' => '<br /><a href="' . shop_href_link(FILENAME_MODULES, 'set=' . $_GET['set'] . '&module=' . $_GET['module'] . '&action=edit') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a>');
	                        }
	                      } else {
	                        $contents[] = array('text' => '<br />This module is enabled');
	                      }
	                    } else {
	                        $contents[] = array('text' => '<br />This module is disabled');
	                    }
	                    break;
	                  }
	                  if ($_GET['set'] == 'theme' || $_GET['set'] == 'skin') {
	                    echo '<td width="120" valign="top" align="center" class="infoBoxContent">' . UNIX_RETURN;
	                    $box = new box;
	                    echo $box->infoBox($heading, array(array('text' => $mInfo->description)));
	                  } else {
	                    echo '<td width="250" valign="top" class="infoBoxContent">' . UNIX_RETURN;
	                    $box = new box;
	                    echo $box->infoBox($heading, $contents);

	                  }
	                  echo '                      </td>' . UNIX_RETURN;
	                ?>
	                </tr>
	              </table>
	            </td>
	          </tr>
	        </table>
	      </td>
	    </tr>
	    <tr>
	      <td background="images/win_div.gif" width="8" height="1"></td>
	    </tr>
	    <tr>
	      <td height=17 background="images/base_bg.gif">
<?php
include('contents/footer.php');
?>
	      </td>
	    </tr>
	  </table>
	</td>
  </tr>
</table>
<!-- body_eof //-->

</body>
</html>
