<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

if (!@$_GET['status']) $_GET['status'] = 'all';
require('contents/resources.php');
require('contents/eshox_os/order.php');

define('HEADING_TITLE', 'Customer Orders');
define('HEADING_TITLE_SEARCH', 'Order ID:');
define('HEADING_TITLE_STATUS', 'Order Status');

define('TABLE_HEADING_COMMENTS', 'Comments');
define('TABLE_HEADING_CUSTOMERS', 'Customer');
define('TABLE_HEADING_ORDERS', 'Orders');
define('TABLE_HEADING_ORDER_TOTAL', 'Order Total');
define('TABLE_HEADING_DATE_PURCHASED', 'Date Purchased');
define('TABLE_HEADING_STATUS', 'Status');
define('TABLE_HEADING_QUANTITY', 'Qty.');
define('TABLE_HEADING_PRODUCTS_SKU', 'SKU');
define('TABLE_HEADING_PRODUCTS_MODEL', 'Model');
define('TABLE_HEADING_PRODUCTS', 'Products');
define('TABLE_HEADING_TAX', 'Tax');
define('TABLE_HEADING_TOTAL', 'Total');
define('TABLE_HEADING_STATUS', 'Status');
define('TABLE_HEADING_COST','Our Cost');
define('TABLE_HEADING_PRICE_EXCLUDING_TAX', 'Price (ex)');
define('TABLE_HEADING_PRICE_INCLUDING_TAX', 'Price (inc)');
define('TABLE_HEADING_TOTAL_EXCLUDING_TAX', 'Total (ex)');
define('TABLE_HEADING_TOTAL_INCLUDING_TAX', 'Total (inc)');
define('TABLE_HEADING_BILL_SHIP','Billing & Shipping Information');

define('TABLE_HEADING_NEW_VALUE', 'Status');
define('TABLE_HEADING_CUSTOMER_NOTIFIED', 'Customer Notified');
define('TABLE_HEADING_DATE_ADDED', 'Date');
define('TABLE_HEADING_TRACKING_NUMBER', 'Tracking Number');

define('ENTRY_CUSTOMER', 'Customer:');
define('ENTRY_SOLD_TO', 'Billing Address');
define('ENTRY_STREET_ADDRESS', 'Street Address:');
define('ENTRY_CITY', 'City:');
define('ENTRY_POST_CODE', 'Post Code:');
define('ENTRY_STATE', 'State:');
define('ENTRY_COUNTRY', 'Country:');
define('ENTRY_TELEPHONE', 'Telephone:');
define('ENTRY_EMAIL_ADDRESS', 'Email Address:');
define('ENTRY_DELIVERY_TO', 'Delivery To:');
define('ENTRY_SHIP_TO', 'Shipping Address:');
define('ENTRY_PAYMENT_METHOD', 'Payment Method:');
define('ENTRY_CREDIT_CARD_OWNER', 'Name on Card:');
define('ENTRY_CREDIT_CARD_NUMBER', 'Credit Card:');
define('ENTRY_CREDIT_CARD_SECURITY_CODE', 'Security Code:');
define('ENTRY_CREDIT_CARD_TYPE', 'Type:');
define('ENTRY_CREDIT_CARD_EXPIRES', 'Exp:');
define('ENTRY_SUB_TOTAL', 'Sub-Total:');
define('ENTRY_TAX', 'Tax:');
define('ENTRY_SHIPPING', 'Shipping:');
define('ENTRY_TOTAL', 'Total:');
define('ENTRY_DATE_PURCHASED', 'Date Purchased:');
define('ENTRY_STATUS', 'Status:');
define('ENTRY_DATE_LAST_UPDATED', 'Date Last Updated:');
define('ENTRY_NOTIFY_CUSTOMER', 'Notify Customer');
define('ENTRY_PRINTABLE', 'Print Invoice');

define('TEXT_INFO_HEADING_DELETE_ORDER', 'Delete Order');
define('TEXT_INFO_DELETE_INTRO', 'Are you sure you want to delete this order?');
define('TEXT_INFO_RESTOCK_PRODUCT_QUANTITY', 'Restock product quantity');
define('TEXT_DATE_ORDER_CREATED', 'Date Created:');
define('TEXT_DATE_ORDER_LAST_MODIFIED', 'Last Modified:');
define('TEXT_INFO_PAYMENT_METHOD', 'Payment Method:');
define('TEXT_MODIFIED', 'Last Modified by:');

define('TEXT_ALL_ORDERS', 'All Orders');
define('TEXT_ACTIVE_ORDERS', 'Active Orders');
define('TEXT_NO_ORDER_HISTORY', 'No Order History Available');

define('EMAIL_TEXT_SUBJECT', STORE_NAME . ' Order Update');
define('EMAIL_TEXT_ORDER_NUMBER', 'Order Number:');
define('EMAIL_TEXT_INVOICE_URL', 'Detailed Invoice:');
define('EMAIL_TEXT_DATE_ORDERED', 'Date Ordered:');
define('EMAIL_TEXT_STATUS_UPDATE', 'Your order has been updated to the following status:

New status: %s

Please reply to this Email if you have any questions.
');
define('EMAIL_TEXT_COMMENTS', 'Your order has been updated with the following comment:

Comment: %s

Please reply to this Email if you have any questions.
');

define('ERROR_ORDER_DOES_NOT_EXIST', 'Error: Order does not exist.');
define('SUCCESS_ORDER_UPDATED', 'Success: Order has been successfully updated.');

$currencies = new currencies();
$orders_statuses = shop_get_orders_status();

function email_order_update ($oID, $body, $info) {
	$link = shop_href_link(DIR_WS_CATALOG . FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $oID, 'SSL');
	$email = STORE_NAME . UNIX_RETURN . shop_image('images/pixel_black.gif', '', '100%', '1') . UNIX_RETURN . EMAIL_TEXT_ORDER_NUMBER . ' ' . $oID . UNIX_RETURN . EMAIL_TEXT_INVOICE_URL . ' <a href="' . $link . '">' . $link . '</a>' . UNIX_RETURN . EMAIL_TEXT_DATE_ORDERED . ' ' . shop_date_long($info['date_purchased']) . UNIX_RETURN . UNIX_RETURN . $body;
	shop_mail($info['customers_name'], $info['customers_email_address'], EMAIL_TEXT_SUBJECT, nl2br($email), STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, 'email_status.html');
}

switch ($_GET['action']) {
	case 'update_order':
	  $oID = ($_GET['oID']);
	  $status = ($_POST['status']);
	  $comments = ($_POST['comments']);
	  $tracking_number = ($_POST['tracking_number']);
	  $tracking_number_type = ($_POST['tracking_number_type']);

	  $order_updated = false;
	  $check_status_query = shop_db_query("select customers_name, customers_email_address, orders_status, date_purchased from " . DB_PREFIX . "orders where orders_id = '" . ($oID) . "'");
	  $check_status = shop_db_fetch_array($check_status_query);
	  if ($check_status['orders_status'] != $status) {
	    shop_db_query("update " . DB_PREFIX . "orders set orders_status = '" . ($status) . "', last_updater = '" . USERNAME . "', last_modified = now() where orders_id = '" . ($oID) . "'");

	    $customer_notified = '0';
	    if ($_POST['notify'] == 'on') {
	      $track = "\r\nTracking number: " . $tracking_number;
	      if ($tracking_number_type == '1') $track = UNIX_RETURN . 'DHL Tracking number: ' . $tracking_number;
	      if ($tracking_number_type == '2') $track = UNIX_RETURN . 'FedEx Tracking number: ' . $tracking_number;
	      if ($tracking_number_type == '3') $track = UNIX_RETURN . 'UPS Tracking number: ' . $tracking_number;
	      if ($tracking_number_type == '4') $track = UNIX_RETURN . 'USPS Tracking number: ' . $tracking_number;
	      $body = sprintf(EMAIL_TEXT_STATUS_UPDATE, (shop_get_orders_status($status) . $track));
	      email_order_update($oID, $body, $check_status);
	      $customer_notified = '1';
	    }

	    shop_db_query("insert into " . DB_PREFIX . "orders_status_history (orders_id, new_value, old_value, date_added, customer_notified, tracking_number, tracking_number_type) values ('" . ($oID) . "', '" . ($status) . "', '" . $check_status['orders_status'] . "', now(), '$customer_notified', '$tracking_number', '$tracking_number_type')");

	    $order_updated = true;
	  }
	  else {
			$body = sprintf(EMAIL_TEXT_COMMENTS, $comments);
			email_order_update($oID, $body, $check_status);
	  }
	  if ($comments) {
	    shop_db_query("update " . DB_PREFIX . "orders set comments = '" . ($comments) . "' where orders_id = '" . ($oID) . "'");
	    $order_updated = true;
	  }	  
	  setcookie('eshox_numorders[check]', '0');
	  shop_redirect(shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('action')) . 'action=edit'));
	  break;
	case 'process_worldship': 
	  $result = shop_db_query("select * from " . DB_PREFIX . "ups_worldship where processed != '1' order by date_added asc");
	  $shipping = array();
	  while ($row = shop_db_fetch_array($result)) {
	  	// if void and tracking info exists already, delete the tracking info
	  	if ($row['void']=='1' && isset($shipping[$row['orders_id']])) 
	  		unset($shipping[$row['orders_id']]);
	  	else $shipping[$row['orders_id']] = $row;
	  	shop_db_query("update " . DB_PREFIX . "ups_worldship set processed = '1' where id = '" . $row['id'] . "'");
	  }
	  foreach ($shipping as $oID => $info) {
	  	// we need to void out a previous tracking number
	  	if ($info['void']=='1') {
	  		// get last order status history information
				$status = shop_db_fetch_array(shop_db_query("select * from " . DB_PREFIX . "orders_status_history where orders_id = '" . $oID . "' order by date_added desc limit 1"));
				// now delete it
				shop_db_query("delete from " . DB_PREFIX . "orders_status_history where orders_id = '" . $oID . "' and new_value = '" . $status['new_value'] . "'");
				// update order to old status value
				shop_db_query("update " . DB_PREFIX . "orders set orders_status = '" . $status['old_value'] . "' where orders_id = '" . $oID . "'");
	  	}
	  	else {
	  		// find old status and update to new status	  		
				$order_info = shop_db_fetch_array(shop_db_query("select customers_name, customers_email_address, orders_status, date_purchased from " . DB_PREFIX . "orders where orders_id = '" . $oID . "'"));
				shop_db_query("update " . DB_PREFIX . "orders set orders_status = '" . $info['status_id'] . "' where orders_id = '" . $oID . "'");
				// add new status history plus tracking number into db
				$data_array = array('orders_id' => $oID,
														'new_value' => $info['status_id'],
														'old_value' => $order_info['orders_status'],
														'date_added' => $info['date_added'],
														'customer_notified' => 1,
														'tracking_number' => $info['tracking_number'],
														'tracking_number_type' => 3, // UPS
														);
				shop_db_perform('orders_status_history', $data_array);
				// Now email them with the new tracking info
				$track = UNIX_RETURN . 'UPS Tracking number: ' . $info['tracking_number'];
	      $body = sprintf(EMAIL_TEXT_STATUS_UPDATE, (shop_get_orders_status($info['status_id']) . $track));
	      email_order_update($oID, $body, $order_info);
	  	}
	  }
	  // send them back to where they were
	  shop_redirect(urldecode($_GET['goto']));
		break;
	case 'deleteconfirm':
	  if ($GLOBALS['USERPERMS'][BITS-10] == '1') {
	    $oID = ($_GET['oID']);
	    shop_remove_order($oID, $_POST['restock']);
	    shop_redirect(shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'action'))));
	  }
		break;
}

if ( ($_GET['action'] == 'edit') && ($_GET['oID']) ) {
	$oID = ($_GET['oID']);
	$orders_query = shop_db_query("select orders_id from " . DB_PREFIX . "orders where orders_id = '" . ($oID) . "'");
	$order_exists = true;
	if (!shop_db_num_rows($orders_query)) {
	  $order_exists = false;
	}
}

?><html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<?php if (!$_GET['action']) echo '<meta http-equiv="Refresh" content="60">'; ?>
<title>eShox: <?php echo HEADING_TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="contents/stylesheet.css">
<script language="JavaScript" src="contents/eshox_os/scripts.js" type="text/javascript"></script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="333333">
<!-- body //-->
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<?php
$help_page = MYSELF;
include('contents/header.php');
?>
</table>
<table border="0" width="100%" cellspacing="8" cellpadding="1" bgcolor="333333">
  <tr>
	<td width="<?php echo BOX_WIDTH; ?>" valign="top"><table border="0" width="160" cellspacing="0" cellpadding="0">
<!-- left_navigation //-->
<?php require('contents/navbar.php'); ?>
<!-- left_navigation_eof //-->
	</table></td>
<!-- body_text //-->
	<td width="100%" valign="top">
<?php
  if ( ($_GET['action'] == 'edit') && ($order_exists) ) {
	$order = new order($oID);
	if (sizeof($order->products) < 1) shop_redirect(MYSELF);
?>
	  <table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	      <td width="8"><img src="images/win_header_left.gif" width="8" height="22"></td>
	      <td width="60" align="left" valign="center" background="images/win_header_bg.gif"><a href="index.php"><img src="images/close.gif" width="13" height="14" border="0"></a></td>
	      <td class="windowHeading" background="images/win_header_bg.gif" height="22" align="center" valign="center"><?php echo 'Order #' . $oID; ?></td>
	      <td width="34" background="images/win_header_bg.gif"></td>
	      <td width="8"><img src="images/win_header_right.gif" width="8" height="22"></td>
	    </tr>
	  </table>
	  <table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	      <td width="100%" bgcolor="ffffff">
	        <table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td colspan="2">
	              <table border="0" width="100%" cellspacing="0" cellpadding="0">
	                <tr>
	                  <td height="17" valign="center" class="dataTableContent" colspan="2" background="images/win_header_column.gif"> &nbsp;<?php echo TABLE_HEADING_PRODUCTS; ?></td>
	                  <td height="17" valign="center" class="dataTableContent" background="images/win_header_column.gif"><?php echo TABLE_HEADING_PRODUCTS_MODEL . ' (' . TABLE_HEADING_PRODUCTS_SKU . ')'; ?></td>
	                  <td height="17" valign="center" class="dataTableContent" align="right" background="images/win_header_column.gif"><?php echo TABLE_HEADING_TAX; ?></td>
	                  <td height="17" valign="center" class="dataTableContent" align="right" background="images/win_header_column.gif"><?php echo TABLE_HEADING_COST; ?> &nbsp;</td>
<?php
	if (!defined('MANUFACTURER')) {
?>
	                  <td height="17" valign="center" class="dataTableContent" align="right" background="images/win_header_column.gif"><?php echo TABLE_HEADING_TOTAL; ?> &nbsp;</td>
<?php
	}
?>
	                </tr>
<?php
	foreach ($order->products as $products_id => $products_info) {
	  echo '                    <tr class="dataTableRow">' . UNIX_RETURN .
	       '                      <td class="dataTableContent" colspan="2" valign="top" width="40%" align="left"> &nbsp; <b>' . $products_info['qty'] . '&nbsp;x&nbsp;' . $products_info['name'] . '</b></td>' . UNIX_RETURN . 
	       '                      <td class="dataTableContent" valign="top">' . $products_info['model'] . (($products_info['sku']) ? ' (' . $products_info['sku'] . ')' : '') . '</td>' . UNIX_RETURN .
	       '                      <td class="dataTableContent" align="right" valign="top">' . shop_display_tax_value($products_info['tax']) . '%</td>' . UNIX_RETURN .
	       '                      <td class="dataTableContent" align="right" valign="top">' . $currencies->format($products_info['cost'] * $products_info['qty']) . ' &nbsp;</td>' . UNIX_RETURN;

	  if (!defined('MANUFACTURER')) {
	    echo '                      <td class="dataTableContent" align="right" valign="top" width="150"><b>' . $currencies->format(shop_add_tax($products_info['price'], $products_info['tax']) * $products_info['qty'], true) . '</b> &nbsp;</td>' . UNIX_RETURN;
	  }
	  echo '                    </tr>' . UNIX_RETURN;
	  
	  echo '                    <tr>' . UNIX_RETURN;
	  echo '                      <td width="36">&nbsp;</td>' . UNIX_RETURN;
	  echo '                      <td class="dataTableContent" align="left" valign="bottom" width="204">';
	  
	  if (sizeof($products_info['attributes']) > 0) {
	    foreach ($products_info['attributes'] as $attributes_id => $attributes_info) {
	      echo '<i>' . $attributes_info['option'] . ': ' . $attributes_info['value'] . '</i><br />';
	    }
	  }

	  if (sizeof($products_info['customer_options']) > 0) {
	    foreach ($products_info['customer_options'] as $customer_options_id => $customer_options_info) {
	      if ($customer_options_info['value']) {
	        $type = $customer_options_info['type'];
	        $value = $customer_options_info['value'];
	        $key = $customer_options_info['option'];
	        if ($type == '3') {
	          if (strlen($value) > 0) echo UNIX_RETURN . '<i><a href="../customer_options/' . $value . '" target="_new">' . $key. '</a></i><br />';
	        } elseif ($type == '4') {
	          if (strlen($value) > 0) echo UNIX_RETURN . '<i>' . $key . ': ' . $value . '</i><br />';
	        } elseif ($type == '7') {
	          if (strlen($value) > 0) echo UNIX_RETURN . '<i><a href="../contents/image.php?image[0]=customer_options/' . $value . '" target="_new">' . $key . '</a></i><br />';
	        } elseif ($type == '8') {
	          if (strlen($value) > 0) echo UNIX_RETURN . '<i>' . $key . ': ' . str_replace(array('.ttf','_'),array('',' '),$value) . '</i><br />';
	        } elseif ($type == '9') {
	          if (strlen($value) > 0) echo UNIX_RETURN . '<i>' . $key. ': ' . $value . 'pt</i><br />';
	        } elseif ($type == '10') {
	          if (strlen($value) > 0) echo UNIX_RETURN . '<i>' . $key. ': ' . $value . '</i><br />';
	        } else {
	          if (strlen($value) > 0) echo UNIX_RETURN . '<i>' . $key . ': ' . $value . '</i><br />';
	        }
	      }
	    }
	  }

	  if (strlen($products_info['serial_number']) > 0) echo UNIX_RETURN . '<i> Serial Number: ' . $products_info['serial_number']. '</i><br />';

	  echo '</td>' . UNIX_RETURN;
	  echo '                      <td class="dataTableContent" align="left" valign="bottom">';
	  
	  if (sizeof($products_info['attributes']) > 0) {
	    foreach ($products_info['attributes'] as $attributes_id => $attributes_info) {
	      echo ($attributes_info['option_id'] ? shop_get_product_attribute_model($products_info['id'],$attributes_info['option_id']) . '<br />' : '-');
	    }
	  }
	  
	  if (sizeof($products_info['customer_options']) > 0) {
	    foreach ($products_info['customer_options'] as $customer_options_id => $customer_options_info) {
	      echo '-';
	    }
	  }
	  
	  echo '</td>' . UNIX_RETURN;
	  if (!defined('MANUFACTURER')) {
	    echo '                      <td class="dataTableContent" colspan="3" align="right" valign="top">';
	  } else {
	    echo '                      <td class="dataTableContent" colspan="2" align="right" valign="top">';
	  }
	  
	  if (sizeof($products_info['attributes']) > 0) {
	    foreach ($products_info['attributes'] as $attributes_id => $attributes_info) {
	      if ($attributes_info['price'] != '0') {
	        echo $attributes_info['prefix'] . $currencies->format(shop_add_tax($attributes_info['price'], $products_info['tax']) * $products_info['qty'], true) . '&nbsp; <br />';
	      } else {
	        echo '-&nbsp; <br />';
	      }
	    }
	  }
	  if ($products_info['customer_options']) {
	    foreach ($products_info['customer_options'] as $option => $value) {
	      echo '-&nbsp; <br />';
	    }
	  }
	  
	  echo '</td>' . UNIX_RETURN;
	  echo '                    </tr>' . UNIX_RETURN;
	}
?>
	                <tr>
	                  <td height="8" valign="center" class="dataTableContent" colspan="4"></td>
	                </tr>
	                <tr>
	                  <td align="right" colspan="<?php echo (defined('MANUFACTURER')) ? 5 : 6; ?>">
	                    <table width="240" border="0" cellspacing="0" cellpadding="0">
<?php
if (!defined('MANUFACTURER')) {
  for ($i=0; $i<sizeof($order->totals); $i++) {
	echo '                          <tr><td colspan="2">' . shop_draw_separator('pixel_trans.gif', '100%', '3') . '</td></tr>' . UNIX_RETURN .
	     '                          <tr>' . UNIX_RETURN .
	     '                            <td align="right" class="dataTableContent">' . $order->totals[$i]['title'] . ' &nbsp; </td>' . UNIX_RETURN .
	     '                            <td align="right" class="dataTableContent" width="70">' . $GLOBALS['currencies']->format($order->totals[$i]['value'], true) . ' &nbsp; </td>' . UNIX_RETURN .
	     '                          </tr>' . UNIX_RETURN;
  }
}
?>
	                    </table>
	                  </td>
	                </tr>
	                <tr>
	                  <td height="12" valign="center" class="dataTableContent" colspan="4"></td>
	                </tr>
	              </table>
	            </td>
	          </tr>
	          <tr>
	            <td colspan="2">
	              <table width="100%" border="0" cellspacing="0" cellpadding="2">
	                <tr>
	                  <td height="17" valign="center" class="dataTableContent" colspan="4" background="images/win_header_column.gif"> &nbsp;<?php echo TABLE_HEADING_BILL_SHIP; ?></td>
	                </tr>
	                <tr>
	                  <td class="dataTableContent" valign="top"> &nbsp;<b><?php echo ENTRY_SOLD_TO; ?></b><br /><?php echo shop_address_format($order->customer['format_id'], $order->customer, 1, ' &nbsp;', '<br />'); ?></td>
	                  <td class="dataTableContent" valign="top"> &nbsp;<b><?php echo ENTRY_SHIP_TO; ?></b><br /><?php echo shop_address_format($order->delivery['format_id'], $order->delivery, 1, ' &nbsp;', '<br />'); ?></td>
	                  <td class="dataTableContent" valign="top"> &nbsp;<b><?php echo ENTRY_TELEPHONE; ?></b><br /> &nbsp;<?php echo $order->customer['telephone']; ?><p> &nbsp;<b><?php echo ENTRY_EMAIL_ADDRESS; ?></b><br /> &nbsp;<?php echo '<a onclick="popupWindow(\'customers_mail.php?customer=' . $order->customer['email_address'] . '\',\'mail_customer\');"><u>' . $order->customer['email_address'] . '</u></a>'; ?></td>
<?php
if (!defined('MANUFACTURER')) {
?>
	                  <td class="dataTableContent" valign="top"> &nbsp;<b><?php echo ENTRY_PAYMENT_METHOD; ?></b><br /><?php echo shop_payment_info($order->info, 1, ' &nbsp;', '<br />'); ?></td>
<?php
}
?>
	                </tr>
	              </table><?php echo shop_draw_separator('pixel_trans.gif', '100%', '5'); ?>
	            </td>
	          </tr>
	          <tr>
	            <td valign="top">
	              <table border="0" cellspacing="0" cellpadding="0" width="100%">
	                <tr>
	                  <td class="smallText" background="images/win_header_column.gif" height="17" align="left"> &nbsp; <?php echo HEADING_TITLE_STATUS; ?></td>
	                  <td class="smallText" background="images/win_header_column.gif" height="17" align="left"><?php echo TABLE_HEADING_DATE_ADDED; ?></td>
	                  <td class="smallText" background="images/win_header_column.gif" height="17" align="left"><?php echo TABLE_HEADING_TRACKING_NUMBER; ?></td>
	                  <td class="smallText" background="images/win_header_column.gif" height="17" align="center"><?php echo TABLE_HEADING_CUSTOMER_NOTIFIED; ?></td>
	                </tr>
<?php
	$orders_history_query = shop_db_query("select orders_status_history_id, new_value, old_value, date_added, tracking_number, tracking_number_type, customer_notified from " . DB_PREFIX . "orders_status_history where orders_id = '" . ($oID) . "' order by orders_status_history_id desc");
	if (shop_db_num_rows($orders_history_query)) {
	  while ($orders_history = shop_db_fetch_array($orders_history_query)) {
	    switch($orders_history['tracking_number_type']) {
	      case '1':
					$tntype_link = '<a href=" http://track.dhl-usa.com/TrackByNbr.asp?ShipmentNumber=' . $orders_history['tracking_number'] . '" target="_new">';
	        $tntype_link_end = '</a>';
	        break;
	      case '2':
					$tntype_link = '<a href=" http://www.fedex.com/Tracking?tracknumbers=' . $orders_history['tracking_number'] . '" target="_new">';
	        $tntype_link_end = '</a>';
	        break;
	      case '3':
	        $tntype_link = '<a href="http://wwwapps.ups.com/WebTracking/processInputRequest?TypeOfInquiryNumber=T&amp;InquiryNumber1=' . $orders_history['tracking_number'] . '" target="_new">';
	        $tntype_link_end = '</a>';
	        break;
	      case '4':
					$tntype_link = '<a href="http://trkcnfrm1.smi.usps.com/PTSInternetWeb/InterLabelInquiry.do?strOrigTrackNum=' . $orders_history['tracking_number'] . '" target="_new">';
	        $tntype_link_end = '</a>';
	        break;
	      default:
	        $tntype_link = '';
	        $tntype_link_end = '';
	        break;
	        
	    }
	    ?>
	              <tr>
	                <td colspan="4" height="4"><?php echo shop_draw_separator('pixel_trans.gif', '100%', '4'); ?></td>
	              </tr>
	    <?php
	    echo '                    <tr bgcolor="ffffff">' . UNIX_RETURN .
	         '                      <td class="smallText"> &nbsp; ' . shop_get_orders_status($orders_history['new_value']) . '</td>' . UNIX_RETURN .
	         '                      <td class="smallText" align="left">' . shop_date_short($orders_history['date_added']) . '</td>' . UNIX_RETURN .
	         '                      <td class="smallText" align="left">' . $tntype_link . $orders_history['tracking_number'] . $tntype_link_end . '</td>' . UNIX_RETURN .
	         '                      <td class="smallText" align="center">';
	    if ($orders_history['customer_notified'] == '1') {
	      echo shop_image('images/icon_status_green.gif', IMAGE_ICON_STATUS_GREEN);
	    } else {
	      echo shop_image('images/icon_status_red.gif', IMAGE_ICON_STATUS_RED);
	    }
	    echo '                    </tr>' . UNIX_RETURN;
	    ?>
	                <tr>
	              <td colspan="4" height="4"><?php echo shop_draw_separator('pixel_trans.gif', '100%', '4'); ?></td>
	            </tr>
	    <?php
	  }
	} else {
	    echo '                <tr>' . UNIX_RETURN .
	         '                  <td class="smallText" colspan="4">' . TEXT_NO_ORDER_HISTORY . '</td>' . UNIX_RETURN .
	         '                </tr>' . UNIX_RETURN;
	}
?>
	            <tr>
	              <td colspan="4" bgcolor="808080" height="1"><?php echo shop_draw_separator('pixel_trans.gif', '100%', '1'); ?></td>
	            </tr>
	            <tr>
	              <td colspan="4" height="2"><?php echo shop_draw_separator('pixel_trans.gif', '100%', '2'); ?></td>
	            </tr>
	            <tr>
	            <td colspan="4">
	              <table border="0" cellspacing="0" cellpadding="2" width="100%" class="dataTableContent">
	                <tr><?php echo shop_draw_form('status', FILENAME_ORDERS, shop_get_all_get_params(array('action')) . 'action=update_order'); ?>
	                  <td class="smalltext"> &nbsp; <?php echo ENTRY_STATUS; ?></td>
	                  <td class="smalltext"><?php echo shop_draw_pull_down_menu('status', $orders_statuses, $order->info['orders_status']); ?></td>
	                  <td class="smalltext"><?php echo TABLE_HEADING_TRACKING_NUMBER; ?>:</td>
	                  <td class="smalltext"><?php echo shop_draw_input_field('tracking_number','','size="16" maxlength="32"'); ?></td>
	                  <td class="smalltext"><?php echo shop_draw_pull_down_menu('tracking_number_type',array(array('id' => '1','text' => 'DHL'),array('id' => '2','text' => 'FedEx'),array('id' => '3','text' => 'UPS'),array('id' => '4','text' => 'USPS'),array('id' => '5','text' => 'None')),'5'); ?></td>
	                  <td class="smalltext"><?php echo shop_draw_checkbox_field('notify', '', false); ?>&nbsp;<?php echo ENTRY_NOTIFY_CUSTOMER; ?></td>
	                  <td class="smalltext" align="center"><?php echo shop_image_submit('button_update.gif', IMAGE_UPDATE); ?></td>
	                </tr></form>
	              </table>
	            </td>
	          </tr>
	        </table>
	      </td>
	      <td class="smallText" valign="top" width="25%">
	        <table border="0" cellspacing="0" cellpadding="2" width="100%">
	          <tr>
	            <td class="smallText" valign="top" background="images/win_header_column.gif" height="17"><?php echo TABLE_HEADING_COMMENTS; ?>:</td>
	          </tr>
	          <tr>
	            <td valign="top" bgcolor="e0e0e0">
	              <table border="0" cellspacing="0" cellpadding="4" width="100%">
	                <tr><?php echo shop_draw_form('status', FILENAME_ORDERS, shop_get_all_get_params(array('action')) . 'action=update_order'); ?>
	                  <td class="smallText" align="right">
<?php echo shop_draw_textarea_field('comments', $order->info['comments']) . '<br />';
echo shop_draw_separator('pixel_trans.gif', '100%', '3');
echo shop_draw_hidden_field('notify', 'on');
echo shop_draw_hidden_field('status', $order->info['orders_status']);
echo shop_image_submit('button_save.gif', IMAGE_SAVE);
?>
	                  </td>
	                </tr></form>
	              </table>
	            </td>
	          </tr>
	        </table>
	      </td></form>
	    </tr>
	  <tr>
	    <td colspan="2"><?php echo shop_draw_separator('pixel_trans.gif', '100%', '15'); ?></td>
	  </tr>
	  <tr>
	    <td colspan="2" align="right"><?php 
	    if (!defined('MANUFACTURER')) {
	      echo '<a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=invoice&oID=' . $_GET['oID']) . '" TARGET="_blank">' . shop_image_button('button_invoice.gif', IMAGE_ORDERS_INVOICE) . '</a> ';
	    }
	    echo '<a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=packingslip&oID=' . $_GET['oID']) . '" TARGET="_blank">' . shop_image_button('button_packingslip.gif', IMAGE_ORDERS_PACKINGSLIP) . '</a> ';
	    echo '<a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=contactsheet&oID=' . $_GET['oID']) . '" TARGET="_blank">' . shop_image_button('button_contactsheet.gif', IMAGE_ORDERS_CONTACTSHEET) . '</a> ';
	    echo '<a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=purchaseorder&oID=' . $_GET['oID']) . '" TARGET="_blank">' . shop_image_button('button_purchaseorder.gif', IMAGE_ORDERS_PURCHASEORDER) . '</a> ';
	    echo '<a href="' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('action'))) . '">' . shop_image_button('button_back.gif', IMAGE_BACK) . '</a> &nbsp;'; ?></td>
	  </tr>
	  <tr>
	    <td colspan="2"><?php echo shop_draw_separator('pixel_trans.gif', '100%', '4'); ?></td>
	  </tr>
<?php
  } else {
?>
	  <table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	      <td><img src="images/win_header_left.gif" width="8" height="22"></td>
	      <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="index.php"><img src="images/close.gif" width="13" height="14" border="0"></a></td>
	      <td width="6" align="left" valign="center" background="images/win_header_bg.gif"><img src="images/pixel_trans.gif" border="0" width="6" height="14"></td>
	      <td width="14" align="left" valign="center" background="images/win_header_bg.gif"><a href="<?php echo MYSELF . '?page_toggle=true'; ?>"><img src="images/max.gif" width="13" height="14" border="0"></a></td>
	      <td class="windowHeading" align="center" valign="center" height="22" width="100%" background="images/win_header_bg.gif"><?php echo HEADING_TITLE; ?></td>
	      <td width="34" background="images/win_header_bg.gif"></td>
	      <td><img src="images/win_header_right.gif" width="8" height="22"></td>
	    </tr>
	  </table>
	  <table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr>
	      <td width="100%" background="images/win_header_column.gif">
	        <table border="0" width="100%" cellspacing="0" cellpadding="0">
	          <tr>
	            <td>
	              <table border="0" width="100%" cellspacing="0" cellpadding="0">
	                <tr>
	                  <td valign="top">
	                    <table border="0" width="100%" cellspacing="0" cellpadding="2">
	                      <tr>
	                        <td height="17" valign="center" class="dataTableContent" colspan="2"> &nbsp; <?php echo TABLE_HEADING_ORDERS; ?></td>
	                        <td height="17" valign="center" class="dataTableContent"><?php echo TABLE_HEADING_CUSTOMERS; ?></td>
<?php
	if (!defined('MANUFACTURER')) {
?>
	                        <td height="17" valign="center" class="dataTableContent" align="right"><?php echo TABLE_HEADING_ORDER_TOTAL; ?></td>
<?php
	}
?>
	                        <td height="17" valign="center" class="dataTableContent" align="center"><?php echo TABLE_HEADING_DATE_PURCHASED; ?></td>
	                        <td height="17" valign="center" class="dataTableContent" align="right"><?php echo TABLE_HEADING_STATUS; ?></td>
	                        <td height="17" valign="center" class="dataTableContent" align="right">&nbsp;</td>
	                      </tr>
<?php
	$orders_query_raw = "select o.orders_id, o.customers_name, o.customers_id, o.payment_method, o.date_purchased, o.last_modified, o.last_updater, o.currency, o.currency_value, o.orders_status, ot.value as order_total from " . DB_PREFIX . "orders o left join " . DB_PREFIX . "orders_total ot on (o.orders_id = ot.orders_id) ";
	if ($_GET['cID']) {
	  $orders_query_raw .= "where o.customers_id = '" . $_GET['cID'] . "' and ot.class = 'ot_total'";
	} elseif ($_GET['customer']) {
	  $orders_query_raw .= "where o.customers_name like '%" . $_GET['customer'] . "%' and ot.class = 'ot_total'";
	} elseif ($_GET['status'] == 'all') {
	  $orders_query_raw .= "where ot.class = 'ot_total'";
	} elseif ($_GET['status'] == 'active') {
		// we need to call all statuses that are active types
		$result = shop_db_query("select status_id from " . DB_PREFIX . "orders_status_values where language_id = '" . $languages_id . "' and is_active = '1'");
		$status = array();
		while ($row = shop_db_fetch_array($result)) $status[] = $row['status_id'];
		$status_sql = @implode(" or o.orders_status = ", $status);
	  $orders_query_raw .= "where (o.orders_status = " . $status_sql . ") and ot.class = 'ot_total'";
	} elseif ($_GET['status']) {
	  $orders_query_raw .= "where o.orders_status = " . $_GET['status'] . " and ot.class = 'ot_total'";
	} else {
	  $orders_query_raw .= "where o.orders_status < 3 and ot.class = 'ot_total'";
	}
	$orders_query_raw .= " order by o.orders_id DESC";
	
	$orders_split = new splitPageResults($_GET['page'], CFG_ADMIN_ITEMS_PAGE, $orders_query_raw, $orders_query_numrows);
	$orders_query = shop_db_query($orders_query_raw);
	while ($orders = shop_db_fetch_array($orders_query)) {
	  if (defined('MANUFACTURER')) {
		$manufacturer_count_query = shop_db_query("select count(*) as count from " . DB_PREFIX . "orders_products op, " . DB_PREFIX . "products p where op.orders_id = '" . $orders['orders_id'] . "' and p.products_id = op.products_id and p.manufacturers_id = '" . MANUFACTURER . "'");
		$manufacturer_count = shop_db_fetch_array($manufacturer_count_query);
		if ($manufacturer_count['count'] < 1) {
		  $orders_query_numrows--;
		  continue;
		}
	  }

	  if (((!$_GET['oID']) || ($_GET['oID'] == $orders['orders_id'])) && (!$oInfo)) {
	    $oInfo = new objectInfo($orders);
	  }
	  if ( (is_object($oInfo)) && ($orders['orders_id'] == $oInfo->orders_id) ) {
	    echo '                          <tr class="dataTableRowSelected" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'action', 'page_toggle')) . 'oID=' . $oInfo->orders_id . '&action=edit') . '\'">' . UNIX_RETURN;
	  } else {
	    echo '                          <tr class="dataTableRow" onmouseover="this.style.cursor=\'pointer\'" onclick="document.location.href=\'' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'page_toggle')) . 'oID=' . $orders['orders_id']) . '\'">' . UNIX_RETURN;
	  }
?>
	                      <td class="dataTableContent" valign="center" align="center" width="22" height="18"><?php echo '<a href="' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'action', 'page_toggle')) . 'oID=' . $orders['orders_id'] . '&action=edit') . '"><img src="images/icons/preview.gif" align="middle" border="0" alt="Preview" title=" Preview "></a></td><td class="dataTableContent" valign="center"> Order #' . $orders['orders_id'] . '</td><td class="dataTableContent" valign="center">' . $orders['customers_name']; ?></td>
<?php
	  if (!defined('MANUFACTURER')) {
?>
	                      <td class="dataTableContent" valign="center" align="right"><?php echo $currencies->format($orders['order_total']); ?></td>
<?php
	   }
?>
	                        <td class="dataTableContent" valign="center" align="center"><?php echo shop_datetime_short($orders['date_purchased']); ?></td>
	                        <td class="dataTableContent" valign="center" align="right"><?php echo shop_get_orders_status($orders['orders_status']); ?></td>
	                        <td class="dataTableContent" valign="center" align="right"><?php if ( (is_object($oInfo)) && ($orders['orders_id'] == $oInfo->orders_id) ) { echo shop_image(DIR_WS_IMAGES . 'icon_arrow_right.gif', ''); } else { echo '<a href="' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID')) . 'oID=' . $orders['orders_id']) . '"></a>'; } ?></td>
	                      </tr>
<?php
	}
	if ($_GET['status']) {
	  $status_selection = $_GET['status'];
	} elseif ($status) {
	  $status_selection = $status;
	} else {
	  $status_selection = 'active';
	}
?>
	                      <tr>
	                        <td colspan="7">
	                          <table border="0" width="100%" cellspacing="0" cellpadding="4">
	                            <tr>
	                              <td class="smallText" valign="top"><?php echo $orders_split->display_count($orders_query_numrows, CFG_ADMIN_ITEMS_PAGE, $_GET['page'], TEXT_DISPLAY_NUMBER_OF_ORDERS); ?></td>
	                              <td class="smallText" align="right"><?php echo $orders_split->display_links($orders_query_numrows, CFG_ADMIN_ITEMS_PAGE, MAX_DISPLAY_PAGE_LINKS, $_GET['page'], 'status=' . $_GET['status'], 'page'); ?></td>
	                            </tr>
	                          </table>
	                        </td>
	                      </tr>
	                      <tr><?php echo shop_draw_form('orders', FILENAME_ORDERS, '', 'get'); ?>
	                        <td class="dataTableContent" align="right" colspan="7"><?php echo 'Customer Search: ' . shop_draw_input_field('customer', $oInfo->customers_name, 'size="12"'); ?></td>
	                      </form></tr>
	                      <tr><?php echo shop_draw_form('orders', FILENAME_ORDERS, '', 'get'); ?>
	                        <td class="dataTableContent" align="right" colspan="7"><?php     echo HEADING_TITLE_SEARCH . ' ' . shop_draw_input_field('oID', '', 'size="12"') . shop_draw_hidden_field('action', 'edit'); ?></td>
	                      </form></tr>
	                      <tr><?php echo shop_draw_form('status', FILENAME_ORDERS, '', 'get');  ?>
	                        <td class="dataTableContent" align="right" colspan="7"><?php echo HEADING_TITLE_STATUS . ' ' . shop_draw_pull_down_menu('status', array_merge(array(array('id' => 'all', 'text' => TEXT_ALL_ORDERS),array('id' => 'active', 'text' => TEXT_ACTIVE_ORDERS)), $orders_statuses), $status_selection, 'onChange="this.form.submit();"'); ?></td>
	                      </form></tr>
	                    </table>
	                  </td>
<?php
  $heading = array();
  $contents = array();
  switch ($_GET['action']) {
	case 'delete':
	  $heading[] = array('text' => TEXT_INFO_HEADING_DELETE_ORDER);

	  $contents = array('form' => shop_draw_form('orders', FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'action')) . 'oID=' . $oInfo->orders_id . '&action=deleteconfirm'));
	  $contents[] = array('text' => TEXT_INFO_DELETE_INTRO . '<br /><br /><b>' . $cInfo->customers_firstname . ' ' . $cInfo->customers_lastname);
	  $contents[] = array('text' => '<br />' . shop_draw_checkbox_field('restock') . ' ' . TEXT_INFO_RESTOCK_PRODUCT_QUANTITY);
	  $contents[] = array('align' => 'center', 'text' => '<br />' . shop_image_submit('button_delete.gif', IMAGE_DELETE) . ' <a href="' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'action')) . 'oID=' . $oInfo->orders_id) . '">' . shop_image_button('button_cancel.gif', IMAGE_CANCEL) . '</a>');
	  break;
	default:
	  if (is_object($oInfo)) {
	    $heading[] = array('text' => 'Order #' . $oInfo->orders_id);

	    $links = ' <a href="' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'action')) . 'oID=' . $oInfo->orders_id . '&action=edit') . '">' . shop_image_button('button_edit.gif', IMAGE_EDIT) . '</a>';
	    if ($GLOBALS['USERPERMS'][BITS-10] == '1') {
	      $links .= ' <a href="' . shop_href_link(FILENAME_ORDERS, shop_get_all_get_params(array('oID', 'action')) . 'oID=' . $oInfo->orders_id . '&action=delete') . '">' . shop_image_button('button_delete.gif', IMAGE_DELETE) . '</a><br />';
	      $links .= ' <a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=invoice&oID=' . $oInfo->orders_id) . '" TARGET="_blank">' . shop_image_button('button_invoice.gif', IMAGE_ORDERS_INVOICE) . '</a>';
	    }
	    $links .= ' <a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=packingslip&oID=' . $oInfo->orders_id) . '" TARGET="_blank">' . shop_image_button('button_packingslip.gif', IMAGE_ORDERS_PACKINGSLIP) . '</a><br />';
	    $links .= ' <a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=contactsheet&oID=' . $oInfo->orders_id) . '" TARGET="_blank">' . shop_image_button('button_contactsheet.gif', IMAGE_ORDERS_CONTACTSHEET) . '</a><br />';
	    $links .= ' <a href="' . shop_href_link(FILENAME_ORDERS_DISPLAY, 'page=purchaseorder&oID=' . $oInfo->orders_id) . '" TARGET="_blank">' . shop_image_button('button_purchaseorder.gif', IMAGE_ORDERS_PURCHASEORDER) . '</a>';

	    if (shop_date_short($oInfo->date_purchased)) $contents[] = array('text' => TEXT_DATE_ORDER_CREATED . ' ' . shop_date_short($oInfo->date_purchased));
	    if (shop_date_short($oInfo->last_modified)) {
	      $contents[] = array('text' => TEXT_DATE_ORDER_LAST_MODIFIED . ' ' . shop_date_short($oInfo->last_modified));
	      $contents[] = array('text' => TEXT_MODIFIED . ' ' . $oInfo->last_updater);
	    }
	    $contents[] = array('align' => 'center', 'text' => '<br />' . $links);
	  }
	  break;
  }

  if ( ($heading) && ($contents) ) {
	echo '                      <td class="infoBoxContent" width="25%" valign="top">' . UNIX_RETURN;

	$box = new box;
	echo $box->infoBox($heading, $contents);

	echo '                      </td>' . UNIX_RETURN;
  }
?>
	                </tr>
	              </table>
	            </td>
	          </tr>
<?php
  }
?>
	        </table>
	      </td>
	    </tr>
	    <tr>
	      <td background="images/win_div.gif" width="8" height="1"></td>
	    </tr>
	    <tr>
	      <td align="left" valign="center" width="100%" height="14" background="images/base_bg.gif">
<?php
include('contents/footer.php');
?>
	      </td>
	    </tr>
	  </table>
	</td>
  </tr>
</table>
<!-- body_text_eof //-->
<!-- body_eof //-->
</body>
</html>