<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

include('contents/resources.php');
include('contents/eshox_os/checkout.php');

define('NAVBAR_TITLE_1', NAVBAR_TITLE_CHECKOUT);
define('NAVBAR_TITLE_2', NAVBAR_TITLE_CONFIRMATION);
define('HEADING_TITLE', HEADING_TITLE_ORDER_CONFIRMATION);

$location = '|&nbsp;<a href="' . shop_href_link('checkout_payment.php', '', 'SSL') . '" class="column">' . NAVBAR_TITLE_1 . '</a>&nbsp;|&nbsp;' . NAVBAR_TITLE_2;

$checkout_form_action = shop_href_link('checkout_process.php', '', 'SSL');

if ($payment_modules = new payment) {
  $payment_modules->pre_confirmation_check();
}

if ($shipping_modules = new shipping) {
  $shipping_modules->confirm();
}

if (@$_POST['coupon_code']) {
  $coupon_array = shop_db_fetch_array(shop_db_query("select * from " . DB_PREFIX . "coupons where coupons_code = '" . $_POST['coupon_code'] . "' and (expires_date >= now() or expires_date = '00-00-0000 00:00:00')"));
  $customer_array = shop_db_fetch_array(shop_db_query("select * from " . DB_PREFIX . "coupons_to_customers where coupons_id = '" . $coupon_array['coupons_id'] . "' and customers_id = '" . $_SESSION['customer_id'] . "'"));
  if ($coupon_array && (($coupon_array['max_usage'] == 0) || ($coupon_array['max_usage'] > $customer_array['coupon_usage']))) {
  	// only allow one coupon per order
  	if (COUPONS_ALLOW_ONE == 'true') $_SESSION['cart']->coupons = array();
		$_SESSION['cart']->coupons[$_POST['coupon_code']] = $coupon_array;
  }
	// Refresh the cart	to reflect new or deleted coupons
	if ($update_cart == true) {
		foreach ($_SESSION['cart']->contents as $key => $product) {
			$_SESSION['cart']->update_quantity($product['products_id'], $product['qty'], $attributes, $customer_options);
		}
	}
}

if ($_POST['payment_selected']) $_SESSION['cart']->info['payment_method'] = $GLOBALS[$_POST['payment_selected']]->shop_title;
if ($_POST['comments']) $_SESSION['cart']->info['comments'] = $_POST['comments'];
if ($_POST['payment_selected']) $_SESSION['cart']->info['payment_selected'] = $_POST['payment_selected'];
if ($_POST['shipping_selected']) $_SESSION['cart']->info['shipping_method'] = $shipping_method;
if ($_POST['shipping_selected']) $_SESSION['cart']->info['shipping_cost'] = $shipping_cost;

$order = new order;

if ($order_total_modules = new order_total) {
  $order_total_modules->process();
}

if (sizeof($shipping_modules->modules) && !$_POST['shipping_selected'] && $_SESSION['cart']->show_weight() != 0) {
  shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(ERROR_NO_SHIPMENT_MODULE_SELECTED), 'SSL'));
}

if (sizeof($payment_modules->modules) && !$_POST['payment_selected']) {
  shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(ERROR_NO_PAYMENT_MODULE_SELECTED), 'SSL'));
}

shop_display_page(MYSELF, $page);
$contents_loc = strpos($page, '[wincontents]');

echo substr($page,0,$contents_loc);
include('contents/pages/' . MYSELF);
echo substr($page,$contents_loc+13);