<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

error_reporting(0);

header("Expires: Mon, 26 Nov 1962 00:00:00 GMT");
header("Last-Modified: " . gmdate("D,d M Y H:i:s") . " GMT");
header("Cache-Control: no-cache, must-revalidate");
header("Pragma: no-cache");

if (file_exists('../config.php')) include('../config.php');

if ($_SERVER['PHP_SELF']) define('PHP_SELF', $_SERVER['PHP_SELF']);
if ($_SERVER['DOCUMENT_URI']) define('PHP_SELF', $_SERVER['DOCUMENT_URI']);
define('MYSELF', basename(PHP_SELF));

$files = array();
while (list($num,$file) = each($_GET['image'])) {
  if ($_GET['prlocx'][$num] || $_GET['prlocy'][$num] || $_GET['prscale'][$num]) {
	$files[] = array('name' => realpath("../") . '/' . $file,
	                 'size' => getimagesize(realpath("../") . '/' . $file),
	                 'locx' => $_GET['prlocx'][$num],
	                 'locy' => $_GET['prlocy'][$num],
	                 'scale' => $_GET['prscale'][$num]);
  } else {
	$files[] = array('name' => realpath("../") . '/' . $file, 'size' => getimagesize(realpath("../") . '/' . $file));
  }
}

switch ($_GET['color']) {
  case 'Red':
	$red = '255'; $green = '48'; $blue = '48';
	break;
  case 'Green':
	$red = '85'; $green = '224'; $blue = '85';
	break;
  case 'Blue':
	$red = '0'; $green = '85'; $blue = '224';
	break;
  case 'Gold':
	$red = '255'; $green = '223'; $blue = '85';
	break;
  case 'Silver':
	$red = '192'; $green = '192'; $blue = '188';
	break;
  case 'White':
	$red = '255'; $green = '255'; $blue = '255';
	break;
  case 'Sky Blue':
	$red = '0'; $green = '255'; $blue = '255';
	break;
  case 'Purple':
	$red = '224'; $green = '85'; $blue = '224';
	break;
  case 'Yellow':
	$red = '255'; $green = '255'; $blue = '0';
	break;
  default:
    $colors = preg_split("//",$_GET['color'], 0, PREG_SPLIT_NO_EMPTY);
	$red = hexdec($colors[0] . $colors[1]); $green = hexdec($colors[2] . $colors[3]); $blue = hexdec($colors[4] . $colors[5]);
	break;
}

if ($_GET['sizex'] || $_GET['sizey']) {
  if ($_GET['sizex'] && !$_GET['sizey']) {
	$width = $_GET['sizex'];
	$height = $files[0]['size'][1] * ($width / $files[0]['size'][0]);
  } elseif ($_GET['sizey'] && !$_GET['sizex']) {
	$height = $_GET['sizey'];
	$width = $files[0]['size'][0] * ($height / $files[0]['size'][1]);
  } else {
	$width = $_GET['sizex'];
	$height = $_GET['sizey'];
  }
} else {
  $width = $files[0]['size'][0];
  $height = $files[0]['size'][1];
}

if (ENABLE_GD == true) {
  $small = imagecreatetruecolor($files[0]['size'][0], $files[0]['size'][1]);
  $trans = imagecolorallocatealpha($small,255,255,255,0);
  imagefill($small,1,1,$trans);
  
  $tmpdir = ini_get('session.save_path');
  while (list($num,$file) = each($files)) {
	$gd = $tmpdir . DIRECTORY_SEPARATOR . substr(md5($file['name']),0,16).'.gd2';
    if (!$image = imagecreatefromgd2($gd)) {
	  if ($file['size']['mime'] == 'image/gif') $image = imagecreatefromgif($file['name']);
	  if ($file['size']['mime'] == 'image/jpeg') $image = imagecreatefromjpeg($file['name']);
	  if ($file['size']['mime'] == 'image/png') $image = imagecreatefrompng($file['name']);
	  imagegd2($image, $gd);
	}
	$purple = imagecolorclosest($image,255,0,255);
	imagecolorset ($image, $purple,$red,$green,$blue);
	
	if (($file['locx'] && $file['locy']) && $file['scale'] != 0) {
	  $sizex = ($file['size'][0] * ($file['scale']/100));
	  $sizey = ($file['size'][1] * ($file['scale']/100));
	  imagecopyresampled($small, $image, ($file['locx']-($sizex/2)), ($file['locy']-($sizey/2)), 0, 0, $sizex, $sizey, $file['size'][0], $file['size'][1]);
	} else {
	  imagecopy($small, $image, 0, 0, 0, 0, $file['size'][0], $file['size'][1]);
	}
	
	if (($num == 3 || $num == sizeof($files)) && $_GET['uploadedimage']) {
	  while (list($num,$uploadedfile) = each($_GET['uploadedimage'])) {
	    $uploadedimagesize = getimagesize($uploadedfile);
	    $uploadedimage = imagecreatefrompng($uploadedfile);
	    $uploadedimage_locx = round($_GET['locx'][$num+1] - ($uploadedimagesize[0] / 2));
	    $uploadedimage_locxy = round($_GET['locy'][$num+1] - ($uploadedimagesize[1] / 2));
	    imagecopy($small, $uploadedimage, $uploadedimage_locx, $uploadedimage_locxy, 0, 0, $uploadedimagesize[0], $uploadedimagesize[1]);
	    ImageDestroy($uploadedimage);
	  }
	}
	ImageDestroy($image);
  }
  
  if ($_GET['text'] && function_exists('ImageTTFText')) {
	$fontcolor = ImageColorAllocate ($small, $red, $green, $blue); 
	if (!$_GET['font']) { $font = 'Trebuchet_MS.ttf'; } else { $font = $_GET['font']; }
	if (!$_GET['fontsize']) { $fontsize = 14; } else { $fontsize = $_GET['fontsize']; }
	$uri = explode(('/contents/' . MYSELF),$_SERVER['SCRIPT_FILENAME']);
	$font = $uri[0] . '/fonts/' . $font;
	while (list($num,$value) = each($_GET['text'])) {
	  $textsize = imageTTFBBox($fontsize,0,$font,addslashes($value));
	  if ($_GET['locx'][$num] > 1) {
	    $textlocx = round($_GET['locx'][$num] - (($textsize[2]-$textsize[0])/2));
	  } else {
	    $textlocx = round(($files[0]['size'][0]/2) - (($textsize[2]-$textsize[0])/2));
	  }
	  if ($_GET['locy'][$num] > 1) {
	    $textlocy = round($_GET['locy'][$num] - (($textsize[6]-$textsize[1])/2));
	  } else {
	    $textlocy = round(($files[0]['size'][1]/2) - (($textsize[6]-$textsize[1])/2));
	  }
	  ImageTTFText($small, $fontsize, 0, $textlocx, $textlocy, $fontcolor, $font, addslashes($value));
	}
  }
  
  header("Content-Type: image/png");

  $finalimage = imagecreatetruecolor($width, $height);
  $trans = imagecolorallocatealpha($finalimage,255,255,255,0);
  imagefill($finalimage,1,1,$trans);
  
  imagecopyresampled($finalimage, $small, 0, 0, 0, 0, $width, $height, $files[0]['size'][0], $files[0]['size'][1]);
  imagealphablending($finalimage,false);
  imagesavealpha($finalimage,true);

  imagepng($finalimage);
  
  ImageDestroy($finalimage);
  ImageDestroy($small);
} else {
  header("Content-Type: " . $files[0]['size']['mime']);
  readfile($files[0]['name']);
}
