<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  class purchaseorder {
	var $code, $title, $description, $enabled;

	function purchaseorder() {
	  $this->code = 'purchaseorder';
	  $this->title = 'Purchase Order';
	  $this->shop_title = 'Purchase Order';
	  $this->description = '';
	  $this->enabled = defined('MODULE_PAYMENT_PURCHASEORDER_STATUS');
	  $this->version = "1.0b";
	}

	function javascript_validation() {
	  $validation_string = 'if (payment_value == "' . $this->code . '") {' . UNIX_RETURN .
	                       '  var po_number = document.payment.po_number.value;' . UNIX_RETURN .
	                       '  if (po_number == "" || po_number.length < 2) {' . UNIX_RETURN .
	                       '    error_message = error_message + "* Purchase Order Number is required";' . UNIX_RETURN .
	                       '    error = 1;' . UNIX_RETURN .
	                       '  }' . UNIX_RETURN .
	                       '}' . UNIX_RETURN;
	  return $validation_string;
	}

	function selection() {
	  return '<blockquote><table border="0" cellspacing="0" cellpadding="5">' . UNIX_RETURN .
	         '  <tr>' . UNIX_RETURN .
	         '    <td class="body">&nbsp;Purchase Order Number:<br />' . shop_draw_input_field('po_number', '', 'size="12"') . '&nbsp; </td>' . UNIX_RETURN . 
	         '  </tr>' . UNIX_RETURN .
	         '</table></blockquote>' . UNIX_RETURN;
	}

	function pre_confirmation_check() {
	  return false;
	}

	function confirmation() {
	  return false;
	}

	function process_button() {
	  return shop_draw_hidden_field('po_number', $_POST['po_number']);
	}

	function before_process() {
	  global $order;
	  if (!$_POST['po_number']) {
	    shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode("Purchase Order number is required"), 'SSL'));
	  }
	  $order->info['po_number'] = $_POST['po_number'];
	  return true;
	}

	function after_process() {
	  return false;
	}

	function check() {
	  return defined('MODULE_PAYMENT_PURCHASEORDER_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_PURCHASEORDER_STATUS', 'true')");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key = 'MODULE_PAYMENT_PURCHASEORDER_STATUS'");
	}

	function keys() {
	  $keys = array('MODULE_PAYMENT_PURCHASEORDER_STATUS');

	  return $keys;
	}
  }