<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

class flat {
	var $code, $title, $description, $icon, $enabled, $quote;

	function flat() {
		$this->code = 'flat';
		$this->title = MODULE_SHIPPING_FLAT_TEXT_TITLE;
		$this->description = 'Flat Rate Shipping Options:';
		$this->icon = 'images/shipping/shipping.gif';
		$this->enabled = defined('MODULE_SHIPPING_FLAT_STATUS');
		$this->quote = array();
	}

	function quote() {
		$total = MODULE_SHIPPING_FLAT_COST + (MODULE_SHIPPING_FLAT_COST * (SHIPPING_MARK/100));
		$total = (SHIPPING_HANDLING_TOTAL + $total);
		$this->quote[] = array('Method' => MODULE_SHIPPING_FLAT_TEXT_WAY, 'Service' => MODULE_SHIPPING_FLAT_NAME, 'TotalCharges' => $total);
		return $total;
	}

	function check() {
	  return defined('MODULE_SHIPPING_FLAT_STATUS');
	}

	function install() {
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_SHIPPING_FLAT_STATUS', 'true')");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Name of flat shipping option', 'MODULE_SHIPPING_FLAT_NAME', 'Flat Rate Shipping', 'The name of the flat shipping option:', '6', '1', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('Flat Cost', 'MODULE_SHIPPING_FLAT_COST', '5.00', 'What is the Shipping cost? The Handling fee will also be added.', '6', '2', 'shop_cfg_price_display(', now())");
	}

	function remove() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_SHIPPING_FLAT_%'");
	}

	function keys() {
		return array('MODULE_SHIPPING_FLAT_STATUS', 'MODULE_SHIPPING_FLAT_NAME', 'MODULE_SHIPPING_FLAT_COST');
	}
}